SystemOrganization addCategory: #'Tweak-Tools-ColorTool'!
SystemOrganization addCategory: #'Tweak-Tools-TextTool'!
SystemOrganization addCategory: #'Tweak-Tools-DocEditor'!
SystemOrganization addCategory: #'Tweak-Tools-PrefTool'!
SystemOrganization addCategory: #'Tweak-Tools-TextChunk'!
SystemOrganization addCategory: #'Tweak-Tools-PartsBin'!
SystemOrganization addCategory: #'Tweak-Tools-Trash'!

CPanel subclass: #CColorTool
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Tools-ColorTool'!

!CColorTool commentStamp: 'tk 3/10/2005 11:04' prior: 0!
The Color Tool is a window that lets the user change the look of an object.  It works on the last object that had a halo.  It has two color pickers, one for the inside color, and one for the border color.  If offers many other controls, such as border style and border width.  
	Get a halo on an object by right-click, or Command-click.  Click the purple eye-dropper handle on the right to get a Color Tool window.

### Allow Users to see the above explanation ###!

CColorTool defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="flagsPage" toSet="flagsPage:" changeEvent="flagsPageChanged">flagsPage</field>
	<field toGet="fillPage" toSet="fillPage:" changeEvent="fillPageChanged">fillPage</field>
	<field toGet="borderPage" toSet="borderPage:" changeEvent="borderPageChanged">borderPage</field>
	<field toGet="target" toSet="target:" changeEvent="targetChanged">target</field>
	<field toGet="halo" toSet="halo:" changeEvent="haloChanged">halo</field>
</fields>'!

!CColorTool class methodsFor: 'class initialization' stamp: 'ar 1/22/2005 22:46'!
initialize
	"self initialize"
	self registerOpenCommand.
! !

!CColorTool class methodsFor: 'class initialization' stamp: 'ar 1/22/2005 22:45'!
registerOpenCommand
	"self initialize"
	Smalltalk at: #CProjectBuilder ifPresent:[:pb|
		pb registerOpenCommand: { 'Color Tool' . { self . #open }. 'A Color Tool' }.
	].! !

!CColorTool methodsFor: 'accessing' stamp: 'ar 3/16/2004 22:26'!
borderPage
	"Answer the borderPage of the receiver"
	<bewareOf: #borderPageChanged>
	^self propertyValueAt: #borderPage! !

!CColorTool methodsFor: 'accessing' stamp: 'ar 3/16/2004 22:26'!
borderPage: aValue
	"Modify the receiver's borderPage"
	^self propertyValueAt: #borderPage put: aValue with: #borderPageChanged! !

!CColorTool methodsFor: 'accessing' stamp: 'ar 3/16/2004 22:26'!
fillPage
	"Answer the fillPage of the receiver"
	<bewareOf: #fillPageChanged>
	^self propertyValueAt: #fillPage! !

!CColorTool methodsFor: 'accessing' stamp: 'ar 3/16/2004 22:26'!
fillPage: aValue
	"Modify the receiver's fillPage"
	^self propertyValueAt: #fillPage put: aValue with: #fillPageChanged! !

!CColorTool methodsFor: 'accessing' stamp: 'ar 3/16/2004 22:26'!
flagsPage
	"Answer the flagsPage of the receiver"
	<bewareOf: #flagsPageChanged>
	^self propertyValueAt: #flagsPage! !

!CColorTool methodsFor: 'accessing' stamp: 'ar 3/16/2004 22:26'!
flagsPage: aValue
	"Modify the receiver's flagsPage"
	^self propertyValueAt: #flagsPage put: aValue with: #flagsPageChanged! !

!CColorTool methodsFor: 'accessing' stamp: 'ar 5/22/2005 18:53'!
halo
	"Answer the halo of the receiver"
	<bewareOf: #haloChanged>
	^self propertyValueAt: #halo! !

!CColorTool methodsFor: 'accessing' stamp: 'ar 5/22/2005 18:53'!
halo: aValue
	"Modify the receiver's halo"
	^self propertyValueAt: #halo put: aValue with: #haloChanged! !

!CColorTool methodsFor: 'initialize' stamp: 'tak 6/15/2005 15:24'!
initialize
	super initialize.
	halo := self project halo.
	self define: #flagsPage as: CColorToolFlagsPage new.
	self define: #fillPage as: CColorToolFillPage new.
	self define: #borderPage as: CColorToolBorderPage new.
! !

!CColorTool methodsFor: 'events' stamp: 'ar 5/22/2005 18:53'!
onHaloChanged
	"Broadcast target changes to my pages"
	<on: haloChanged>
	self onHaloTargetChanged.! !

!CColorTool methodsFor: 'events' stamp: 'ar 5/22/2005 18:53'!
onHaloTargetChanged
	"Broadcast target changes to my pages"
	<on: targetChanged in: halo>
	target := halo target.
! !

!CColorTool methodsFor: 'events' stamp: 'ar 2/7/2005 00:54'!
onNameChanged
	<on: nameChanged in: target>
	costume label: target name.! !

!CColorTool methodsFor: 'events' stamp: 'ar 5/22/2005 18:54'!
onTargetChanged
	"Broadcast target changes to my pages"
	<on: targetChanged>
	target ifNil:[^self].
	flagsPage target: target.
	fillPage target: target.
	borderPage target: target.
	self onNameChanged.
! !

!CColorTool methodsFor: 'initialize' stamp: 'ar 6/24/2005 21:06'!
setupCostume

	super setupCostume.

	self extent: 284@270.
	self hResizing: #rigid; vResizing: #rigid.

	flagsPage extent: 280@50.
	self add: flagsPage.

	fillPage topLeft: 0@50.
	fillPage extent: 140@190.
	self add: fillPage.

	borderPage topLeft: 140@50.
	borderPage extent: 140@190.
	self add: borderPage.

	self decorate: costume elements color: self defaultWindowColor.! !

!CColorTool methodsFor: 'accessing' stamp: 'ar 3/16/2004 22:39'!
target
	"Answer the target of the receiver"
	<bewareOf: #targetChanged>
	^self propertyValueAt: #target! !

!CColorTool methodsFor: 'accessing' stamp: 'ar 3/16/2004 22:39'!
target: aValue
	"Modify the receiver's target"
	^self propertyValueAt: #target put: aValue with: #targetChanged! !

CPanel subclass: #CPartsBin
	instanceVariableNames: ''
	classVariableNames: 'AllCategoryNames AllPartDescriptions'
	poolDictionaries: ''
	category: 'Tweak-Tools-PartsBin'!

!CPartsBin commentStamp: 'tk 2/28/2005 14:00' prior: 0!
A Parts Bin is the main way to get a new object in Tweak.  Choose a category, and then drag an object out into the world.  Balloons tell what each kind of object does.  Get a Parts Bin from the Tools menu in the menu bar.[general]


### Allow Users to see the above explanation ###
Scott says:  A simple parts bin in Tweak -- my first little bit of Tweak coding.  Basically I started with Andreas's CPreferencesTool and slowly munged and morphed it into a parts bin tool.!

CPartsBin defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="categories" toSet="categories:" changeEvent="categoriesChanged">categories</field>
	<field toGet="contents" toSet="contents:" changeEvent="contentsChanged">contents</field>
	<field toGet="searchPane" toSet="searchPane:" changeEvent="searchPaneChanged">searchPane</field>
	<field toGet="searchLabel" toSet="searchLabel:" changeEvent="searchLabelChanged">searchLabel</field>
	<field toGet="searchField" toSet="searchField:" changeEvent="searchFieldChanged">searchField</field>
	<field toGet="searchButton" toSet="searchButton:" changeEvent="searchButtonChanged">searchButton</field>
	<field toGet="iconsPane" toSet="iconsPane:" changeEvent="iconsPaneChanged">iconsPane</field>
</fields>'!

!CPartsBin class methodsFor: 'categories' stamp: 'sw 2/1/2005 00:39'!
absorbAllCategoriesMentionedInPartDescriptions
	"Like de selector say"

	| allCats |
	allCats := self allCategoryNames asOrderedCollection.
	allCats add: CPartsBin nameForSearchResultsCategory.
	allCats add: CPartsBin nameForAdditionsCategory.
	self allPartDescriptions do: [:descr | allCats addAll: descr categories].
	AllCategoryNames := allCats asSet asSortedArray asOrderedCollection.


"
CPartsBin absorbAllCategoriesMentionedInPartDescriptions
"

! !

!CPartsBin class methodsFor: 'categories' stamp: 'sw 2/8/2005 01:19'!
addCategoryNamed: aName
	"Add a new category.  Resort the list, and update extant instances."

	AllCategoryNames := AllCategoryNames copyWith: aName.
	self alphabetizeCategoryNames.
	self allInstancesDo:
		[:p | p onCategoriesChanged]! !

!CPartsBin class methodsFor: 'standard default parts bin' stamp: 'sw 2/6/2005 03:14'!
addDescriptionsFor: aCategoryName from: tuples
	"Convenience method to create and register part-descriptions from a list of triplets of the form <rcvr> <label> <balloon-help msg>.  Tuples whose first elements are not in the Smalltalk dictionary are ignored."

	| aPartDescription |
	tuples do:
		[:aTuple |
			(Smalltalk includesKey: aTuple first) ifTrue:
				[aPartDescription := CPartDescription partDescriptionWithLabel: aTuple second balloonHelp: aTuple third category: aCategoryName creator: aTuple first selector: #newbornPartToDropIn: customForm: nil.
				self registerPartDescription: aPartDescription]]! !

!CPartsBin class methodsFor: 'standard default parts bin' stamp: 'ar 10/9/2005 23:03'!
addDescriptionsForBasic
	"Add part descriptions for basic category"

	self addDescriptionsFor: #basic from: #(
		(CPlayfield			'Playfield' 		'A playfield')
		(CEllipsePlayer		'Ellipse' 		'An ellipse or circle')
		(CRectanglePlayer 	'Rectangle'		'A rectangle')
		(CPolygonPlayer		'Polygon'		'A figure of connected line segments')
		(CRoundRectPlayer 	'RoundRect'		'A rectangle with rounded corners')
		(CTextLabel			'Text'			'A raw piece of text')
	)! !

!CPartsBin class methodsFor: 'standard default parts bin' stamp: 'sw 2/8/2005 02:43'!
addDescriptionsForButtons
	"Add part descriptions for the buttons category"

	self addDescriptionsFor: 'buttons' from: #(
		(CPushButton		'PushButton'		'A PushButton is just like any other Button, except that it uses a system-default costume.  It is shaded from top to bottom, going from white to dark yellow.  Pressing a button causes it to "fire".  You can decide which event will fire the button , such as mouseUp or mouseDown.  You can define a script that will tell the button what to do when it fires.')
		(CRadioButton		'RadioButton' 		'A RadioButton finds the other RadioButtons in the same container.  When any one is pressed, it turns the others off.  The one that is pressed stays on and highlighted.')
		(CImageButton		'ImageButton'	'An ImageButton is a simple button which takes two to four images to display depending on its state.')
		(CCheckBox			'CheckBox'		'A CheckBox is a simple button that toggles its value between true and false.  It shows a check mark when its value is true.  Adding a label is easy')
		(CTabButton			'TabButton'		'A TabButton is a horizontal row of buttons that look like tabs.  It is used for tabbed palettes (e.g., a TabButtonList).'))! !

!CPartsBin class methodsFor: 'standard default parts bin' stamp: 'ar 6/23/2005 16:57'!
addDescriptionsForDemo
	"Add part descriptions for miscellaneous category"

	self addDescriptionsFor: #demo from: #(
		(CFlasher				'Flasher'			'A flashing object')
		(CColorListDemo			'ColorHolder'		'A holder for colors')
	)

! !

!CPartsBin class methodsFor: 'standard default parts bin' stamp: 'ar 10/8/2005 12:50'!
addDescriptionsForLists
	"Add part descriptions for the lists category"

	self addDescriptionsFor: 'lists' from: #(
		(CList			'List' 			'A List is the basic way to show a list of choices.  It carries its own list of items which (contrary to its elements) can be shared with another object.  This allows a list to automatically provide a view of an arbitrary collection.  
A List can have an itemMaker to specify how the items will be shown.  By default a CListItem is used which merely uses the #displayText representation of the object.  A different itemMaker could display the items as images.')
		(CDropDownList	'DropDownList' 	'A DropDownList presents the user with an input field and a drop down list.  When the user selects an item, the list''s selection and its value will change to the selected item.  If the list is editable, then the user can type into the input field.  Upon accepting the input, the list will add in the new accepted value.')
		(CPopUpList	'PopUpList' 	'A PopUpList presents the user with a menu to choose an item from a list of values. When the user selects an item, the list''s selection and its value will change to the selected item.')
		(CSpinnerList	'SpinnerList'	'A Spinner is an object with up and down buttons.  A SpinnerList shows the currently selected item from a hidden list of choices.  The arrow buttons move the selection up or down the list to a new item.  The SpinnerList''s cursor changes accordingly.')
		(CStringList		'StringList'		'A StringList shows all of its elements in a list.  Each shows what it returns from the message #displayText, usually its name.'))! !

!CPartsBin class methodsFor: 'standard default parts bin' stamp: 'tak 5/9/2005 16:25'!
addDescriptionsForMiscellaneous
	"Add part descriptions for miscellaneous category"

	self addDescriptionsFor: #miscellaneous from: #(
		(CEToyHolder		'Holder'			'A container for other objects')
		(CTrashCan			'TrashCan'		'A place for discarding things')
		(CStopStepGoControls 'Script Controls'	'Controls for the scripts in this project')).

	CStickyPad registerWithPartsBin.  "on account of custom form"
	CMagnifier registerWithPartsBin.

! !

!CPartsBin class methodsFor: 'standard default parts bin' stamp: 'sw 2/8/2005 02:36'!
addDescriptionsForScrolling
	"Add part descriptions for the sliders category"

	self addDescriptionsFor: 'scrolling' from: #(
		(CSlider			'Slider' 			'A Slider is a bar with a marker in it.  The marker''s position indicates a value that is somewhere between two extreme values.  A ScrollBar is a kind of Slider.')
		(CScrollBar		'ScrollBar' 		'A ScrollBar is the slider you see at the edge of a window.  It lets you move the contents of a pane inside the pane.')
		(CScrollPane		'ScrollPane'		'A ScrollPane is an area with contents and two scroll bars.')
		(CSpinnerButtons	'SpinnerButtons'		'SpinnerButtons are the up and down arrows on a Spinner.  Look in the ColorTool at the Fill Alpha: control to see a Spinner with SpinnerButtons.')
		(CSpinner		'Spinner'		'A Spinner is a display with up and down arrows to change its value.  Look in the ColorTool at the Fill Alpha: control to see a Spinner.')
		(CWheelWidget	'Wheel Widget'	'What is this class used for, anyway?  --Ted.'))! !

!CPartsBin class methodsFor: 'standard default parts bin' stamp: 'sw 2/8/2005 02:45'!
addDescriptionsForText
	"Add descriptions for the text category"

	self addDescriptionsFor: 'text' from: #(
		(CLabel				'Label'			'A Label shows one line of characters.  It is often added as an element to another object.  You cannot edit the text of a label by clicking in it.')
		(CSimpleTextEditor	'Text Editor'		'A simple text editor.')
		(CInputField			'Input Field'		'An InputField is a one line text editor.  The enter key and the return key make it accept and remember its text.  This text is stored in its value field.  It can carry a TextConverter to convert forth and back between its value (any object) and the text it displays.'))
! !

!CPartsBin class methodsFor: 'standard default parts bin' stamp: 'sw 4/30/2005 21:57'!
addDescriptionsForTools
	"Add descriptions for the tools category"

	self addDescriptionsFor: 'tools' from: #(
		(CPainter				'Painter	'				'A tool for drawing and painting objects')
		(CPartsBin				'Parts Bin'				'A repository from which you can drag out new objects')
		(CTextTool				'Text Tool'				'A tool for editing text')
		(CTranscriptView		'Transcript'				'A window that can display messages to the user')
		(CWorkspace				'Workspace'				'A textual window which remembers values of variables you assign to within it.')
		(CPreferencesTool		'Preferences'			'A tool for setting many different options that govern how things work in the system.')
		(CColorTool				'Color Tool'				'A tool for changing color and border characteristics of any object')
		(CClassBrowser			'Class Browser'			'A tool for viewing and editing code')
		(CChangeSorter			'Change Sorter'			'A tool for viewing and manipulating change-sets')
		(CTrashTool				'Trash'					'A tool for viewing and reclaiming discarded items')
		(CAnnotationsBrowser	'Annotations'			'A tool for viewing method annotations'))
! !

!CPartsBin class methodsFor: 'standard default parts bin' stamp: 'sw 2/8/2005 02:20'!
addDescriptionsForWindows
	"Add part descriptions for the windows category"

	self addDescriptionsFor: 'windows' from: #(
		(CWindow			'Window'		'A resizable window with title bar.')
		(CUserDialog			'UserDialog'		'A textual interaction with the user')
		(CFileOpenDialog	 	'FileOpenDialog'	'A tool that allows the user to choose a file')
		(CFileSaveDialog		'FileSaveDialog'	'A tool that allows the user to choose where to save a file on disk'))
! !

!CPartsBin class methodsFor: 'queries' stamp: 'sw 1/31/2005 22:22'!
allCategoryNames
	"Answer the master list of all known category names.  Some may have no items associated with them at the moment"

	^ AllCategoryNames ifNil:
		[AllCategoryNames := OrderedCollection with: self nameForSearchResultsCategory with: self nameForAdditionsCategory.
		^ AllCategoryNames]! !

!CPartsBin class methodsFor: 'queries' stamp: 'sw 1/25/2005 17:32'!
allPartDescriptions
	"Answer the dictionary holding all parts descriptions"

	^  AllPartDescriptions ifNil: [AllPartDescriptions := Dictionary new]! !

!CPartsBin class methodsFor: 'queries' stamp: 'sw 2/6/2005 03:04'!
allPopulatableCategoryNames
	"Answer the master list of all known category names that could be chosen as destination categories.  Some may have no items associated with them at the moment"

	^ self allCategoryNames copyWithout: self nameForSearchResultsCategory! !

!CPartsBin class methodsFor: 'categories' stamp: 'sw 2/8/2005 01:17'!
alphabetizeCategoryNames
	"NB case-blind sort"
.
	AllCategoryNames := (AllCategoryNames asSet
		asSortedCollection: [:a :b | a asLowercase < b asLowercase]) asOrderedCollection! !

!CPartsBin class methodsFor: 'standard default parts bin' stamp: 'sw 2/8/2005 14:32'!
assureLibraryInitialized
	"If the class vars holding the parts-bin-library info are not fully set up, do it now..."

	AllPartDescriptions isEmptyOrNil ifTrue: [self rebuildPartsLibrary]! !

!CPartsBin class methodsFor: 'categories' stamp: 'sw 2/8/2005 01:18'!
changeCategoryNamed: existing to: newName
	"Change the category currently known as existing to be the new one.  I've got some doubts about this."

	| |
	self allPartDescriptions do:
		[:d | d categoryNamed: existing changedTo: newName].
	AllCategoryNames remove: existing; add: newName.
	self alphabetizeCategoryNames.
	self signal: #allCategoriesChanged.
	self signal: #needToShowCategory with: newName! !

!CPartsBin class methodsFor: 'categories' stamp: 'sw 2/6/2005 02:23'!
declassifyPartsAndDeleteCategory: categoryName
	"Remove the category of the given name; if any objects were only filed in that category, reassign them to the unclassified category"

	| itsCategories  |
	self allPartDescriptions do:
		[:aDescription | ((itsCategories := aDescription categories) includes: categoryName)
			ifTrue:
				[itsCategories size > 1
					ifTrue: "Not the expected case in current single-category implementation"
						[itsCategories remove: categoryName]
					ifFalse:
						[aDescription categories: (Array with: self nameForAdditionsCategory)]]].
	AllCategoryNames remove: categoryName.
	self signal: #allCategoriesChanged! !

!CPartsBin class methodsFor: 'registry' stamp: 'sw 2/8/2005 03:18'!
haveInstancesShowUnclassified
	"See to it that any instances of mine open on the screen get pointed to the Unclassified category"

	self signal: #needToShowCategory with: self nameForAdditionsCategory! !

!CPartsBin class methodsFor: 'categories' stamp: 'sw 2/1/2005 00:52'!
immutableCategoryNames
	"Answer the immutable category names that the user cannot edit or delete"

	^ {self nameForAdditionsCategory. self nameForSearchResultsCategory}! !

!CPartsBin class methodsFor: 'class initialization' stamp: 'sw 1/25/2005 00:39'!
initialize
	"Initialize the receiver"

	self registerOpenCommand! !

!CPartsBin class methodsFor: 'categories' stamp: 'sw 2/1/2005 02:07'!
initializeCategories
	"Initialize the category list"

	AllCategoryNames := OrderedCollection with: self nameForSearchResultsCategory with: self nameForAdditionsCategory.
	self absorbAllCategoriesMentionedInPartDescriptions


"
CPartsBin initializeCategories.
CPartsBin rebuildPartsLibrary.
AllCategoryNames
"! !

!CPartsBin class methodsFor: 'registry' stamp: 'sw 2/7/2005 03:34'!
installNewbornInstanceForms
	"Launch examples of all items in the parts bin, thus obtaining useful newbornInstanceForms for all of them."

	self allPartDescriptions do:
		[:aPartDescription |
			aPartDescription rebuildNewbornInstanceForm]
"
CPartsBin installNewbornInstanceForms
"! !

!CPartsBin class methodsFor: 'queries' stamp: 'sw 2/1/2005 02:07'!
nameForAdditionsCategory
	"Answer the name for the category bearing unclassified items"

	^ '-unclassified-'! !

!CPartsBin class methodsFor: 'queries' stamp: 'sw 2/1/2005 02:07'!
nameForSearchResultsCategory
	"Answer the name for the category bearing the search results"

	^ '-search results-'! !

!CPartsBin class methodsFor: 'queries' stamp: 'sw 1/31/2005 01:05'!
partDescriptionNamed: aName
	"Answer a partDescription of the given name, if any known"

	^ self allPartDescriptions at: aName ifAbsent: [nil]

"
CPartsBin partDescriptionNamed: 'Parts Bin'
"! !

!CPartsBin class methodsFor: 'queries' stamp: 'sw 2/7/2005 03:09'!
predefinedCategoryNames
	"Answer the predefined category names that merit extra warning if the user attempts to delete or rename them"

	^ #('basic' 'buttons' 'lists' 'scrolling' 'text' 'tools' 'windows')! !

!CPartsBin class methodsFor: 'registry' stamp: 'ar 6/23/2005 16:57'!
rebuildPartsLibrary
	"Caution: dangerous, destructive!!  If you have any user-specified category changes or user-constructed objects added to the parts bin, they will be lost."
	"CPartsBin rebuildPartsLibrary"

	Cursor wait showWhile:
		[AllPartDescriptions := nil.

		self addDescriptionsForBasic.
		self addDescriptionsForButtons.
		self addDescriptionsForLists.
		self addDescriptionsForMiscellaneous. 
		self addDescriptionsForScrolling.
		self addDescriptionsForText.
		self addDescriptionsForTools.
		self addDescriptionsForWindows.
		self addDescriptionsForDemo.

		self installNewbornInstanceForms.
		self initializeCategories]! !

!CPartsBin class methodsFor: 'class initialization' stamp: 'sw 1/24/2005 23:26'!
registerOpenCommand
	"Register the open command for the receiver"

	Smalltalk at: #CProjectBuilder ifPresent:
		[:pb |
			pb registerOpenCommand: { 'Parts Bin' . { self . #open }. 'A source of new objects' }]! !

!CPartsBin class methodsFor: 'registry' stamp: 'sw 2/6/2005 01:43'!
registerPartDescription: aPartDescription
	"Register the given part-description.  Note that if its name duplicates the name of an already-registered item, the old item will be replaced by the new one"

	AllPartDescriptions ifNil: [AllPartDescriptions := Dictionary new].
	AllPartDescriptions at: aPartDescription label put: aPartDescription.
	self absorbAllCategoriesMentionedInPartDescriptions.
	self signal: #allPartDescriptionsChanged.

! !

!CPartsBin class methodsFor: 'registry' stamp: 'sw 2/6/2005 02:17'!
removePart: aName
	"Remove the part of the given name from the library"

	(self partDescriptionNamed: aName) ifNil: [^ self error: 'cannot find this part'].
	self allPartDescriptions removeKey: aName ifAbsent: [].
	self signal: #allPartDescriptionsChanged! !

!CPartsBin class methodsFor: 'services' stamp: 'sw 2/8/2005 03:14'!
setFormForPartNamed: aName to: aForm
	"Set the newbornInstanceForm for the part of the given name to the form provided.  No senders in the image at present, but available for calls from do-its"

	| aDescription |
	aDescription := self partDescriptionNamed: aName.
	aDescription ifNil: [^ self inform: 'no such part found in the library'].
	aDescription newbornInstanceForm: aForm! !

!CPartsBin methodsFor: 'menu' stamp: 'sw 2/4/2005 00:38'!
addCategory
	"Add a new category"

	| reply |
	(reply := self request: 'New category name:' initialAnswer: '') isEmptyOrNil
		ifFalse:
			[(self class allCategoryNames includes: reply)
				ifTrue:
					[self inform: 'That name is already in the list.']
				ifFalse:
					[CPartsBin addCategoryNamed: reply.
					categories selection: reply]]! !

!CPartsBin methodsFor: 'miscellaneous' stamp: 'sw 1/24/2005 18:35'!
allPartDescriptions
	"Answer all the partDescriptions known"

	^ self class allPartDescriptions! !

!CPartsBin methodsFor: 'accessing' stamp: 'sw 2/8/2005 03:21'!
categories
	"Answer the categories of the receiver"

	<bewareOf: #categoriesChanged>
	^ self propertyValueAt: #categories! !

!CPartsBin methodsFor: 'accessing' stamp: 'sw 1/31/2005 13:42'!
categories: aValue
	"Modify the receiver's categories"

	^ self propertyValueAt: #categories put: aValue with: #categoriesChanged! !

!CPartsBin methodsFor: 'menu' stamp: 'sw 2/8/2005 11:57'!
categoriesMenu
	"Answer the categories-list menu"

	| aMenu |
	aMenu := CMenu new.
	aMenu label: 'Categories'.
	aMenu addList:#(
			('add new category' 		addCategory		'add a new category to the parts bin')
			-
			('rename this category'		renameCategory	'change the name of the selected category')
			('export this category'		exportCategory	'write a disk file representing this category')
			-
			('delete this category'		deleteCategory	'remove this category; any items in it will be shifted to the unclassified category')) target: self.
	^ aMenu! !

!CPartsBin methodsFor: 'accessing' stamp: 'sw 2/8/2005 03:22'!
contents
	"Answer the contents of the receiver"

	<bewareOf: #contentsChanged>
	^ self propertyValueAt: #contents! !

!CPartsBin methodsFor: 'accessing' stamp: 'sw 2/8/2005 03:21'!
contents: aValue
	"Modify the receiver's contents"

	^ self propertyValueAt: #contents put: aValue with: #contentsChanged! !

!CPartsBin methodsFor: 'menu' stamp: 'sw 2/4/2005 00:38'!
deleteCategory
	"Delete the selected category"

	|  existing aMessage |
	existing := categories selection ifNil: [^ self beep].
	(self class immutableCategoryNames includes: existing) ifTrue: [^ self inform: 'Sorry, cannot delete that system-defined category.'].

	aMessage :=  (self class predefinedCategoryNames includes: existing)
		ifTrue:
			[existing, ' is a standard category
that you are not advised to delete. 
Are you REALLY sure you want to do this?']
		ifFalse:
			['Really delete ', existing, '?'].
	(self confirm: aMessage) 
		ifTrue:
			[self class declassifyPartsAndDeleteCategory: existing]! !

!CPartsBin methodsFor: 'menu' stamp: 'sw 2/8/2005 12:25'!
exportCategory
	"Export the category to disk"

	self notYetImplemented! !

!CPartsBin methodsFor: 'accessing' stamp: 'sw 1/19/2005 01:21'!
iconsPane
	"Answer the iconsPane of the receiver"
	<bewareOf: #iconsPaneChanged>
	^self propertyValueAt: #iconsPane! !

!CPartsBin methodsFor: 'accessing' stamp: 'sw 1/19/2005 01:21'!
iconsPane: aValue
	"Modify the receiver's iconsPane"
	^self propertyValueAt: #iconsPane put: aValue with: #iconsPaneChanged! !

!CPartsBin methodsFor: 'initialize' stamp: 'sw 2/8/2005 14:30'!
initialize
	"Initialize the receiver."

	super initialize.
	self define: #categories as: CStringList new.
	self define: #contents as: CScrollPane new.
	self define: #searchPane as: CPlayer new.
	self define: #searchLabel as: CLabel new.
	self define: #searchField as: CInputField new.
	self define: #searchButton as: CPushButton new.
	self define: #iconsPane as: CStyleReadoutList new.
	self class assureLibraryInitialized.
	categories addAll: CPartsBin allCategoryNames! !

!CPartsBin methodsFor: 'initialize' stamp: 'sw 2/8/2005 05:02'!
makeSearchPane
	"create the search pane"

	| row |
	row := CPlayer new.
	row hResizing: #spaceFill; vResizing: #spaceFill.
	row layout: CTableLayout new.
	row layout listDirection: #leftToRight.
	row layoutInset: 10@10.

	searchLabel value: 'Search: ' asText allBold.
	searchLabel hResizing: #shrinkWrap.
	row addLast: searchLabel.

	searchField := CInputField new.
	searchField hResizing: #spaceFill; vResizing: #spaceFill.
	row addLast: searchField.

	searchButton width: 20; height: 20.
	searchButton font: (TextStyle named: #WindowFont) defaultFont.
	searchButton label: 'F'.
	row addLast: searchButton.

	searchPane add: row! !

!CPartsBin methodsFor: 'events' stamp: 'ar 5/28/2005 21:42'!
onAllPartsChanged
   "A part description has been added or removed. Update me"

   <on: allPartDescriptionsChanged in: CPartsBin>
   self comeToFront. "make sure I'm visible in the project"
   self onCategoryChanged. "update current category"
! !

!CPartsBin methodsFor: 'events' stamp: 'sw 2/6/2005 02:57'!
onCategoriesChanged
	"The categories list has changed; make the tool react properly"

	| saved names |
	<on: allCategoriesChanged in: CPartsBin>

	saved := categories selection.
	categories removeAll; addAll: (names := CPartsBin allCategoryNames).
	saved ifNotNil:
		[(names includes: saved) ifTrue:
			[categories selection: saved]]
			
	! !

!CPartsBin methodsFor: 'events' stamp: 'sw 1/31/2005 22:30'!
onCategoryChanged
	"The category choice has changed; make the tool react properly"

	| match descriptions |
	<on: cursorChanged in: categories>
	categories cursor = 0
		ifTrue:
			[iconsPane removeAll]
		ifFalse:
			[match := categories selection.
			match = CPartsBin nameForSearchResultsCategory
				ifTrue: [^ self onFindObject].
			descriptions := self allPartDescriptions select:
				[:aDescription | aDescription categories includes: match] .
			self showIconsFor: descriptions]! !

!CPartsBin methodsFor: 'events' stamp: 'sw 2/1/2005 02:06'!
onFindObject
	"The user has made a gesture to trigger a search.  Carry it out"

	| result items |
	result := searchField text asString asLowercase.
	result := result asLowercase withBlanksTrimmed.
	items := result isEmpty
		ifTrue:
			[OrderedCollection new]
		ifFalse:
			[items := self allPartDescriptions values select:
				[:aDescription | aDescription label includesSubstring: result caseSensitive: false]].

	categories selection: CPartsBin nameForSearchResultsCategory.
	self showIconsFor: items! !

!CPartsBin methodsFor: 'events' stamp: 'sw 2/6/2005 02:36'!
onNeedToShow: aCategoryName
	"Signalled when a user gesture requires that a visible parts-bin be pointed at a given category"

	<on: needToShowCategory in: CPartsBin>

	categories selection: aCategoryName! !

!CPartsBin methodsFor: 'events' stamp: 'sw 2/6/2005 01:36'!
onSearchAccept
	"The user submitted contents to the searchField; trigger a search"

	<on: accept in: searchField>
	self onFindObject! !

!CPartsBin methodsFor: 'events' stamp: 'sw 2/6/2005 01:36'!
onSearchButtonFire
	"The user submitted contents to the searchField by hitting the Search button; trigger a search"

	<on: fire in: searchButton>
	self onFindObject! !

!CPartsBin methodsFor: 'menu' stamp: 'sw 2/6/2005 02:50'!
renameCategory
	"Rename the selected category"

	| reply existing |
	existing := categories selection ifNil: [^ self beep].
	(self class immutableCategoryNames includes: existing) ifTrue: [^ self inform: 'Sorry, cannot change that system-defined category name.'].
	(self class predefinedCategoryNames includes: existing) ifTrue:
		[(self confirm: existing, ' is a standard category that you are not
advised to change.  Do you really want to do this?') ifFalse: [^ self]].
	(reply := self request: 'New category name:' initialAnswer: existing) isEmptyOrNil
		ifFalse:
			[reply = existing ifTrue: [^ self].
			(self class allCategoryNames includes: reply)
				ifTrue:
					[self inform: 'That name is already in the list.']
				ifFalse:
					[CPartsBin changeCategoryNamed: existing to: reply]]! !

!CPartsBin methodsFor: 'accessing' stamp: 'sw 2/8/2005 03:21'!
searchButton
	"Answer the searchButton of the receiver"

	<bewareOf: #searchButtonChanged>
	^ self propertyValueAt: #searchButton! !

!CPartsBin methodsFor: 'accessing' stamp: 'sw 2/8/2005 03:20'!
searchButton: aValue
	"Modify the receiver's searchButton"

	^ self propertyValueAt: #searchButton put: aValue with: #searchButtonChanged! !

!CPartsBin methodsFor: 'accessing' stamp: 'sw 2/8/2005 03:21'!
searchField
	"Answer the searchField of the receiver"

	<bewareOf: #searchFieldChanged>
	^ self propertyValueAt: #searchField! !

!CPartsBin methodsFor: 'accessing' stamp: 'sw 2/8/2005 03:22'!
searchField: aValue
	"Modify the receiver's searchField"

	^ self propertyValueAt: #searchField put: aValue with: #searchFieldChanged! !

!CPartsBin methodsFor: 'accessing' stamp: 'sw 2/8/2005 03:21'!
searchLabel
	"Answer the searchLabel of the receiver"
	<bewareOf: #searchLabelChanged>

	^ self propertyValueAt: #searchLabel! !

!CPartsBin methodsFor: 'accessing' stamp: 'sw 2/8/2005 03:21'!
searchLabel: aValue
	"Modify the receiver's searchLabel"

	^ self propertyValueAt: #searchLabel put: aValue with: #searchLabelChanged! !

!CPartsBin methodsFor: 'accessing' stamp: 'sw 2/8/2005 03:21'!
searchPane
	"Answer the searchPane of the receiver"

	<bewareOf: #searchPaneChanged>
	^ self propertyValueAt: #searchPane! !

!CPartsBin methodsFor: 'accessing' stamp: 'sw 2/8/2005 03:21'!
searchPane: aValue
	"Modify the receiver's searchPane"

	^ self propertyValueAt: #searchPane put: aValue with: #searchPaneChanged! !

!CPartsBin methodsFor: 'miscellaneous' stamp: 'sw 2/1/2005 02:06'!
selectCategory: aCategoryName
	"Select the category of the given name"

	categories selection: aCategoryName! !

!CPartsBin methodsFor: 'initialize' stamp: 'ar 5/26/2005 20:13'!
setupCostume
	"Set up the receiver's costume"

	| aFrame |

	super setupCostume.
	self extent: 440@290.
	self hResizing: #rigid; vResizing: #rigid.
	self layout := CProportionalLayout new.
	self label: 'Parts Bin'.

	categories hResizing: #spaceFill; vResizing: #spaceFill.
	categories width: 120.
	categories allowDeselect: true.
	categories layoutFrame: (aFrame := CLayoutFrame new).
	aFrame leftOffset: 0; leftFraction: 0.0.
	aFrame topOffset: 0; topFraction: 0.0.
	aFrame rightOffset: 0; rightFraction: 120 / 440.
	aFrame bottomOffset: 0; bottomFraction: 1.0.
	self add: categories.
	categories menu: self categoriesMenu.

	contents hResizing: #spaceFill; vResizing: #spaceFill.
	contents hScrollable: false; vScrollable: nil.

	contents color: Color white.
	contents layout: CTableLayout new.
	contents layoutFrame: (aFrame := CLayoutFrame new).
	aFrame leftOffset: 0; leftFraction: 120/440.
	aFrame topOffset: 0; topFraction: 0.0.
	aFrame rightOffset: 0; rightFraction: 1.0.
	aFrame bottomOffset: 0; bottomFraction: 1.0.
	self add: contents.

	self makeSearchPane.
	searchPane layout: CTableLayout new.
	searchPane hResizing: #spaceFill; vResizing: #shrinkWrap.
	contents add: searchPane.

	iconsPane layout: CTableLayout new.
	iconsPane hResizing: #spaceFill; vResizing: #shrinkWrap.
	iconsPane layout listDirection: #leftToRight; wrapDirection: #topToBottom; layoutInset: 4@4; cellInset: 10@10.
	contents add: iconsPane.

	self decorate: elements color: self defaultWindowColor.! !

!CPartsBin methodsFor: 'miscellaneous' stamp: 'ar 3/1/2005 09:29'!
showIconsFor: itemDescriptions
	"Replace the contents of the icons pane with items representing the given part description"

	| aLauncher |
	iconsPane removeAll.
	(itemDescriptions asArray sort: [:p1 :p2 | p1 label asLowercase <= p2 label asLowercase]) do:
		[:aDescription |
			aLauncher := CPartIcon new.
			aLauncher partDescription: aDescription.
			aLauncher accommodatePartDescription.
			aLauncher startScript: #launchPart when: {aLauncher. #mouseDrag}.
			iconsPane add: aLauncher]! !

CPanel subclass: #CPartsSource
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Tools-PartsBin'!

!CPartsSource commentStamp: 'sw 6/12/2005 21:57' prior: 0!
A player that offers a "stationery pad" or "parts bin" of objects that can be "torn off".!

CPartsSource defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="categories" toSet="categories:" changeEvent="categoriesChanged">categories</field>
	<field toGet="contents" toSet="contents:" changeEvent="contentsChanged">contents</field>
	<field toGet="searchPane" toSet="searchPane:" changeEvent="searchPaneChanged">searchPane</field>
	<field toGet="searchLabel" toSet="searchLabel:" changeEvent="searchLabelChanged">searchLabel</field>
	<field toGet="searchField" toSet="searchField:" changeEvent="searchFieldChanged">searchField</field>
	<field toGet="searchButton" toSet="searchButton:" changeEvent="searchButtonChanged">searchButton</field>
	<field toGet="iconsPane" toSet="iconsPane:" changeEvent="iconsPaneChanged">iconsPane</field>
	<field toGet="allCategoryNames" toSet="allCategoryNames:" changeEvent="allCategoryNamesChanged">allCategoryNames</field>
	<field toGet="allPartDescriptions" toSet="allPartDescriptions:" changeEvent="allPartDescriptionsChanged">allPartDescriptions</field>
	<field toGet="buildSelector" toSet="buildSelector:" changeEvent="buildSelectorChanged">buildSelector</field>
</fields>'!

!CPartsSource methodsFor: 'categories' stamp: 'sw 2/1/2005 00:39'!
absorbAllCategoriesMentionedInPartDescriptions
	"Like de selector say"

	| allCats |
	allCats := self allCategoryNames asOrderedCollection.
	allCats add: self nameForSearchResultsCategory.
	allCats add: self nameForAdditionsCategory.
	self allPartDescriptions do: [:descr | allCats addAll: descr categories].
	allCategoryNames := allCats asSet asSortedArray asOrderedCollection.


"
CPartsSource new absorbAllCategoriesMentionedInPartDescriptions
"

! !

!CPartsSource methodsFor: 'category menu' stamp: 'sw 6/2/2005 01:11'!
addCategory
	"Add a new category"

	| reply |
	(reply := self request: 'New category name:' initialAnswer: '') isEmptyOrNil
		ifFalse:
			[(self allCategoryNames includes: reply)
				ifTrue:
					[self inform: 'That name is already in the list.']
				ifFalse:
					[self addCategoryNamed: reply.
					categories selection: reply]]! !

!CPartsSource methodsFor: 'categories' stamp: 'sw 6/12/2005 22:14'!
addCategoryNamed: aName
	"Add a new category.  Resort the list, and update extant instances."

	allCategoryNames := allCategoryNames copyWith: aName.
	self alphabetizeCategoryNames.
	self onCategoriesChanged! !

!CPartsSource methodsFor: 'part descriptions default parts bin' stamp: 'sw 2/6/2005 03:14'!
addDescriptionsFor: aCategoryName from: tuples
	"Convenience method to create and register part-descriptions from a list of triplets of the form <rcvr> <label> <balloon-help msg>.  Tuples whose first elements are not in the Smalltalk dictionary are ignored."

	| aPartDescription |
	tuples do:
		[:aTuple |
			(Smalltalk includesKey: aTuple first) ifTrue:
				[aPartDescription := CPartDescription partDescriptionWithLabel: aTuple second balloonHelp: aTuple third category: aCategoryName creator: aTuple first selector: #newbornPartToDropIn: customForm: nil.
				self registerPartDescription: aPartDescription]]! !

!CPartsSource methodsFor: 'part descriptions default parts bin' stamp: 'ar 6/29/2005 09:59'!
addDescriptionsForBasic
	"Add part descriptions for basic category"

	self addDescriptionsFor: #basic from: #(
		(CPlayfield			'Playfield' 		'A playfield')
		(CEllipsePlayer		'Ellipse' 		'An ellipse or circle')
		(CRectanglePlayer 	'Rectangle'		'A rectangle')
		(CPolygonPlayer		'Polygon'		'A figure of connected line segments')
		(CRoundRectPlayer 	'RoundRect'		'A rectangle with rounded corners'))! !

!CPartsSource methodsFor: 'part descriptions default parts bin' stamp: 'sw 2/8/2005 02:43'!
addDescriptionsForButtons
	"Add part descriptions for the buttons category"

	self addDescriptionsFor: 'buttons' from: #(
		(CPushButton		'PushButton'		'A PushButton is just like any other Button, except that it uses a system-default costume.  It is shaded from top to bottom, going from white to dark yellow.  Pressing a button causes it to "fire".  You can decide which event will fire the button , such as mouseUp or mouseDown.  You can define a script that will tell the button what to do when it fires.')
		(CRadioButton		'RadioButton' 		'A RadioButton finds the other RadioButtons in the same container.  When any one is pressed, it turns the others off.  The one that is pressed stays on and highlighted.')
		(CImageButton		'ImageButton'	'An ImageButton is a simple button which takes two to four images to display depending on its state.')
		(CCheckBox			'CheckBox'		'A CheckBox is a simple button that toggles its value between true and false.  It shows a check mark when its value is true.  Adding a label is easy')
		(CTabButton			'TabButton'		'A TabButton is a horizontal row of buttons that look like tabs.  It is used for tabbed palettes (e.g., a TabButtonList).'))! !

!CPartsSource methodsFor: 'part descriptions default parts bin' stamp: 'sw 2/8/2005 02:11'!
addDescriptionsForLists
	"Add part descriptions for the lists category"

	self addDescriptionsFor: 'lists' from: #(
		(CList			'List' 			'A List is the basic way to show a list of choices.  It carries its own list of items which (contrary to its elements) can be shared with another object.  This allows a list to automatically provide a view of an arbitrary collection.  
A List can have an itemMaker to specify how the items will be shown.  By default a CListItem is used which merely uses the #displayText representation of the object.  A different itemMaker could display the items as images.')
		(CDropDownList	'DropDownList' 	'A DropDownList presents the user with an input field and a drop down list.  When the user selects an item, the list''s selection and its value will change to the selected item.  If the list is editable, then the user can type into the input field.  Upon accepting the input, the list will add in the new accepted value.')
		(CSpinnerList	'SpinnerList'	'A Spinner is an object with up and down buttons.  A SpinnerList shows the currently selected item from a hidden list of choices.  The arrow buttons move the selection up or down the list to a new item.  The SpinnerList''s cursor changes accordingly.')
		(CStringList		'StringList'		'A StringList shows all of its elements in a list.  Each shows what it returns from the message #displayText, usually its name.'))! !

!CPartsSource methodsFor: 'part descriptions default parts bin' stamp: 'sw 6/12/2005 19:21'!
addDescriptionsForMiscellaneous
	"Add part descriptions for miscellaneous category"

	self addDescriptionsFor: #miscellaneous from: #(
		(CEToyHolder		'Holder'			'A container for other objects')
		(CTrashCan			'TrashCan'		'A place for discarding things')
		(CStopStepGoControls 'Script Controls'	'Controls for the scripts in this project')).

	CStickyPad registerWithPartsSource: self.  "on account of custom form"
	CMagnifier registerWithPartsSource: self

! !

!CPartsSource methodsFor: 'part descriptions default parts bin' stamp: 'sw 2/8/2005 02:36'!
addDescriptionsForScrolling
	"Add part descriptions for the sliders category"

	self addDescriptionsFor: 'scrolling' from: #(
		(CSlider			'Slider' 			'A Slider is a bar with a marker in it.  The marker''s position indicates a value that is somewhere between two extreme values.  A ScrollBar is a kind of Slider.')
		(CScrollBar		'ScrollBar' 		'A ScrollBar is the slider you see at the edge of a window.  It lets you move the contents of a pane inside the pane.')
		(CScrollPane		'ScrollPane'		'A ScrollPane is an area with contents and two scroll bars.')
		(CSpinnerButtons	'SpinnerButtons'		'SpinnerButtons are the up and down arrows on a Spinner.  Look in the ColorTool at the Fill Alpha: control to see a Spinner with SpinnerButtons.')
		(CSpinner		'Spinner'		'A Spinner is a display with up and down arrows to change its value.  Look in the ColorTool at the Fill Alpha: control to see a Spinner.')
		(CWheelWidget	'Wheel Widget'	'What is this class used for, anyway?  --Ted.'))! !

!CPartsSource methodsFor: 'part descriptions default parts bin' stamp: 'sw 2/8/2005 02:45'!
addDescriptionsForText
	"Add descriptions for the text category"

	self addDescriptionsFor: 'text' from: #(
		(CLabel				'Label'			'A Label shows one line of characters.  It is often added as an element to another object.  You cannot edit the text of a label by clicking in it.')
		(CSimpleTextEditor	'Text Editor'		'A simple text editor.')
		(CInputField			'Input Field'		'An InputField is a one line text editor.  The enter key and the return key make it accept and remember its text.  This text is stored in its value field.  It can carry a TextConverter to convert forth and back between its value (any object) and the text it displays.'))
! !

!CPartsSource methodsFor: 'part descriptions default parts bin' stamp: 'sw 6/18/2005 03:32'!
addDescriptionsForTools
	"Add descriptions for the tools category"

	self addDescriptionsFor: 'tools' from: #(
		(CPainter				'Painter	'				'A tool for drawing and painting objects')
		(CTextTool				'Text Tool'				'A tool for editing text')
		(CTranscriptView		'Transcript'				'A window that can display messages to the user')
		(CWorkspace				'Workspace'				'A textual window which remembers values of variables you assign to within it.')
		(CPreferencesTool		'Preferences'			'A tool for setting many different options that govern how things work in the system.')
		(CColorTool				'Color Tool'				'A tool for changing color and border characteristics of any object')
		(CClassBrowser			'Class Browser'			'A tool for viewing and editing code')
		(CChangeSorter			'Change Sorter'			'A tool for viewing and manipulating change-sets')
		(CTrashTool				'Trash'					'A tool for viewing and reclaiming discarded items')
		(CAnnotationsBrowser	'Annotations'			'A tool for viewing method annotations'))
! !

!CPartsSource methodsFor: 'part descriptions default parts bin' stamp: 'sw 2/8/2005 02:20'!
addDescriptionsForWindows
	"Add part descriptions for the windows category"

	self addDescriptionsFor: 'windows' from: #(
		(CWindow			'Window'		'A resizable window with title bar.')
		(CUserDialog			'UserDialog'		'A textual interaction with the user')
		(CFileOpenDialog	 	'FileOpenDialog'	'A tool that allows the user to choose a file')
		(CFileSaveDialog		'FileSaveDialog'	'A tool that allows the user to choose where to save a file on disk'))
! !

!CPartsSource methodsFor: 'queries' stamp: 'sw 6/2/2005 01:09'!
allCategoryNames
	"Answer the allCategoryNames of the receiver"
	<bewareOf: #allCategoryNamesChanged>
	^self propertyValueAt: #allCategoryNames! !

!CPartsSource methodsFor: 'accessing' stamp: 'sw 6/2/2005 01:09'!
allCategoryNames: aValue
	"Modify the receiver's allCategoryNames"
	^self propertyValueAt: #allCategoryNames put: aValue with: #allCategoryNamesChanged! !

!CPartsSource methodsFor: 'queries' stamp: 'sw 6/2/2005 01:09'!
allPartDescriptions
	"Answer the allPartDescriptions of the receiver"
	<bewareOf: #allPartDescriptionsChanged>
	^self propertyValueAt: #allPartDescriptions! !

!CPartsSource methodsFor: 'miscellaneous' stamp: 'sw 6/2/2005 01:09'!
allPartDescriptions: aValue
	"Modify the receiver's allPartDescriptions"
	^self propertyValueAt: #allPartDescriptions put: aValue with: #allPartDescriptionsChanged! !

!CPartsSource methodsFor: 'queries' stamp: 'sw 2/6/2005 03:04'!
allPopulatableCategoryNames
	"Answer the master list of all known category names that could be chosen as destination categories.  Some may have no items associated with them at the moment"

	^ self allCategoryNames copyWithout: self nameForSearchResultsCategory! !

!CPartsSource methodsFor: 'categories' stamp: 'sw 2/8/2005 01:17'!
alphabetizeCategoryNames
	"NB case-blind sort"
.
	allCategoryNames := (allCategoryNames asSet
		asSortedCollection: [:a :b | a asLowercase < b asLowercase]) asOrderedCollection! !

!CPartsSource methodsFor: 'part descriptions default parts bin' stamp: 'sw 6/13/2005 01:26'!
assureLibraryInitialized
	"If the vars holding the parts-bin-library info are not fully set up, set them up now..."

	allPartDescriptions isEmptyOrNil ifTrue: [self rebuildPartsLibrary]! !

!CPartsSource methodsFor: 'libraries' stamp: 'sw 6/20/2005 03:23'!
buildBasicOnlyLibrary
	"Create a library with only the basic category"

	self addDescriptionsForBasic
! !

!CPartsSource methodsFor: 'libraries' stamp: 'sw 6/20/2005 03:23'!
buildFullPartsLibrary
	"Build the full parts library"

	self addDescriptionsForBasic.
	self addDescriptionsForButtons.
	self addDescriptionsForLists.
	self addDescriptionsForMiscellaneous. 
	self addDescriptionsForScrolling.
	self addDescriptionsForText.
	self addDescriptionsForTools.
	self addDescriptionsForWindows! !

!CPartsSource methodsFor: 'accessing' stamp: 'sw 6/13/2005 01:24'!
buildSelector
	"Answer the buildSelector of the receiver"
	<bewareOf: #buildSelectorChanged>
	^self propertyValueAt: #buildSelector! !

!CPartsSource methodsFor: 'accessing' stamp: 'sw 6/13/2005 01:24'!
buildSelector: aValue
	"Modify the receiver's buildSelector"
	^self propertyValueAt: #buildSelector put: aValue with: #buildSelectorChanged! !

!CPartsSource methodsFor: 'libraries' stamp: 'sw 6/18/2005 03:17'!
buildSimplePartsBin
	"Give me only Basic and Miscellaneous categories..."
	"CPartsSource new buildSimplePartsBin; open"

	self addDescriptionsForBasic.
	self addDescriptionsForMiscellaneous! !

!CPartsSource methodsFor: 'accessing' stamp: 'sw 2/8/2005 03:21'!
categories
	"Answer the categories of the receiver"

	<bewareOf: #categoriesChanged>
	^ self propertyValueAt: #categories! !

!CPartsSource methodsFor: 'accessing' stamp: 'sw 1/31/2005 13:42'!
categories: aValue
	"Modify the receiver's categories"

	^ self propertyValueAt: #categories put: aValue with: #categoriesChanged! !

!CPartsSource methodsFor: 'category menu' stamp: 'sw 2/8/2005 11:57'!
categoriesMenu
	"Answer the categories-list menu"

	| aMenu |
	aMenu := CMenu new.
	aMenu label: 'Categories'.
	aMenu addList:#(
			('add new category' 		addCategory		'add a new category to the parts bin')
			-
			('rename this category'		renameCategory	'change the name of the selected category')
			('export this category'		exportCategory	'write a disk file representing this category')
			-
			('delete this category'		deleteCategory	'remove this category; any items in it will be shifted to the unclassified category')) target: self.
	^ aMenu! !

!CPartsSource methodsFor: 'categories' stamp: 'sw 6/16/2005 15:11'!
changeCategoryNamed: existing to: newName
	"Change the category currently known as existing to be the new one.  I've got some doubts about this."

	self allPartDescriptions do:
		[:d | d categoryNamed: existing changedTo: newName].
	allCategoryNames remove: existing; add: newName.
	self alphabetizeCategoryNames.
	self signal: #allCategoriesChanged.
	self showCategory: newName! !

!CPartsSource methodsFor: 'accessing' stamp: 'sw 2/8/2005 03:22'!
contents
	"Answer the contents of the receiver"

	<bewareOf: #contentsChanged>
	^ self propertyValueAt: #contents! !

!CPartsSource methodsFor: 'accessing' stamp: 'sw 2/8/2005 03:21'!
contents: aValue
	"Modify the receiver's contents"

	^ self propertyValueAt: #contents put: aValue with: #contentsChanged! !

!CPartsSource methodsFor: 'categories' stamp: 'sw 2/6/2005 02:23'!
declassifyPartsAndDeleteCategory: categoryName
	"Remove the category of the given name; if any objects were only filed in that category, reassign them to the unclassified category"

	| itsCategories  |
	self allPartDescriptions do:
		[:aDescription | ((itsCategories := aDescription categories) includes: categoryName)
			ifTrue:
				[itsCategories size > 1
					ifTrue: "Not the expected case in current single-category implementation"
						[itsCategories remove: categoryName]
					ifFalse:
						[aDescription categories: (Array with: self nameForAdditionsCategory)]]].
	allCategoryNames remove: categoryName.
	self signal: #allCategoriesChanged! !

!CPartsSource methodsFor: 'category menu' stamp: 'sw 6/17/2005 03:54'!
deleteCategory
	"Delete the selected category"

	|  existing aMessage |
	existing := categories selection ifNil: [^ self beep].
	(self immutableCategoryNames includes: existing) ifTrue: [^ self inform: 'Sorry, cannot delete that system-defined category.'].

	aMessage :=  (self predefinedCategoryNames includes: existing)
		ifTrue:
			[existing, ' is a standard category
that you are not advised to delete. 
Are you REALLY sure you want to do this?']
		ifFalse:
			['Really delete ', existing, '?'].
	(self confirm: aMessage) 
		ifTrue:
			[self declassifyPartsAndDeleteCategory: existing]! !

!CPartsSource methodsFor: 'category menu' stamp: 'sw 2/8/2005 12:25'!
exportCategory
	"Export the category to disk"

	self notYetImplemented! !

!CPartsSource methodsFor: 'libraries' stamp: 'sw 6/16/2005 15:10'!
haveInstancesShowUnclassified
	"See to it that any instances of mine open on the screen get pointed to the Unclassified category"

	self showCategory: self nameForAdditionsCategory! !

!CPartsSource methodsFor: 'accessing' stamp: 'sw 1/19/2005 01:21'!
iconsPane
	"Answer the iconsPane of the receiver"
	<bewareOf: #iconsPaneChanged>
	^self propertyValueAt: #iconsPane! !

!CPartsSource methodsFor: 'accessing' stamp: 'sw 1/19/2005 01:21'!
iconsPane: aValue
	"Modify the receiver's iconsPane"
	^self propertyValueAt: #iconsPane put: aValue with: #iconsPaneChanged! !

!CPartsSource methodsFor: 'categories' stamp: 'sw 2/1/2005 00:52'!
immutableCategoryNames
	"Answer the immutable category names that the user cannot edit or delete"

	^ {self nameForAdditionsCategory. self nameForSearchResultsCategory}! !

!CPartsSource methodsFor: 'initialize' stamp: 'sw 6/18/2005 03:33'!
initialize
	"Initialize the receiver."

	super initialize.
	self define: #categories as: CStringList new.
	self define: #contents as: CScrollPane new.
	self define: #searchPane as: CPlayer new.
	self define: #searchLabel as: CLabel new.
	self define: #searchField as: CInputField new.
	self define: #searchButton as: CPushButton new.
	self define: #iconsPane as: CStyleReadoutList new.
	allCategoryNames := OrderedCollection new.
	allPartDescriptions := Dictionary new.
	buildSelector ifNil: [buildSelector := #buildFullPartsLibrary]

! !

!CPartsSource methodsFor: 'categories' stamp: 'sw 2/1/2005 02:07'!
initializeCategories
	"Initialize the category list"

	allCategoryNames := OrderedCollection with: self nameForSearchResultsCategory with: self nameForAdditionsCategory.
	self absorbAllCategoriesMentionedInPartDescriptions


"
CPartsSource new initializeCategories.
CPartsSource new rebuildPartsLibrary.
allCategoryNames
"! !

!CPartsSource methodsFor: 'libraries' stamp: 'sw 2/7/2005 03:34'!
installNewbornInstanceForms
	"Launch examples of all items in the parts bin, thus obtaining useful newbornInstanceForms for all of them."

	self allPartDescriptions do:
		[:aPartDescription |
			aPartDescription rebuildNewbornInstanceForm]
"
CPartsSource installNewbornInstanceForms
"! !

!CPartsSource methodsFor: 'initialize' stamp: 'sw 2/8/2005 05:02'!
makeSearchPane
	"create the search pane"

	| row |
	row := CPlayer new.
	row hResizing: #spaceFill; vResizing: #spaceFill.
	row layout: CTableLayout new.
	row layout listDirection: #leftToRight.
	row layoutInset: 10@10.

	searchLabel value: 'Search: ' asText allBold.
	searchLabel hResizing: #shrinkWrap.
	row addLast: searchLabel.

	searchField := CInputField new.
	searchField hResizing: #spaceFill; vResizing: #spaceFill.
	row addLast: searchField.

	searchButton width: 20; height: 20.
	searchButton font: (TextStyle named: #WindowFont) defaultFont.
	searchButton label: 'F'.
	row addLast: searchButton.

	searchPane add: row! !

!CPartsSource methodsFor: 'queries' stamp: 'sw 2/1/2005 02:07'!
nameForAdditionsCategory
	"Answer the name for the category bearing unclassified items"

	^ '-unclassified-'! !

!CPartsSource methodsFor: 'queries' stamp: 'sw 2/1/2005 02:07'!
nameForSearchResultsCategory
	"Answer the name for the category bearing the search results"

	^ '-search results-'! !

!CPartsSource methodsFor: 'events' stamp: 'sw 6/20/2005 03:22'!
onAllPartsChanged
   "A part description has been added or removed. Update me"

   <on: allPartDescriptionsChanged in: CPartsSource>
   self comeToFront. "make sure I'm visible in the project"
   self onCategoryChanged. "update current category"
! !

!CPartsSource methodsFor: 'events' stamp: 'sw 6/12/2005 21:54'!
onCategoriesChanged
	"The categories list has changed; make the tool react properly"

	| saved names |
	<on: allCategoriesChanged>

	saved := categories selection.
	categories removeAll; addAll: (names := self allCategoryNames).
	saved ifNotNil:
		[(names includes: saved) ifTrue:
			[categories selection: saved]]
			
	! !

!CPartsSource methodsFor: 'events' stamp: 'sw 6/12/2005 21:55'!
onCategoryChanged
	"The category choice has changed; make the tool react properly"

	| match descriptions |
	<on: cursorChanged in: categories>
	categories cursor = 0
		ifTrue:
			[iconsPane removeAll]
		ifFalse:
			[match := categories selection.
			match = self nameForSearchResultsCategory
				ifTrue: [^ self onFindObject].
			descriptions := self allPartDescriptions select:
				[:aDescription | aDescription categories includes: match] .
			self showIconsFor: descriptions]! !

!CPartsSource methodsFor: 'events' stamp: 'sw 6/17/2005 01:00'!
onDragDropInContents: aPlayer 
	"Triggered when an object is dropped in the contents pane"

	| labelString aDescription usedLabels categoryToAssign sel |
	<on: dragDrop in: contents>

	categoryToAssign := ((sel := categories selection) == nil or: [sel = self nameForSearchResultsCategory])
		ifTrue:
			[self nameForAdditionsCategory]
		ifFalse:
			[sel].
		
	usedLabels := self allPartDescriptions collect: [:d | d label].
	labelString := Utilities keyLike: aPlayer name satisfying:
		[:aKey | (usedLabels includes: aKey) not].
	(aPlayer isKindOf: CPartPrecursor)
		ifFalse:
			[aDescription := CPartDescription new..
			aDescription label: labelString balloonHelp: (aPlayer balloonHelp ifNil: ['Help to be provided'  translated]) category: categoryToAssign creator: aPlayer copy selector: #copy customForm: nil]
		ifTrue:
			[aDescription := aPlayer partDescription copy.
			aDescription categories: (Array with: categoryToAssign)].
	self registerPartDescription: aDescription.
	aPlayer signal: #dropAccept with: self.
! !

!CPartsSource methodsFor: 'initialize' stamp: 'sw 6/20/2005 03:23'!
onFinalInitializations
	"Perform final initializations"

	<on: finalInitializations>
	self assureLibraryInitialized.
	categories addAll: self allCategoryNames.
! !

!CPartsSource methodsFor: 'events' stamp: 'sw 6/12/2005 21:55'!
onFindObject
	"The user has made a gesture to trigger a search.  Carry it out"

	| result items |
	result := searchField text asString asLowercase.
	result := result asLowercase withBlanksTrimmed.
	items := result isEmpty
		ifTrue:
			[OrderedCollection new]
		ifFalse:
			[items := self allPartDescriptions values select:
				[:aDescription | aDescription label includesSubstring: result caseSensitive: false]].

	categories selection: self nameForSearchResultsCategory.
	self showIconsFor: items! !

!CPartsSource methodsFor: 'events' stamp: 'sw 2/6/2005 01:36'!
onSearchAccept
	"The user submitted contents to the searchField; trigger a search"

	<on: accept in: searchField>
	self onFindObject! !

!CPartsSource methodsFor: 'events' stamp: 'sw 2/6/2005 01:36'!
onSearchButtonFire
	"The user submitted contents to the searchField by hitting the Search button; trigger a search"

	<on: fire in: searchButton>
	self onFindObject! !

!CPartsSource methodsFor: 'queries' stamp: 'sw 1/31/2005 01:05'!
partDescriptionNamed: aName
	"Answer a partDescription of the given name, if any known"

	^ self allPartDescriptions at: aName ifAbsent: [nil]

"
CPartsSource partDescriptionNamed: 'Parts Bin'
"! !

!CPartsSource methodsFor: 'queries' stamp: 'sw 2/7/2005 03:09'!
predefinedCategoryNames
	"Answer the predefined category names that merit extra warning if the user attempts to delete or rename them"

	^ #('basic' 'buttons' 'lists' 'scrolling' 'text' 'tools' 'windows')! !

!CPartsSource methodsFor: 'libraries' stamp: 'sw 6/18/2005 03:16'!
rebuildPartsLibrary
	"Build my parts library afresh by performing my buildSelector"

	Cursor wait showWhile:
		[allPartDescriptions := nil.
		self perform: buildSelector.
		self installNewbornInstanceForms.
		self initializeCategories]! !

!CPartsSource methodsFor: 'part descriptions default parts bin' stamp: 'sw 6/18/2005 03:37'!
registerPartDescription: aPartDescription
	"Register the given part-description.  Note that if its name duplicates the name of an already-registered item, the old item will be replaced by the new one"

	allPartDescriptions ifNil: [allPartDescriptions := Dictionary new].
	allPartDescriptions at: aPartDescription label put: aPartDescription.
	self absorbAllCategoriesMentionedInPartDescriptions.
	self signal: #allPartDescriptionsChanged

! !

!CPartsSource methodsFor: 'miscellaneous' stamp: 'sw 2/6/2005 02:17'!
removePart: aName
	"Remove the part of the given name from the library"

	(self partDescriptionNamed: aName) ifNil: [^ self error: 'cannot find this part'].
	self allPartDescriptions removeKey: aName ifAbsent: [].
	self signal: #allPartDescriptionsChanged! !

!CPartsSource methodsFor: 'category menu' stamp: 'sw 6/17/2005 04:31'!
renameCategory
	"Rename the selected category"

	| reply existing |
	existing := categories selection ifNil: [^ self beep].
	(self immutableCategoryNames includes: existing) ifTrue: [^ self inform: 'Sorry, cannot change that system-defined category name.'].
	(self predefinedCategoryNames includes: existing) ifTrue:
		[(self confirm: existing, ' is a standard category that you are not
advised to change.  Do you really want to do this?') ifFalse: [^ self]].
	(reply := self request: 'New category name:' initialAnswer: existing) isEmptyOrNil
		ifFalse:
			[reply = existing ifTrue: [^ self].
			(self allCategoryNames includes: reply)
				ifTrue:
					[self inform: 'That name is already in the list.']
				ifFalse:
					[self changeCategoryNamed: existing to: reply]]! !

!CPartsSource methodsFor: 'accessing' stamp: 'sw 2/8/2005 03:21'!
searchButton
	"Answer the searchButton of the receiver"

	<bewareOf: #searchButtonChanged>
	^ self propertyValueAt: #searchButton! !

!CPartsSource methodsFor: 'accessing' stamp: 'sw 2/8/2005 03:20'!
searchButton: aValue
	"Modify the receiver's searchButton"

	^ self propertyValueAt: #searchButton put: aValue with: #searchButtonChanged! !

!CPartsSource methodsFor: 'accessing' stamp: 'sw 2/8/2005 03:21'!
searchField
	"Answer the searchField of the receiver"

	<bewareOf: #searchFieldChanged>
	^ self propertyValueAt: #searchField! !

!CPartsSource methodsFor: 'accessing' stamp: 'sw 2/8/2005 03:22'!
searchField: aValue
	"Modify the receiver's searchField"

	^ self propertyValueAt: #searchField put: aValue with: #searchFieldChanged! !

!CPartsSource methodsFor: 'accessing' stamp: 'sw 2/8/2005 03:21'!
searchLabel
	"Answer the searchLabel of the receiver"
	<bewareOf: #searchLabelChanged>

	^ self propertyValueAt: #searchLabel! !

!CPartsSource methodsFor: 'accessing' stamp: 'sw 2/8/2005 03:21'!
searchLabel: aValue
	"Modify the receiver's searchLabel"

	^ self propertyValueAt: #searchLabel put: aValue with: #searchLabelChanged! !

!CPartsSource methodsFor: 'accessing' stamp: 'sw 2/8/2005 03:21'!
searchPane
	"Answer the searchPane of the receiver"

	<bewareOf: #searchPaneChanged>
	^ self propertyValueAt: #searchPane! !

!CPartsSource methodsFor: 'accessing' stamp: 'sw 2/8/2005 03:21'!
searchPane: aValue
	"Modify the receiver's searchPane"

	^ self propertyValueAt: #searchPane put: aValue with: #searchPaneChanged! !

!CPartsSource methodsFor: 'miscellaneous' stamp: 'sw 2/1/2005 02:06'!
selectCategory: aCategoryName
	"Select the category of the given name"

	categories selection: aCategoryName! !

!CPartsSource methodsFor: 'miscellaneous' stamp: 'sw 2/8/2005 03:14'!
setFormForPartNamed: aName to: aForm
	"Set the newbornInstanceForm for the part of the given name to the form provided.  No senders in the image at present, but available for calls from do-its"

	| aDescription |
	aDescription := self partDescriptionNamed: aName.
	aDescription ifNil: [^ self inform: 'no such part found in the library'].
	aDescription newbornInstanceForm: aForm! !

!CPartsSource methodsFor: 'initialize' stamp: 'sw 6/16/2005 17:54'!
setupCostume
	"Set up the receiver's costume"

	| aFrame |
	super setupCostume.

	self extent: 440@290.
	self hResizing: #rigid; vResizing: #rigid.
	self layout := CProportionalLayout new.
	self label: 'Supplies'.

	categories hResizing: #spaceFill; vResizing: #spaceFill.
	categories width: 120.
	categories allowDeselect: true.
	categories layoutFrame: (aFrame := CLayoutFrame new).
	aFrame leftOffset: 0; leftFraction: 0.0.
	aFrame topOffset: 0; topFraction: 0.0.
	aFrame rightOffset: 0; rightFraction: 120 / 440.
	aFrame bottomOffset: 0; bottomFraction: 1.0.
	self add: categories.
	categories menu: self categoriesMenu.

	contents hResizing: #spaceFill; vResizing: #spaceFill.
	contents hScrollable: false; vScrollable: nil.

	contents color: Color white.
	contents layout: CTableLayout new.
	contents layoutFrame: (aFrame := CLayoutFrame new).
	aFrame leftOffset: 0; leftFraction: 120/440.
	aFrame topOffset: 0; topFraction: 0.0.
	aFrame rightOffset: 0; rightFraction: 1.0.
	aFrame bottomOffset: 0; bottomFraction: 1.0.
	self add: contents.

	self makeSearchPane.
	searchPane layout: CTableLayout new.
	searchPane hResizing: #spaceFill; vResizing: #shrinkWrap.
	contents add: searchPane.

	iconsPane layout: CTableLayout new.
	iconsPane hResizing: #spaceFill; vResizing: #shrinkWrap.
	iconsPane layout listDirection: #leftToRight; wrapDirection: #topToBottom; layoutInset: 4@4; cellInset: 10@10.
	contents add: iconsPane.

	self decorate: elements color: self defaultWindowColor.

	self signal: #finalInitializations! !

!CPartsSource methodsFor: 'categories' stamp: 'sw 6/16/2005 15:07'!
showCategory: aCategoryName
	"Show the given category"

	categories selection: aCategoryName! !

!CPartsSource methodsFor: 'miscellaneous' stamp: 'sw 6/17/2005 03:22'!
showIconsFor: itemDescriptions
	"Replace the contents of the icons pane with items representing the given part description"

	| aLauncher |
	iconsPane removeAll.
	(itemDescriptions asArray sort: [:p1 :p2 | p1 label asLowercase <= p2 label asLowercase]) do:
		[:aDescription |
			aLauncher := CPartIcon new.
			aLauncher partDescription: aDescription.
			aLauncher accommodatePartDescription.
			aLauncher startScript: #launchPart when: {aLauncher. #mouseDrag}.
			iconsPane add: aLauncher]! !

CPanel subclass: #CPreferencesTool
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Tools-PrefTool'!

!CPreferencesTool commentStamp: 'tk 2/28/2005 14:01' prior: 0!
The Preferences Tool lets you see and change many settings about Tweak.  Click on Tweak in the left hand list.  Hold the cursor over any item to see a balloon that explains it.  Click on a preference to change it.  You can search for a preference by name.  Get a Preferences Tool from the Tools menu in the menu bar.  Preferences that are not in the Tweak category apply to Squeak in general (they will not seem to do anything).[general]


### Allow Users to see the above explanation ###!

CPreferencesTool defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="categories" toSet="categories:" changeEvent="categoriesChanged">categories</field>
	<field toGet="contents" toSet="contents:" changeEvent="contentsChanged">contents</field>
	<field toGet="searchPane" toSet="searchPane:" changeEvent="searchPaneChanged">searchPane</field>
	<field toGet="searchLabel" toSet="searchLabel:" changeEvent="searchLabelChanged">searchLabel</field>
	<field toGet="searchField" toSet="searchField:" changeEvent="searchFieldChanged">searchField</field>
	<field toGet="searchButton" toSet="searchButton:" changeEvent="searchButtonChanged">searchButton</field>
	<field toGet="prefList" toSet="prefList:" changeEvent="prefListChanged">prefList</field>
	<field toGet="buttonRow" toSet="buttonRow:" changeEvent="buttonRowChanged">buttonRow</field>
</fields>'!

!CPreferencesTool class methodsFor: 'class initialization' stamp: 'ar 1/22/2005 22:46'!
initialize
	"CPreferencesTool initialize"
	self registerOpenCommand.
! !

!CPreferencesTool class methodsFor: 'class initialization' stamp: 'ar 1/22/2005 22:45'!
registerOpenCommand
	"CPreferencesTool initialize"
	Smalltalk at: #CProjectBuilder ifPresent:[:pb|
		pb registerOpenCommand: { 'Preferences Panel' . { self . #open }. 'A preferences panel' }.
	].! !

!CPreferencesTool methodsFor: 'initialize' stamp: 'ar 12/19/2004 11:39'!
addButtons
	| button |
	button := CPushButton new.
	button hResizing: #spaceFill; vResizing: #spaceFill.
	button label: 'Load'.
	buttonRow add: button.
	button := CPushButton new.
	button hResizing: #spaceFill; vResizing: #spaceFill.
	button label: 'Save'.
	buttonRow add: button.
! !

!CPreferencesTool methodsFor: 'accessing' stamp: 'ar 12/19/2004 11:24'!
buttonRow
	"Answer the buttonRow of the receiver"
	<bewareOf: #buttonRowChanged>
	^self propertyValueAt: #buttonRow! !

!CPreferencesTool methodsFor: 'accessing' stamp: 'ar 12/19/2004 11:24'!
buttonRow: aValue
	"Modify the receiver's buttonRow"
	^self propertyValueAt: #buttonRow put: aValue with: #buttonRowChanged! !

!CPreferencesTool methodsFor: 'accessing' stamp: 'ar 12/19/2004 09:53'!
categories
	"Answer the categories of the receiver"
	<bewareOf: #categoriesChanged>
	^self propertyValueAt: #categories! !

!CPreferencesTool methodsFor: 'accessing' stamp: 'ar 12/19/2004 09:53'!
categories: aValue
	"Modify the receiver's categories"
	^self propertyValueAt: #categories put: aValue with: #categoriesChanged! !

!CPreferencesTool methodsFor: 'accessing' stamp: 'ar 12/19/2004 10:02'!
contents
	"Answer the contents of the receiver"
	<bewareOf: #contentsChanged>
	^self propertyValueAt: #contents! !

!CPreferencesTool methodsFor: 'accessing' stamp: 'ar 12/19/2004 10:02'!
contents: aValue
	"Modify the receiver's contents"
	^self propertyValueAt: #contents put: aValue with: #contentsChanged! !

!CPreferencesTool methodsFor: 'events' stamp: 'ar 12/19/2004 11:20'!
copyName: pref
	Clipboard clipboardText: pref name asString asText! !

!CPreferencesTool methodsFor: 'events' stamp: 'ar 12/19/2004 11:14'!
findCategoryFromPreference: pref
	| list selected aMenu |
	list := pref categoryList.
	list size < 1 ifTrue:[^self inform: 'Oops - this preference has no categories???'].
	list size < 2 ifTrue:[^categories selection: list first].
	aMenu := CMenu new.
	aMenu label: 'Category?'.
	selected := aMenu chooseFrom: (list collect:[:each| {each. each}]).
	selected ifNotNil:[categories selection: selected].! !

!CPreferencesTool methodsFor: 'initialize' stamp: 'ar 12/22/2004 19:44'!
initialize
	super initialize.
	self define: #categories as: CStringList new.
	self define: #contents as: CScrollPane new.
	self define: #searchPane as: CPlayer new.
	self define: #searchLabel as: CLabel new.
	self define: #searchField as: CInputField new.
	self define: #searchButton as: CPushButton new.
	self define: #prefList as: CHolder new.
	self define: #buttonRow as: CHolder new.
	categories addAll: self listOfCategories.! !

!CPreferencesTool methodsFor: 'events' stamp: 'ar 12/19/2004 10:08'!
listOfCategories
	| names |
	names := Set new.
	Preferences allPreferenceObjects do:[:pref|
		names addAll: (pref categoryList collect: [:n | n asSymbol])
	].
	^names asSortedArray! !

!CPreferencesTool methodsFor: 'initialize' stamp: 'ar 12/19/2004 11:36'!
makeSearchPane
	"create the search pane"
	| row |
	row := CPlayer new.
	row hResizing: #spaceFill; vResizing: #spaceFill.
	row layout: CTableLayout new.
	row layout listDirection: #leftToRight.
	row layoutInset: 10@10.

	searchLabel value: 'Find: ' asText allBold.
	searchLabel hResizing: #shrinkWrap.
	row addLast: searchLabel.

	searchField := CInputField new.
	searchField hResizing: #spaceFill; vResizing: #spaceFill.
	row addLast: searchField.

	searchButton width: 20; height: 20.
	searchButton font: (TextStyle named: #WindowFont) defaultFont.
	searchButton label: 'R'.
	row addLast: searchButton.

	searchPane add: row.

	self startScript: #onFindPref when:{
		searchField. #accept.
		searchButton. #fire.
	}.! !

!CPreferencesTool methodsFor: 'events' stamp: 'ar 12/19/2004 11:20'!
offerContextMenu: prefCostume
	| pref aMenu item |
	pref := prefCostume preference.
	aMenu := CMenu new.
	aMenu label: pref name.

	(Preferences okayToChangeProjectLocalnessOf: pref name) ifTrue:[
		item := aMenu add: 'project local' target: pref action: #toggleProjectLocalness.
		item balloonHelp: 'Some preferences are best applied uniformly to all projects, and others are best set by each individual project.  If this item is checked, then this preference will be printed in bold and will have a separate value for each project'.
		item checked: pref localToProject.
	].
	item := aMenu add: 'browse senders' target: Smalltalk action: #browseAllCallsOn: argument: pref name.
	item balloonHelp: 'This will open a method-list browser on all methods that the send the preference "', pref name, '".'.
	item := aMenu add: 'show category...' target: self action: #findCategoryFromPreference: argument: pref.
	item balloonHelp: 'Allows you to find out which category, or categories, this preference belongs to.'.

	item := aMenu add: 'hand me a button' target: self action: #tearOffButton: argument: pref.
	item balloonHelp: 'Will give you a button that governs this preference, which you may deposit wherever you wish'.

	item := aMenu add: 'copy this name to clipboard' target: self action: #copyName: argument: pref.
	item balloonHelp: 'Copy the name of the preference to the text clipboard, so that you can paste into code somewhere'.

	aMenu openAt: hand position.! !

!CPreferencesTool methodsFor: 'events' stamp: 'ar 12/19/2004 11:21'!
onCategoryChanged
	| match |
	<on: cursorChanged in: categories>
	categories cursor = 0 ifTrue:[
		prefList removeAll.
	] ifFalse:[
		match := categories selection.
		self showPreferences:
			(Preferences allPreferenceObjects 
				select:[:pref| pref categoryList includes: match]).
	].! !

!CPreferencesTool methodsFor: 'events' stamp: 'ar 12/19/2004 10:52'!
onFindPref
	| result prefs |
	result := searchField text asString asLowercase.
	result := result asLowercase withBlanksTrimmed.
	result isEmptyOrNil ifTrue: [^ self].
	prefs := Preferences allPreferenceObjects select:[:pref | 
			(pref name includesSubstring: result caseSensitive: false) or:
				[pref helpString includesSubstring: result caseSensitive: false]].
	self showPreferences: prefs.! !

!CPreferencesTool methodsFor: 'accessing' stamp: 'ar 12/19/2004 10:35'!
prefList
	"Answer the prefList of the receiver"
	<bewareOf: #prefListChanged>
	^self propertyValueAt: #prefList! !

!CPreferencesTool methodsFor: 'accessing' stamp: 'ar 12/19/2004 10:35'!
prefList: aValue
	"Modify the receiver's prefList"
	^self propertyValueAt: #prefList put: aValue with: #prefListChanged! !

!CPreferencesTool methodsFor: 'accessing' stamp: 'ar 12/19/2004 10:29'!
searchButton
	"Answer the searchButton of the receiver"
	<bewareOf: #searchButtonChanged>
	^self propertyValueAt: #searchButton! !

!CPreferencesTool methodsFor: 'accessing' stamp: 'ar 12/19/2004 10:29'!
searchButton: aValue
	"Modify the receiver's searchButton"
	^self propertyValueAt: #searchButton put: aValue with: #searchButtonChanged! !

!CPreferencesTool methodsFor: 'accessing' stamp: 'ar 12/19/2004 10:28'!
searchField
	"Answer the searchField of the receiver"
	<bewareOf: #searchFieldChanged>
	^self propertyValueAt: #searchField! !

!CPreferencesTool methodsFor: 'accessing' stamp: 'ar 12/19/2004 10:28'!
searchField: aValue
	"Modify the receiver's searchField"
	^self propertyValueAt: #searchField put: aValue with: #searchFieldChanged! !

!CPreferencesTool methodsFor: 'accessing' stamp: 'ar 12/19/2004 10:29'!
searchLabel
	"Answer the searchLabel of the receiver"
	<bewareOf: #searchLabelChanged>
	^self propertyValueAt: #searchLabel! !

!CPreferencesTool methodsFor: 'accessing' stamp: 'ar 12/19/2004 10:29'!
searchLabel: aValue
	"Modify the receiver's searchLabel"
	^self propertyValueAt: #searchLabel put: aValue with: #searchLabelChanged! !

!CPreferencesTool methodsFor: 'accessing' stamp: 'ar 12/19/2004 10:13'!
searchPane
	"Answer the searchPane of the receiver"
	<bewareOf: #searchPaneChanged>
	^self propertyValueAt: #searchPane! !

!CPreferencesTool methodsFor: 'accessing' stamp: 'ar 12/19/2004 10:13'!
searchPane: aValue
	"Modify the receiver's searchPane"
	^self propertyValueAt: #searchPane put: aValue with: #searchPaneChanged! !

!CPreferencesTool methodsFor: 'initialize' stamp: 'ar 5/26/2005 20:17'!
setupCostume
	| frm |
	super setupCostume.
	self extent: 350@350.
	self hResizing: #rigid; vResizing: #rigid.
	self layout := CProportionalLayout new.
	self label: 'Preferences'.

	categories hResizing: #spaceFill; vResizing: #spaceFill.
	categories width: 100.
	categories allowDeselect: true.
	categories layoutFrame: (frm := CLayoutFrame new).
	frm leftOffset: 0; leftFraction: 0.0.
	frm topOffset: 0; topFraction: 0.0.
	frm rightOffset: 0; rightFraction: 100 / 350.
	frm bottomOffset: 0; bottomFraction: 1.0.
	self add: categories.

	contents hResizing: #spaceFill; vResizing: #spaceFill.
	contents hScrollable: false; vScrollable: nil.
	contents layout: CTableLayout new.
	contents layoutFrame: (frm := CLayoutFrame new).
	frm leftOffset: 0; leftFraction: 100/350.
	frm topOffset: 0; topFraction: 0.0.
	frm rightOffset: 0; rightFraction: 1.0.
	frm bottomOffset: 0; bottomFraction: 1.0.
	self add: contents.

	self makeSearchPane.
	searchPane layout: CTableLayout new.
	searchPane hResizing: #spaceFill; vResizing: #shrinkWrap.
	contents add: searchPane.

	prefList layout: CTableLayout new.
	prefList hResizing: #spaceFill; vResizing: #shrinkWrap.
	prefList layoutInset: 10@10.
	contents add: prefList.
false ifTrue:[
	buttonRow layout: CTableLayout new.
	buttonRow layout listDirection: #leftToRight.
	buttonRow layoutFrame: (frm := CLayoutFrame new).
	frm leftOffset: 0; leftFraction: 0.0.
	frm rightOffset: 0; rightFraction: 1.0.
	frm bottomOffset: 0; bottomFraction: 1.0.
	buttonRow hResizing: #spaceFill; vResizing: #rigid.
	buttonRow height: 30.
	self addButtons.
	self add: buttonRow.
].
	self decorate: elements color: self defaultWindowColor.! !

!CPreferencesTool methodsFor: 'events' stamp: 'ar 5/29/2005 19:04'!
showPreferences: prefs
	| cc |
	prefList removeAll.
	(prefs asArray sort:[:p1 :p2| p1 name <= p2 name]) do:[:pref|
		cc := CPreferenceCostume new.
		cc preference: pref.
		cc value: pref preferenceValue. "check box defaults to false so must set explicitly"
		cc menuHolder: self.
		prefList add: cc.
	].
! !

!CPreferencesTool methodsFor: 'events' stamp: 'ar 5/29/2005 19:04'!
tearOffButton: pref
	"tear off a button"
	| cc |
	cc := CPreferenceCostume new.
	cc preference: pref.
	cc value: pref preferenceValue. "check box defaults to false so must set explicitly"
	cc color: Color white.
	cc borderWidth: 1; borderColor: Color black; borderStyle: #simple.
	cc roundCorners: true.
	cc layoutInset: 3@0.
	cc openInHand.! !

CPanel subclass: #CSimpleTextEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Tools-DocEditor'!

!CSimpleTextEditor commentStamp: 'tk 2/28/2005 13:30' prior: 0!
A Simple Text is a place to write text.  It wears a window costume, which is different from the Text Editor widget.  Get a Simple Text from the Tools menu of the menu bar.[general]


### Allow Users to see the above explanation ###!

CSimpleTextEditor defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="editor" toSet="editor:" changeEvent="editorChanged">editor</field>
</fields>'!

!CSimpleTextEditor class methodsFor: 'class initialization' stamp: 'ar 1/22/2005 22:46'!
initialize
	"self initialize"
	self registerOpenCommand.
! !

!CSimpleTextEditor class methodsFor: 'class initialization' stamp: 'ar 1/22/2005 22:45'!
registerOpenCommand
	"self initialize"
	Smalltalk at: #CProjectBuilder ifPresent:[:pb|
		pb registerOpenCommand: {'SimpleText'. {self. #open}}.
	].! !

!CSimpleTextEditor methodsFor: 'initialize' stamp: 'ar 5/26/2005 20:18'!
defaultWindowColor
	^Color r: 0.995 g: 0.788 b: 0.353! !

!CSimpleTextEditor methodsFor: 'accessing' stamp: 'ar 4/5/2004 02:11'!
editor
	"Answer the editor of the receiver"
	<bewareOf: #editorChanged>
	^self propertyValueAt: #editor! !

!CSimpleTextEditor methodsFor: 'accessing' stamp: 'ar 4/5/2004 02:11'!
editor: aValue
	"Modify the receiver's editor"
	^self propertyValueAt: #editor put: aValue with: #editorChanged! !

!CSimpleTextEditor methodsFor: 'initialize' stamp: 'ar 2/7/2005 01:01'!
initialize
	super initialize.
	"Define our components"
	self define: #editor as: CTextEditor new.! !

!CSimpleTextEditor methodsFor: 'initialize' stamp: 'ar 5/26/2005 20:18'!
setupCostume
	"Create the default costume"
	super setupCostume.

	self extent: 400@265.
	self layout: CProportionalLayout new.

	editor color: Color white.
	editor layoutFrame: (0@0 corner: 1@1).
	editor hResizing: #spaceFill; vResizing: #spaceFill.
	editor textWrap: true.
	editor hScrollable: false; vScrollable: true.
	self add: editor.

	"Give all of my contents the default look"
	self decorate: elements color: self defaultWindowColor.
	self label: 'SimpleText'.! !

CPanel subclass: #CTrashTool
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Tools-Trash'!

!CTrashTool commentStamp: 'sw 5/1/2005 05:02' prior: 0!
A tool for viewing and manipulating the trash associated with a project.  In this first version, items in the trash can only be viewed iconically, but list views are also planned.!

CTrashTool defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="controlsPane" toSet="controlsPane:" changeEvent="controlsPaneChanged">controlsPane</field>
	<field toGet="itemsPane" toSet="itemsPane:" changeEvent="itemsPaneChanged">itemsPane</field>
	<field toGet="emptyTrashButton" toSet="emptyTrashButton:" changeEvent="emptyTrashButtonChanged">emptyTrashButton</field>
	<field toGet="byIconButton" toSet="byIconButton:" changeEvent="byIconButtonChanged">byIconButton</field>
	<field toGet="trashManager" toSet="trashManager:" changeEvent="trashManagerChanged">trashManager</field>
</fields>'!

!CTrashTool class methodsFor: 'class initialization' stamp: 'sw 4/30/2005 21:19'!
initialize
	"Initialize the receiver"

	self registerOpenCommand

"CTrashTool initialize"! !

!CTrashTool class methodsFor: 'class initialization' stamp: 'sw 4/30/2005 21:18'!
registerOpenCommand
	"Register me in the tools menu"

	Smalltalk at: #CProjectBuilder ifPresent:  [:pb |
		pb registerOpenCommand:  {
			'Trash'.
			{ self. #open. }.
			'Discarded items'. }]

"CTrashTool initialize"
! !

!CTrashTool methodsFor: 'initialization' stamp: 'sw 4/29/2005 03:58'!
addControls
	"Add widgets to the pane up at the top of the tool"

	emptyTrashButton layout: CTableLayout new.
	emptyTrashButton layout hResizing: #spaceFill; vResizing: #spaceFill.
	emptyTrashButton label: 'Empty Trash' translated.
	controlsPane add: emptyTrashButton.
"
	byIconButton hResizing: #spaceFill; vResizing: #spaceFill.
	byIconButton label: 'by icon'.
	controlsPane add: byIconButton."! !

!CTrashTool methodsFor: 'accessing' stamp: 'sw 4/29/2005 02:02'!
byIconButton
	"Answer the byIconButton of the receiver"
	<bewareOf: #byIconButtonChanged>
	^self propertyValueAt: #byIconButton! !

!CTrashTool methodsFor: 'accessing' stamp: 'sw 4/29/2005 02:02'!
byIconButton: aValue
	"Modify the receiver's byIconButton"
	^self propertyValueAt: #byIconButton put: aValue with: #byIconButtonChanged! !

!CTrashTool methodsFor: 'accessing' stamp: 'sw 4/28/2005 16:06'!
controlsPane
	"Answer the controlsPane of the receiver"
	<bewareOf: #controlsPaneChanged>
	^self propertyValueAt: #controlsPane! !

!CTrashTool methodsFor: 'accessing' stamp: 'sw 4/28/2005 16:06'!
controlsPane: aValue
	"Modify the receiver's controlsPane"
	^self propertyValueAt: #controlsPane put: aValue with: #controlsPaneChanged! !

!CTrashTool methodsFor: 'accessing' stamp: 'sw 4/29/2005 02:02'!
emptyTrashButton
	"Answer the emptyTrashButton of the receiver"
	<bewareOf: #emptyTrashButtonChanged>
	^self propertyValueAt: #emptyTrashButton! !

!CTrashTool methodsFor: 'accessing' stamp: 'sw 4/29/2005 02:02'!
emptyTrashButton: aValue
	"Modify the receiver's emptyTrashButton"
	^self propertyValueAt: #emptyTrashButton put: aValue with: #emptyTrashButtonChanged! !

!CTrashTool methodsFor: 'initialization' stamp: 'ar 6/19/2005 12:12'!
initialize
	"Initialize a trash tool."
	super initialize.
	trashManager := self project trashManager.
	self define: #controlsPane as: CHolder new.
	self define: #itemsPane as: CScrollPane new.
	self define: #emptyTrashButton as: CPushButton new.
	self define: #byIconButton as: CCheckBox new.
! !

!CTrashTool methodsFor: 'accessing' stamp: 'sw 4/28/2005 23:51'!
itemsPane
	"Answer the itemsPane of the receiver"
	<bewareOf: #itemsPaneChanged>
	^self propertyValueAt: #itemsPane! !

!CTrashTool methodsFor: 'accessing' stamp: 'sw 4/28/2005 23:51'!
itemsPane: aValue
	"Modify the receiver's itemsPane"
	^self propertyValueAt: #itemsPane put: aValue with: #itemsPaneChanged! !

!CTrashTool methodsFor: 'events' stamp: 'sw 4/30/2005 22:11'!
onActivate
	"When activated, make my icon-bed color a bright white."

	<on: activate>
	itemsPane color: Color white! !

!CTrashTool methodsFor: 'events' stamp: 'ar 5/28/2005 19:33'!
onDrop: aPlayer
	"Accept a dropped object."

	<on: dragDrop>
	aPlayer close.
	trashManager addToTrash: aPlayer.
	aPlayer signal: #dropAccept with: self
! !

!CTrashTool methodsFor: 'events' stamp: 'ar 5/28/2005 19:33'!
onEmptyTrashButtonHit
	"Empty the trash when the user hits the empty-trash button."

	<on: fire in: emptyTrashButton>
	trashManager emptyTrash! !

!CTrashTool methodsFor: 'events' stamp: 'ar 6/1/2005 12:01'!
onOpened
	"Get the initial contents of the project's trash into the receiver."

	<on: opened>
	trashManager ifNotNil:[self onTrashChanged].! !

!CTrashTool methodsFor: 'events' stamp: 'sw 5/1/2005 04:41'!
onPassivate
	"When deactivating, darken the background."

	<on: passivate>
	itemsPane color:  (Color r: 1.0 g: 0.968 b: 0.903)! !

!CTrashTool methodsFor: 'events' stamp: 'ar 5/28/2005 19:31'!
onTrashChanged
	"Upon drop over my items pane, accept the proffered object"

	| occupant |
	<on: trashChanged in: trashManager>
	itemsPane removeAll.
	itemsPane addAll: (trashManager discardedPlayers collect: [:item | 
		occupant := CTrashOccupant for: item.
		occupant trashManager: trashManager.
		occupant]).! !

!CTrashTool methodsFor: 'initialization' stamp: 'ar 5/26/2005 20:18'!
setupCostume
	"Set up the receiver's costume."

	super setupCostume.
	self extent:  220@260.
	self hResizing: #rigid; vResizing: #rigid.
	self layout := CTableLayout new.
	layout listDirection: #topToBottom.
	self label: 'Trash'.

	controlsPane layout: CTableLayout new.
	controlsPane layout listDirection: #leftToRight.
	controlsPane hResizing: #spaceFill; vResizing: #rigid.
	controlsPane height: 30.
	self addControls.
	self add: controlsPane.

	itemsPane hResizing: #spaceFill; vResizing: #spaceFill.
	itemsPane hScrollable: false; vScrollable: nil.
	itemsPane layout: CTableLayout new.
	itemsPane layout listDirection: #leftToRight; wrapDirection: #topToBottom.
	self addLast: itemsPane.

	self decorate: elements color: self defaultWindowColor.! !

!CTrashTool methodsFor: 'accessing' stamp: 'ar 5/28/2005 22:08'!
trashManager
	"Answer the trashManager of the receiver"
	<bewareOf: #trashManagerChanged>
	^self propertyValueAt: #trashManager! !

!CTrashTool methodsFor: 'accessing' stamp: 'ar 5/28/2005 22:08'!
trashManager: aValue
	"Modify the receiver's trashManager"
	^self propertyValueAt: #trashManager put: aValue with: #trashManagerChanged! !

CObject subclass: #CPartDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Tools-PartsBin'!

!CPartDescription commentStamp: 'sw 2/8/2005 04:29' prior: 0!
A description of a 'part' that can be dragged out from a parts bin.
This is the basic unit of registry.  Any CObject class can register to have its instances be obtainable from the parts bin by implementing #descriptionForPartsBin; the implementation will return an instance of CPartDescription holding the salient informtion.

	label is the string by which the part should be known.
	balloonHelp	is a string to be offered as balloon-help to the user
	categories is a list of categories in which the part wishes to be listed
	creator is the object (or the classname of the object) to which to send the...
	selector   ...in order to obtain a newborn object.
	labeledIconForm is a form containing the labeled icon 
	newbornInstanceForm holds a picture to use when the user drags a precorsor for me.!

CPartDescription defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="label" toSet="label:" changeEvent="labelChanged">label</field>
	<field toGet="balloonHelp" toSet="balloonHelp:" changeEvent="balloonHelpChanged">balloonHelp</field>
	<field toGet="categories" toSet="categories:" changeEvent="categoriesChanged">categories</field>
	<field toGet="creator" toSet="creator:" changeEvent="creatorChanged">creator</field>
	<field toGet="selector" toSet="selector:" changeEvent="selectorChanged">selector</field>
	<field toGet="labeledIconForm" toSet="labeledIconForm:" changeEvent="labeledIconFormChanged">labeledIconForm</field>
	<field toGet="newbornInstanceForm" toSet="newbornInstanceForm:" changeEvent="newbornInstanceFormChanged">newbornInstanceForm</field>
</fields>'!

!CPartDescription class methodsFor: 'instance creation' stamp: 'sw 2/6/2005 03:41'!
partDescriptionWithLabel: aLabel balloonHelp: helpString category: categoryInfo creator: aCreator selector: aSelector customForm: aForm
	"Answer a description for use in parts bins"

	^ self new label: aLabel balloonHelp: helpString category: categoryInfo creator: aCreator selector: aSelector customForm: aForm! !

!CPartDescription methodsFor: 'accessing' stamp: 'sw 1/25/2005 17:40'!
balloonHelp
	"Answer the balloonHelp of the receiver"
	<bewareOf: #balloonHelpChanged>

	^ self propertyValueAt: #balloonHelp! !

!CPartDescription methodsFor: 'accessing' stamp: 'sw 1/25/2005 17:43'!
balloonHelp: aValue
	"Modify the receiver's balloonHelp"

	self propertyValueAt: #balloonHelp put: aValue with: #balloonHelpChanged! !

!CPartDescription methodsFor: 'accessing' stamp: 'sw 1/20/2005 23:25'!
categories
	"Answer the categories of the receiver"
	<bewareOf: #categoriesChanged>
	^self propertyValueAt: #categories! !

!CPartDescription methodsFor: 'accessing' stamp: 'sw 1/20/2005 23:25'!
categories: aValue
	"Modify the receiver's categories"
	^self propertyValueAt: #categories put: aValue with: #categoriesChanged! !

!CPartDescription methodsFor: 'transition' stamp: 'sw 2/6/2005 02:42'!
categoryNamed: existing changedTo: new
	"The user requested that a given category name be changed to a different one..."

	(categories includes: existing)
		ifTrue:
			[categories replace: existing with: new]! !

!CPartDescription methodsFor: 'accessing' stamp: 'sw 1/24/2005 01:21'!
creator
	"Answer the creator of the receiver"
	<bewareOf: #creatorChanged>
	^self propertyValueAt: #creator! !

!CPartDescription methodsFor: 'accessing' stamp: 'sw 1/24/2005 01:21'!
creator: aValue
	"Modify the receiver's creator"
	^self propertyValueAt: #creator put: aValue with: #creatorChanged! !

!CPartDescription methodsFor: 'initialize' stamp: 'sw 1/24/2005 18:17'!
initialize
	"Initialize the receiver"

	super initialize.
	self define: #label as: CLabel new.
	self define: #categories as: CStringList new! !

!CPartDescription methodsFor: 'accessing' stamp: 'sw 1/24/2005 01:19'!
label
	"Answer the label of the receiver"
	<bewareOf: #labelChanged>
	^self propertyValueAt: #label! !

!CPartDescription methodsFor: 'accessing' stamp: 'sw 1/24/2005 01:19'!
label: aValue
	"Modify the receiver's label"
	^self propertyValueAt: #label put: aValue with: #labelChanged! !

!CPartDescription methodsFor: 'initialize' stamp: 'mtf 2/2/2011 21:41'!
label: labelString balloonHelp: helpString category: categoryInfo creator: creatorObject selector: nativitySelector customForm: customForm
	"Initialize a new instance of the receiver to have the properties indicated.  Details:
		(a)  the 'categoryInfo' parameter can be a single string or a list of strings
		(b)  if a custom form is provided, it is used to create the graphic; otherwise,
				the graphic is created by launching a new object as per the creatorObject
				and nativitySelector parameters and capturing its appearance."
	
	label := labelString asString.
	balloonHelp := helpString.
	categories addAll:((categoryInfo isKindOf: String)
			ifTrue:
				[Array with: categoryInfo asSymbol]
			ifFalse:
				[categoryInfo collect: [:i | i asSymbol]]).
	creator := Smalltalk globals keyAtValue: creatorObject ifAbsent: [creatorObject].
	selector := nativitySelector.

	self rebuildGraphicFrom: customForm! !

!CPartDescription methodsFor: 'accessing' stamp: 'sw 2/4/2005 00:26'!
labeledIconForm
	"Answer the labeledIconForm of the receiver"
	<bewareOf: #labeledIconFormChanged>
	^self propertyValueAt: #labeledIconForm! !

!CPartDescription methodsFor: 'accessing' stamp: 'sw 2/4/2005 00:26'!
labeledIconForm: aValue
	"Modify the receiver's labeledIconForm"
	^self propertyValueAt: #labeledIconForm put: aValue with: #labeledIconFormChanged! !

!CPartDescription methodsFor: 'part launching' stamp: 'sw 2/7/2005 03:28'!
newInstanceIn: aContainer
	"Answer an instance of the part I represent, given that it has been, or will be,dropped into the given container"

	| actualCreator |
	actualCreator := Smalltalk at: creator ifAbsent: [creator].
	^ selector numArgs = 0
		ifTrue:
			[actualCreator perform: selector]
		ifFalse:
			[actualCreator perform: selector with: aContainer]! !

!CPartDescription methodsFor: 'part launching' stamp: 'sw 2/7/2005 03:28'!
newPartInstance
	"Answer a new instance of the part I represent"

	^ self newInstanceIn: nil! !

!CPartDescription methodsFor: 'part launching' stamp: 'sw 2/4/2005 00:48'!
newPartPrecursor
	"Answer a PartPrecursor for the part I represent"

	| anInstance |
	anInstance := CPartPrecursor new.
	anInstance partDescription: self.
	^ anInstance
	! !

!CPartDescription methodsFor: 'accessing' stamp: 'sw 2/4/2005 00:26'!
newbornInstanceForm
	"Answer the newbornInstanceForm of the receiver"
	<bewareOf: #newbornInstanceFormChanged>
	^self propertyValueAt: #newbornInstanceForm! !

!CPartDescription methodsFor: 'accessing' stamp: 'sw 2/4/2005 00:26'!
newbornInstanceForm: aValue
	"Modify the receiver's newbornInstanceForm"
	^self propertyValueAt: #newbornInstanceForm put: aValue with: #newbornInstanceFormChanged! !

!CPartDescription methodsFor: 'debugging' stamp: 'sw 2/1/2005 02:05'!
printOn: aStream
	"Print the receiver on a stream"

	aStream nextPutAll: 'CPartDescription: ', label! !

!CPartDescription methodsFor: 'accessing' stamp: 'sw 6/12/2005 18:58'!
rebuildGraphicFrom: aForm
	"Rebuild the graphic for the part, possibly deploying a custom form"

	| unlabeledForm |
	newbornInstanceForm := aForm ifNil: [self newPartInstance asForm].
	unlabeledForm := CPartIcon thumbnailFormFrom: newbornInstanceForm.
	labeledIconForm := CPartIcon labeledFormFromThumbnail: unlabeledForm withLabel: label! !

!CPartDescription methodsFor: 'accessing' stamp: 'sw 4/26/2005 03:35'!
rebuildNewbornInstanceForm
	"Rebuild the newbornInstanceForm by launching a new instance, grabbing its bits, then deleting the instance"

	| anInstance |
	anInstance := self newPartInstance.
	(anInstance propertyValueAt: #useCustomForm) ifNotNil:
		[newbornInstanceForm ifNotNil: [^ self]].
	"The above assures that classes that wish maintain a custom form will not have  it clobbered at this phase"

	anInstance open.
	anInstance fullBounds; waitTick.
	self rebuildGraphicFrom: anInstance asForm.
	anInstance destroy! !

!CPartDescription methodsFor: 'accessing' stamp: 'sw 1/24/2005 01:21'!
selector
	"Answer the selector of the receiver"
	<bewareOf: #selectorChanged>
	^self propertyValueAt: #selector! !

!CPartDescription methodsFor: 'accessing' stamp: 'sw 1/24/2005 01:21'!
selector: aValue
	"Modify the receiver's selector"
	^self propertyValueAt: #selector put: aValue with: #selectorChanged! !

CObject subclass: #CTrashManager
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Tools-Trash'!

CTrashManager defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="project" toSet="project:" changeEvent="projectChanged">project</field>
	<field toGet="discardedPlayers" toSet="discardedPlayers:" changeEvent="discardedPlayersChanged">discardedPlayers</field>
</fields>'!

!CTrashManager methodsFor: 'trash handling' stamp: 'ar 6/25/2005 15:16'!
addToTrash: aPlayer
	"Add a player to the discarded players list"

	| discards |
	((discards := self discardedPlayers) includes: aPlayer) ifFalse:[
		aPlayer userDataAt: #discardedAt put: TimeStamp current.
		discards addLast: aPlayer.
		self signal: #trashChanged.
	].
	self assureTrashCanShows! !

!CTrashManager methodsFor: 'trash handling' stamp: 'ar 5/28/2005 22:26'!
assureTrashCanShows
	"Assure that a trashcan is showing in the project"
	| trash |
	trash := project world elements detect: [:d | d isKindOf: CTrashCan].
	trash ifNotNil:[^trash beOnScreen; comeToFront]. "make sure it shows"
	"Create new trash can"
	trash := CTrashCan open.
	trash trashManager: self.
	trash bottomLeft: project world localBounds bottomLeft + (10 @ -10).
! !

!CTrashManager methodsFor: 'accessing' stamp: 'ar 5/28/2005 22:24'!
discardedPlayers
	"Answer the discardedPlayers of the receiver"
	<bewareOf: #discardedPlayersChanged>
	^self propertyValueAt: #discardedPlayers! !

!CTrashManager methodsFor: 'accessing' stamp: 'ar 5/28/2005 22:24'!
discardedPlayers: aValue
	"Modify the receiver's discardedPlayers"
	^self propertyValueAt: #discardedPlayers put: aValue with: #discardedPlayersChanged! !

!CTrashManager methodsFor: 'trash handling' stamp: 'ar 5/28/2005 22:25'!
emptyTrash
	"Clear the project's memory of all discarded items"
	discardedPlayers := OrderedCollection new.
	self signal: #trashChanged! !

!CTrashManager methodsFor: 'initialize' stamp: 'ar 5/28/2005 22:24'!
initialize
	super initialize.
	discardedPlayers := OrderedCollection new.! !

!CTrashManager methodsFor: 'accessing' stamp: 'ar 5/28/2005 22:26'!
project
	"Answer the project of the receiver"
	<bewareOf: #projectChanged>
	^self propertyValueAt: #project! !

!CTrashManager methodsFor: 'accessing' stamp: 'ar 5/28/2005 22:26'!
project: aValue
	"Modify the receiver's project"
	^self propertyValueAt: #project put: aValue with: #projectChanged! !

!CTrashManager methodsFor: 'trash handling' stamp: 'ar 6/25/2005 15:17'!
removeFromTrash: aPlayer
	"Remove a player from the trash.  This could be because the final plug is being pulled on it or because the object is being revived back into the world"
	| discards |
	((discards := self discardedPlayers) includes: aPlayer) ifTrue:[
		(aPlayer userData) ifNotNilDo:[:dict| dict removeKey: #discardedAt ifAbsent:[]].
		discards remove: aPlayer.
		self signal: #trashChanged]! !

CColorPicker subclass: #CMultiColorPicker
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Tools-ColorTool'!

CMultiColorPicker defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!CMultiColorPicker methodsFor: 'events' stamp: 'ar 3/13/2004 23:30'!
onColorsChanged
	self value: (colorValues collect:[:each| each value]).! !

!CMultiColorPicker methodsFor: 'events' stamp: 'ar 3/13/2004 23:14'!
onValueChanged
	<on: valueChanged>
	self colors: self value.! !

!CMultiColorPicker methodsFor: 'private' stamp: 'ar 3/13/2004 23:23'!
setupPicker
	colorValues := #().
	self value: (Array with: Color white).! !

CCheckBox subclass: #CPreferenceCostume
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Tools-PrefTool'!

!CPreferenceCostume commentStamp: 'ar 12/19/2004 10:47' prior: 0!
A view for preferences. Also usable in lists.!

CPreferenceCostume defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="preference" toSet="preference:" changeEvent="preferenceChanged">preference</field>
	<field toGet="menuHolder" toSet="menuHolder:" changeEvent="menuHolderChanged">menuHolder</field>
</fields>'!

!CPreferenceCostume methodsFor: 'accessing' stamp: 'ar 12/19/2004 10:34'!
listItemValue: pref
	preference := pref.! !

!CPreferenceCostume methodsFor: 'accessing' stamp: 'ar 12/19/2004 10:59'!
menuHolder
	"Answer the menuHolder of the receiver"
	<bewareOf: #menuHolderChanged>
	^self propertyValueAt: #menuHolder! !

!CPreferenceCostume methodsFor: 'accessing' stamp: 'ar 12/19/2004 10:59'!
menuHolder: aValue
	"Modify the receiver's menuHolder"
	^self propertyValueAt: #menuHolder put: aValue with: #menuHolderChanged! !

!CPreferenceCostume methodsFor: 'events' stamp: 'ar 12/19/2004 10:59'!
onContextMenu
	<on: yellowButtonDown>
	menuHolder ifNotNil:[menuHolder offerContextMenu: self].! !

!CPreferenceCostume methodsFor: 'events' stamp: 'ar 3/11/2005 21:05'!
onPreferenceChanged
	<on: preferenceChanged>
	label := preference name.
	preference localToProject ifTrue:[textEmphasis := 1].
	balloonHelp := preference helpString.
	value := preference preferenceValue.
! !

!CPreferenceCostume methodsFor: 'events' stamp: 'ar 3/11/2005 21:05'!
onValueChanged
	<on: valueChanged>
	super onValueChanged.
	preference preferenceValue: value.! !

!CPreferenceCostume methodsFor: 'accessing' stamp: 'ar 12/19/2004 10:33'!
preference
	"Answer the preference of the receiver"
	<bewareOf: #preferenceChanged>
	^self propertyValueAt: #preference! !

!CPreferenceCostume methodsFor: 'accessing' stamp: 'ar 12/19/2004 10:33'!
preference: aValue
	"Modify the receiver's preference"
	^self propertyValueAt: #preference put: aValue with: #preferenceChanged! !

CPlayer subclass: #CBorderStyleReadout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Tools-ColorTool'!

CBorderStyleReadout defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!CBorderStyleReadout methodsFor: 'events' stamp: 'ar 3/24/2004 02:03'!
deselect
	self removeHighlight: #selectionHighlight.! !

!CBorderStyleReadout methodsFor: 'initialize' stamp: 'ar 12/19/2004 12:53'!
initialize
	super initialize.
	self extent: 20@20.
	self color: CWidgetLibrary default paneColor.
	self borderColor: CWidgetLibrary default frameColor.
	borderStyle := #simple.
	borderWidth := 4.! !

!CBorderStyleReadout methodsFor: 'events' stamp: 'tk 6/23/2004 10:52'!
onValueChanged
	<on: valueChanged>
	value ifNil:[^self].
	self borderStyle: value.
	value == #simple ifTrue:[
		color := Color transparent.
		borderWidth := 5.	"see it better when selected"
	].
	value == #none ifTrue:[
		color := Color transparent.
		borderWidth := 1.
		borderColor := Color gray.
		borderStyle := #simple.
	].! !

!CBorderStyleReadout methodsFor: 'events' stamp: 'ar 3/24/2004 02:01'!
select
	| highlight |
	highlight := CFramingHighlight new.
	highlight border: (CBorder width: 2 color: Color black).
	highlight name: #selectionHighlight.
	self addHighlight: highlight.! !

CPlayer subclass: #CButtonList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Tools-TextTool'!

!CButtonList commentStamp: 'tak 5/10/2005 11:39' prior: 0!
This is a holder where radio buttons are. This is almost a copy of CStyleReadoutList.
I don't think this is a good manner, and I wonder if it is integrated in CStyleReadoutList
or impremented as a subclass of CList...!

CButtonList defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="selection" toSet="selection:" changeEvent="selectionChanged">selection</field>
</fields>'!

!CButtonList methodsFor: 'events' stamp: 'tak 5/10/2005 11:13'!
onCursorChanged
	<on: cursorChanged in: elements>
	elements cursor = 0 ifTrue:[^self].
	selection ifNotNil:[selection deselect].
	selection := elements selection.
	selection ifNotNil:[selection select].
	value := selection value.
! !

!CButtonList methodsFor: 'events' stamp: 'tak 5/10/2005 11:30'!
onValueChanged
	<on: #valueChanged>
	elements
		selection: (elements
				findFirstElement: [:item | item value == value])! !

!CButtonList methodsFor: 'accessing' stamp: 'tak 5/10/2005 11:13'!
selection
	"Answer the selection of the receiver"
	<bewareOf: #selectionChanged>
	^self propertyValueAt: #selection! !

!CButtonList methodsFor: 'accessing' stamp: 'tak 5/10/2005 11:13'!
selection: aValue
	"Modify the receiver's selection"
	^self propertyValueAt: #selection put: aValue with: #selectionChanged! !

!CButtonList methodsFor: 'initialize' stamp: 'tak 5/10/2005 11:22'!
setupCostume
	super setupCostume.
	self layout: CTableLayout new.
! !

CPlayer subclass: #CColorToolBorderPage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Tools-ColorTool'!

CColorToolBorderPage defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="target" toSet="target:" changeEvent="targetChanged">target</field>
	<field toGet="borderStyleList" toSet="borderStyleList:" changeEvent="borderStyleListChanged">borderStyleList</field>
	<field toGet="borderColorChooser" toSet="borderColorChooser:" changeEvent="borderColorChooserChanged">borderColorChooser</field>
	<field toGet="borderWidthField" toSet="borderWidthField:" changeEvent="borderWidthFieldChanged">borderWidthField</field>
	<field toGet="label" toSet="label:" changeEvent="labelChanged">label</field>
</fields>'!

!CColorToolBorderPage methodsFor: 'accessing' stamp: 'ar 3/16/2004 22:22'!
borderColorChooser
	"Answer the borderColorChooser of the receiver"
	<bewareOf: #borderColorChooserChanged>
	^self propertyValueAt: #borderColorChooser! !

!CColorToolBorderPage methodsFor: 'accessing' stamp: 'ar 3/16/2004 22:22'!
borderColorChooser: aValue
	"Modify the receiver's borderColorChooser"
	^self propertyValueAt: #borderColorChooser put: aValue with: #borderColorChooserChanged! !

!CColorToolBorderPage methodsFor: 'accessing' stamp: 'ar 3/16/2004 22:22'!
borderStyleList
	"Answer the borderStyleList of the receiver"
	<bewareOf: #borderStyleListChanged>
	^self propertyValueAt: #borderStyleList! !

!CColorToolBorderPage methodsFor: 'accessing' stamp: 'ar 3/16/2004 22:22'!
borderStyleList: aValue
	"Modify the receiver's borderStyleList"
	^self propertyValueAt: #borderStyleList put: aValue with: #borderStyleListChanged! !

!CColorToolBorderPage methodsFor: 'accessing' stamp: 'ar 3/16/2004 22:22'!
borderWidthField
	"Answer the borderWidthField of the receiver"
	<bewareOf: #borderWidthFieldChanged>
	^self propertyValueAt: #borderWidthField! !

!CColorToolBorderPage methodsFor: 'accessing' stamp: 'ar 3/16/2004 22:22'!
borderWidthField: aValue
	"Modify the receiver's borderWidthField"
	^self propertyValueAt: #borderWidthField put: aValue with: #borderWidthFieldChanged! !

!CColorToolBorderPage methodsFor: 'initialize' stamp: 'ar 3/22/2004 14:40'!
initialize
	super initialize.
	self define: #label as: CLabel new.
	self define: #borderColorChooser as: CColorPicker new.
	self define: #borderWidthField as: CSpinner new.
	self define: #borderStyleList as: CStyleReadoutList new.
! !

!CColorToolBorderPage methodsFor: 'accessing' stamp: 'ar 3/16/2004 22:23'!
label
	"Answer the label of the receiver"
	<bewareOf: #labelChanged>
	^self propertyValueAt: #label! !

!CColorToolBorderPage methodsFor: 'accessing' stamp: 'ar 3/16/2004 22:23'!
label: aValue
	"Modify the receiver's label"
	^self propertyValueAt: #label put: aValue with: #labelChanged! !

!CColorToolBorderPage methodsFor: 'events' stamp: 'ar 3/16/2004 22:38'!
onTargetChanged
	<on: targetChanged>
	borderStyleList player: (target fieldNamed: #borderStyle).
	borderColorChooser player: (target fieldNamed: #borderColor).
	borderWidthField player: (target fieldNamed: #borderWidth).! !

!CColorToolBorderPage methodsFor: 'initialize' stamp: 'ar 12/19/2004 13:08'!
setupCostume
	super setupCostume.

	#(complexInset complexAltFramed complexAltRaised complexAltInset
	complexRaised complexFramed inset raised simple none
	framed inner outer) 
		do:[:style| borderStyleList add: (CBorderStyleReadout on: style)].
	borderStyleList height: 10.

	self layout: CTableLayout new.
	self hResizing: #rigid; vResizing: #rigid.
	self layout layoutInset: 4; cellInset: 2.
	self extent: 140@190.
		label value: 'Border:'.
	self add: label.
	self add: borderColorChooser.
		borderWidthField label: 'Width:'.
		borderWidthField vResizing: #rigid.
		borderWidthField height: 20.
	self add: borderWidthField.
	self add: borderStyleList.
! !

!CColorToolBorderPage methodsFor: 'accessing' stamp: 'ar 3/16/2004 22:22'!
target
	"Answer the target of the receiver"
	<bewareOf: #targetChanged>
	^self propertyValueAt: #target! !

!CColorToolBorderPage methodsFor: 'accessing' stamp: 'ar 3/16/2004 22:22'!
target: aValue
	"Modify the receiver's target"
	^self propertyValueAt: #target put: aValue with: #targetChanged! !

CPlayer subclass: #CColorToolFillPage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Tools-ColorTool'!

CColorToolFillPage defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="target" toSet="target:" changeEvent="targetChanged">target</field>
	<field toGet="fillStyleList" toSet="fillStyleList:" changeEvent="fillStyleListChanged">fillStyleList</field>
	<field toGet="fillColorChooser" toSet="fillColorChooser:" changeEvent="fillColorChooserChanged">fillColorChooser</field>
	<field toGet="fillAlphaField" toSet="fillAlphaField:" changeEvent="fillAlphaFieldChanged">fillAlphaField</field>
	<field toGet="fillAngleField" toSet="fillAngleField:" changeEvent="fillAngleFieldChanged">fillAngleField</field>
	<field toGet="label" toSet="label:" changeEvent="labelChanged">label</field>
</fields>'!

!CColorToolFillPage methodsFor: 'accessing' stamp: 'ar 3/16/2004 22:20'!
fillAlphaField
	"Answer the fillAlphaField of the receiver"
	<bewareOf: #fillAlphaFieldChanged>
	^self propertyValueAt: #fillAlphaField! !

!CColorToolFillPage methodsFor: 'accessing' stamp: 'ar 3/16/2004 22:20'!
fillAlphaField: aValue
	"Modify the receiver's fillAlphaField"
	^self propertyValueAt: #fillAlphaField put: aValue with: #fillAlphaFieldChanged! !

!CColorToolFillPage methodsFor: 'accessing' stamp: 'ar 3/16/2004 22:20'!
fillAngleField
	"Answer the fillAngleField of the receiver"
	<bewareOf: #fillAngleFieldChanged>
	^self propertyValueAt: #fillAngleField! !

!CColorToolFillPage methodsFor: 'accessing' stamp: 'ar 3/16/2004 22:20'!
fillAngleField: aValue
	"Modify the receiver's fillAngleField"
	^self propertyValueAt: #fillAngleField put: aValue with: #fillAngleFieldChanged! !

!CColorToolFillPage methodsFor: 'accessing' stamp: 'ar 3/16/2004 22:20'!
fillColorChooser
	"Answer the fillColorChooser of the receiver"
	<bewareOf: #fillColorChooserChanged>
	^self propertyValueAt: #fillColorChooser! !

!CColorToolFillPage methodsFor: 'accessing' stamp: 'ar 3/16/2004 22:20'!
fillColorChooser: aValue
	"Modify the receiver's fillColorChooser"
	^self propertyValueAt: #fillColorChooser put: aValue with: #fillColorChooserChanged! !

!CColorToolFillPage methodsFor: 'accessing' stamp: 'ar 3/16/2004 22:20'!
fillStyleList
	"Answer the fillStyleList of the receiver"
	<bewareOf: #fillStyleListChanged>
	^self propertyValueAt: #fillStyleList! !

!CColorToolFillPage methodsFor: 'accessing' stamp: 'ar 3/16/2004 22:20'!
fillStyleList: aValue
	"Modify the receiver's fillStyleList"
	^self propertyValueAt: #fillStyleList put: aValue with: #fillStyleListChanged! !

!CColorToolFillPage methodsFor: 'initialize' stamp: 'ar 3/22/2004 14:40'!
initialize
	super initialize.
	self define: #label as: CLabel new.
	self define: #fillColorChooser as: CMultiColorPicker new.
	self define: #fillStyleList as: CStyleReadoutList new.
	self define: #fillAlphaField as: CSpinner new.
	self define: #fillAngleField as: CSpinner new.
! !

!CColorToolFillPage methodsFor: 'accessing' stamp: 'ar 3/16/2004 22:23'!
label
	"Answer the label of the receiver"
	<bewareOf: #labelChanged>
	^self propertyValueAt: #label! !

!CColorToolFillPage methodsFor: 'accessing' stamp: 'ar 3/16/2004 22:23'!
label: aValue
	"Modify the receiver's label"
	^self propertyValueAt: #label put: aValue with: #labelChanged! !

!CColorToolFillPage methodsFor: 'events' stamp: 'ar 3/16/2004 22:37'!
onTargetChanged
	<on: targetChanged>
	fillStyleList player: (target fieldNamed: #fillStyle).
	fillColorChooser player: (target fieldNamed: #fillColors).
	fillAlphaField player: (target fieldNamed: #fillAlpha).
	fillAngleField player: (target fieldNamed: #fillAngle).! !

!CColorToolFillPage methodsFor: 'initialize' stamp: 'ar 4/30/2004 15:57'!
setupCostume
	#(radialGradient verticalGradient diagonalGradient horizontalGradient solid none) 
		do:[:style| fillStyleList add: (CFillStyleReadout on: style)].
	fillStyleList height: 10.
	self layout: CTableLayout new.
	self hResizing: #rigid; vResizing: #rigid.
	self layout layoutInset: 4; cellInset: 2.
		label value: 'Fill:'.
	self add: label.
	self add: fillColorChooser.
	self add: fillStyleList.
		fillAlphaField label: 'Fill Alpha:'.
		fillAlphaField min: 0.0.
		fillAlphaField max: 1.0.
		fillAlphaField step: 0.01.
		fillAlphaField vResizing: #rigid.
		fillAlphaField height: 20.
	self add: fillAlphaField.
		fillAngleField label: 'Fill Angle:'.
		fillAngleField min: -360.
		fillAngleField max: 360.
		fillAngleField vResizing: #rigid.
		fillAngleField height: 20.
	self add: fillAngleField.
! !

!CColorToolFillPage methodsFor: 'accessing' stamp: 'ar 3/16/2004 22:19'!
target
	"Answer the target of the receiver"
	<bewareOf: #targetChanged>
	^self propertyValueAt: #target! !

!CColorToolFillPage methodsFor: 'accessing' stamp: 'ar 3/16/2004 22:19'!
target: aValue
	"Modify the receiver's target"
	^self propertyValueAt: #target put: aValue with: #targetChanged! !

CPlayer subclass: #CColorToolFlagsPage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Tools-ColorTool'!

CColorToolFlagsPage defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="target" toSet="target:" changeEvent="targetChanged">target</field>
	<field toGet="roundedFlag" toSet="roundedFlag:" changeEvent="roundedFlagChanged">roundedFlag</field>
	<field toGet="lockedFlag" toSet="lockedFlag:" changeEvent="lockedFlagChanged">lockedFlag</field>
	<field toGet="shadowFlag" toSet="shadowFlag:" changeEvent="shadowFlagChanged">shadowFlag</field>
	<field toGet="floatingFlag" toSet="floatingFlag:" changeEvent="floatingFlagChanged">floatingFlag</field>
	<field toGet="visibleFlag" toSet="visibleFlag:" changeEvent="visibleFlagChanged">visibleFlag</field>
	<field toGet="stickyFlag" toSet="stickyFlag:" changeEvent="stickyFlagChanged">stickyFlag</field>
	<field toGet="clippingFlag" toSet="clippingFlag:" changeEvent="clippingFlagChanged">clippingFlag</field>
	<field toGet="infiniteFlag" toSet="infiniteFlag:" changeEvent="infiniteFlagChanged">infiniteFlag</field>
</fields>'!

!CColorToolFlagsPage methodsFor: 'accessing' stamp: 'ar 3/16/2004 22:11'!
clippingFlag
	"Answer the clippingFlag of the receiver"
	<bewareOf: #clippingFlagChanged>
	^self propertyValueAt: #clippingFlag! !

!CColorToolFlagsPage methodsFor: 'accessing' stamp: 'ar 3/16/2004 22:11'!
clippingFlag: aValue
	"Modify the receiver's clippingFlag"
	^self propertyValueAt: #clippingFlag put: aValue with: #clippingFlagChanged! !

!CColorToolFlagsPage methodsFor: 'accessing' stamp: 'ar 3/16/2004 22:10'!
floatingFlag
	"Answer the floatingFlag of the receiver"
	<bewareOf: #floatingFlagChanged>
	^self propertyValueAt: #floatingFlag! !

!CColorToolFlagsPage methodsFor: 'accessing' stamp: 'ar 3/16/2004 22:10'!
floatingFlag: aValue
	"Modify the receiver's floatingFlag"
	^self propertyValueAt: #floatingFlag put: aValue with: #floatingFlagChanged! !

!CColorToolFlagsPage methodsFor: 'accessing' stamp: 'ar 3/16/2004 22:11'!
infiniteFlag
	"Answer the infiniteFlag of the receiver"
	<bewareOf: #infiniteFlagChanged>
	^self propertyValueAt: #infiniteFlag! !

!CColorToolFlagsPage methodsFor: 'accessing' stamp: 'ar 3/16/2004 22:11'!
infiniteFlag: aValue
	"Modify the receiver's infiniteFlag"
	^self propertyValueAt: #infiniteFlag put: aValue with: #infiniteFlagChanged! !

!CColorToolFlagsPage methodsFor: 'initialize' stamp: 'ar 3/22/2004 14:40'!
initialize
	super initialize.
	self define: #roundedFlag as: CCheckBox new.
	self define: #lockedFlag as: CCheckBox new.
	self define: #shadowFlag as: CCheckBox new.
	self define: #floatingFlag as: CCheckBox new.
	self define: #visibleFlag as: CCheckBox new.
	self define: #stickyFlag as: CCheckBox new.
	self define: #clippingFlag as: CCheckBox new.
	self define: #infiniteFlag as: CCheckBox new.
! !

!CColorToolFlagsPage methodsFor: 'accessing' stamp: 'ar 3/16/2004 22:10'!
lockedFlag
	"Answer the lockedFlag of the receiver"
	<bewareOf: #lockedFlagChanged>
	^self propertyValueAt: #lockedFlag! !

!CColorToolFlagsPage methodsFor: 'accessing' stamp: 'ar 3/16/2004 22:10'!
lockedFlag: aValue
	"Modify the receiver's lockedFlag"
	^self propertyValueAt: #lockedFlag put: aValue with: #lockedFlagChanged! !

!CColorToolFlagsPage methodsFor: 'events' stamp: 'ar 3/25/2004 14:20'!
onTargetChanged
	"Update my fields"
	<on: targetChanged>
	target ifNil:[^self].
	roundedFlag player: (target fieldNamed: #roundCorners).
	lockedFlag player: (target fieldNamed: #locked).
	shadowFlag player: (target fieldNamed: #dropShadowEnabled).
	floatingFlag player: (target fieldNamed: #floating).
	visibleFlag player: (target fieldNamed: #visible).
	stickyFlag player: (target fieldNamed: #sticky).
	clippingFlag player: (target fieldNamed: #clipping).
	infiniteFlag player: (target fieldNamed: #infinite).
! !

!CColorToolFlagsPage methodsFor: 'accessing' stamp: 'ar 3/16/2004 22:10'!
roundedFlag
	"Answer the roundedFlag of the receiver"
	<bewareOf: #roundedFlagChanged>
	^self propertyValueAt: #roundedFlag! !

!CColorToolFlagsPage methodsFor: 'accessing' stamp: 'ar 3/16/2004 22:10'!
roundedFlag: aValue
	"Modify the receiver's roundedFlag"
	^self propertyValueAt: #roundedFlag put: aValue with: #roundedFlagChanged! !

!CColorToolFlagsPage methodsFor: 'initialize' stamp: 'ar 4/30/2004 15:49'!
setupCostume
	super setupCostume.
	self layout: CTableLayout new.
	self layout listDirection: #topToBottom; wrapDirection: #leftToRight.
	self layout layoutInset: 4; cellInset: 4.
	roundedFlag label: 'rounded'.
	self add: roundedFlag.
	visibleFlag label: 'visible'.
	self add: visibleFlag.

	lockedFlag label: 'locked'.
	self add: lockedFlag.
	stickyFlag label: 'sticky'.
	self add: stickyFlag.

	shadowFlag label: 'shadow'.
	self add: shadowFlag.
	clippingFlag label: 'clipping'.
	self add: clippingFlag.

	floatingFlag label: 'floating'.
	self add: floatingFlag.
	infiniteFlag label: 'infinite'.
	self add: infiniteFlag.
! !

!CColorToolFlagsPage methodsFor: 'accessing' stamp: 'ar 3/16/2004 22:10'!
shadowFlag
	"Answer the shadowFlag of the receiver"
	<bewareOf: #shadowFlagChanged>
	^self propertyValueAt: #shadowFlag! !

!CColorToolFlagsPage methodsFor: 'accessing' stamp: 'ar 3/16/2004 22:10'!
shadowFlag: aValue
	"Modify the receiver's shadowFlag"
	^self propertyValueAt: #shadowFlag put: aValue with: #shadowFlagChanged! !

!CColorToolFlagsPage methodsFor: 'accessing' stamp: 'ar 3/16/2004 22:10'!
stickyFlag
	"Answer the stickyFlag of the receiver"
	<bewareOf: #stickyFlagChanged>
	^self propertyValueAt: #stickyFlag! !

!CColorToolFlagsPage methodsFor: 'accessing' stamp: 'ar 3/16/2004 22:10'!
stickyFlag: aValue
	"Modify the receiver's stickyFlag"
	^self propertyValueAt: #stickyFlag put: aValue with: #stickyFlagChanged! !

!CColorToolFlagsPage methodsFor: 'accessing' stamp: 'ar 3/16/2004 22:10'!
target
	"Answer the target of the receiver"
	<bewareOf: #targetChanged>
	^self propertyValueAt: #target! !

!CColorToolFlagsPage methodsFor: 'accessing' stamp: 'ar 3/16/2004 22:10'!
target: aValue
	"Modify the receiver's target"
	^self propertyValueAt: #target put: aValue with: #targetChanged! !

!CColorToolFlagsPage methodsFor: 'accessing' stamp: 'ar 3/16/2004 22:10'!
visibleFlag
	"Answer the visibleFlag of the receiver"
	<bewareOf: #visibleFlagChanged>
	^self propertyValueAt: #visibleFlag! !

!CColorToolFlagsPage methodsFor: 'accessing' stamp: 'ar 3/16/2004 22:10'!
visibleFlag: aValue
	"Modify the receiver's visibleFlag"
	^self propertyValueAt: #visibleFlag put: aValue with: #visibleFlagChanged! !

CPlayer subclass: #CFillStyleReadout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Tools-ColorTool'!

CFillStyleReadout defineFields: '<?xml  version="1.0" ?>
<fields>
</fields>'!

!CFillStyleReadout methodsFor: 'events' stamp: 'ar 3/13/2004 22:45'!
deselect
	borderWidth := 1.! !

!CFillStyleReadout methodsFor: 'initialize' stamp: 'ar 3/14/2004 00:26'!
initialize
	super initialize.
	self extent: 18@18.
	fillColors := {Color white. Color black}.
	borderStyle := #simple.
	borderWidth := 1.
	borderColor := Color black.! !

!CFillStyleReadout methodsFor: 'events' stamp: 'tk 6/23/2004 11:07'!
onValueChanged
	<on: valueChanged>
	value ifNil:[^self].
	self fillStyle: value.
	value == #solid ifTrue: [fillColors := {Color gray: 0.75. Color black}].
! !

!CFillStyleReadout methodsFor: 'events' stamp: 'ar 3/13/2004 22:45'!
select
	borderWidth := 2.! !

CPlayer subclass: #CPartPrecursor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Tools-PartsBin'!

!CPartPrecursor commentStamp: 'sw 2/8/2005 05:01' prior: 0!
This is a lightweight object that is carried by the hand when an object is dragged out from the parts bin.  Instantiation of the actual newborn object is not done until the drop happens, so that the creation of the newborn object can take into account its new home.!

CPartPrecursor defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="partDescription" toSet="partDescription:" changeEvent="partDescriptionChanged">partDescription</field>
</fields>'!

!CPartPrecursor methodsFor: 'initialization' stamp: 'sw 2/4/2005 00:44'!
initialize
	"Object initialization"

	super initialize.
	self define: #partDescription as: CPartDescription new! !

!CPartPrecursor methodsFor: 'events' stamp: 'tak 5/9/2005 16:23'!
onDropped
	"Invoked when the receiver has been dropped in a container.  Create the actual object and transform the receiver into that objec.t"

	| theNewInstance |
	<on: dropAccept>
	(container == nil or: [partDescription == nil]) ifTrue: [^ self].  "Both have been seen..."
	theNewInstance := partDescription newInstanceIn: container.
	container elements replace: self with: theNewInstance.
	theNewInstance position: self position. "keep scale"
	self destroy "is necessary for terminating scripts etc?  probably not"! !

!CPartPrecursor methodsFor: 'events' stamp: 'ar 6/25/2005 20:21'!
onPartDescriptionChanged
	"When the part description is set, absorb its info into my graphic, size, and label."

	<on: partDescriptionChanged>
	self graphic := partDescription newbornInstanceForm.
	self extent := graphic extent.
	self name: partDescription label
! !

!CPartPrecursor methodsFor: 'accessing' stamp: 'sw 2/4/2005 00:43'!
partDescription
	"Answer the partDescription of the receiver"
	<bewareOf: #partDescriptionChanged>
	^self propertyValueAt: #partDescription! !

!CPartPrecursor methodsFor: 'accessing' stamp: 'ar 2/8/2005 19:24'!
partDescription: aPartDescription
	"Set the receiver's partDescription"
	^ self propertyValueAt: #partDescription put: aPartDescription with: #partDescriptionChanged! !

CPlayer subclass: #CStyleReadoutList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Tools-ColorTool'!

!CStyleReadoutList commentStamp: 'ar 3/16/2004 16:35' prior: 0!
I couldn't think of a good name for the class but what it's doing is really to define the most stupid list type possible - all it does is taking its value as the selection in its elements.!

CStyleReadoutList defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="selection" toSet="selection:" changeEvent="selectionChanged">selection</field>
</fields>'!

!CStyleReadoutList methodsFor: 'events' stamp: 'ar 3/17/2004 03:34'!
onCursorChanged
	<on: cursorChanged in: elements>
	elements cursor = 0 ifTrue:[^self].
	selection ifNotNil:[selection deselect].
	selection := elements selection.
	selection ifNotNil:[selection select].
	value := selection value.
! !

!CStyleReadoutList methodsFor: 'events' stamp: 'ar 3/16/2004 17:42'!
onMouseDown
	| item |
	<on: mouseDown>
	item := self findPlayerAt: self cursorPoint.
	item ifNotNil:[elements selection: item].
! !

!CStyleReadoutList methodsFor: 'events' stamp: 'ar 3/16/2004 17:27'!
onValueChanged
	<on: valueChanged>
	elements selection: (elements findFirstElement:[:item| item value == value]).! !

!CStyleReadoutList methodsFor: 'accessing' stamp: 'ar 3/16/2004 17:34'!
selection
	"Answer the selection of the receiver"
	<bewareOf: #selectionChanged>
	^self propertyValueAt: #selection! !

!CStyleReadoutList methodsFor: 'accessing' stamp: 'ar 3/16/2004 17:34'!
selection: aValue
	"Modify the receiver's selection"
	^self propertyValueAt: #selection put: aValue with: #selectionChanged! !

!CStyleReadoutList methodsFor: 'initialize' stamp: 'ar 4/30/2004 15:54'!
setupCostume
	super setupCostume.
	self layout: CTableLayout new.
	self hResizing: #spaceFill; vResizing: #shrinkWrap.
	self layout listDirection: #leftToRight; wrapDirection: #topToBottom.
	self layout layoutInset: 4; cellInset: 2.
! !

CPlayer subclass: #CTextChunkTool
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Tools-TextChunk'!

CTextChunkTool defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="halo" toSet="halo:" changeEvent="haloChanged">halo</field>
	<field toGet="charFrom" toSet="charFrom:" changeEvent="charFromChanged">charFrom</field>
	<field toGet="charTo" toSet="charTo:" changeEvent="charToChanged">charTo</field>
	<field toGet="wordFrom" toSet="wordFrom:" changeEvent="wordFromChanged">wordFrom</field>
	<field toGet="wordTo" toSet="wordTo:" changeEvent="wordToChanged">wordTo</field>
	<field toGet="itemFrom" toSet="itemFrom:" changeEvent="itemFromChanged">itemFrom</field>
	<field toGet="itemTo" toSet="itemTo:" changeEvent="itemToChanged">itemTo</field>
	<field toGet="itemSeparators" toSet="itemSeparators:" changeEvent="itemSeparatorsChanged">itemSeparators</field>
	<field toGet="lineFrom" toSet="lineFrom:" changeEvent="lineFromChanged">lineFrom</field>
	<field toGet="lineTo" toSet="lineTo:" changeEvent="lineToChanged">lineTo</field>
	<field toGet="seeChunk" toSet="seeChunk:" changeEvent="seeChunkChanged">seeChunk</field>
	<field toGet="errorString" toSet="errorString:" changeEvent="errorStringChanged">errorString</field>
</fields>'!

!CTextChunkTool methodsFor: 'accessing' stamp: 'tk 1/5/2005 17:54'!
charFrom
	"Answer the charFrom of the receiver"
	<bewareOf: #charFromChanged>
	^self propertyValueAt: #charFrom! !

!CTextChunkTool methodsFor: 'accessing' stamp: 'tk 1/5/2005 17:54'!
charFrom: aValue
	"Modify the receiver's charFrom"
	^self propertyValueAt: #charFrom put: aValue with: #charFromChanged! !

!CTextChunkTool methodsFor: 'accessing' stamp: 'tk 1/5/2005 17:54'!
charTo
	"Answer the charTo of the receiver"
	<bewareOf: #charToChanged>
	^self propertyValueAt: #charTo! !

!CTextChunkTool methodsFor: 'accessing' stamp: 'tk 1/5/2005 17:54'!
charTo: aValue
	"Modify the receiver's charTo"
	^self propertyValueAt: #charTo put: aValue with: #charToChanged! !

!CTextChunkTool methodsFor: 'private' stamp: 'tk 1/7/2005 14:12'!
charsIn: str
	"Return the chars specified by the input fields.  If blank fields, pass the entire text through.  Keep error message separate."

	"find numbers"
	| ff tt |
	charFrom value ifNil: [^ str].
	charFrom value withBlanksTrimmed = '' ifTrue: [^ str].	"no lines"
	(ff := charFrom value withBlanksTrimmed asInteger) ifNil: [
		errorString := 'Character-from index must be a number or empty'.  ^ ''].
	ff > str size ifTrue: [errorString := 'Character-from index is too big'.  ^ ''].
	ff := ff max: 1.

	tt := nil.
	charTo value ifNil: [tt := ff].	"one char only"
	tt ifNil: [charTo value withBlanksTrimmed = '' ifTrue: [tt := ff]].
	tt ifNil: [(tt := charTo value withBlanksTrimmed asInteger) ifNil: [
		errorString := 'Character-to index must be a number'.  ^'']].
	tt < ff ifTrue: [errorString := 'Character-to index is too small'.  ^ ''].

	^ str char: ff to: tt! !

!CTextChunkTool methodsFor: 'initialize' stamp: 'tk 1/5/2005 22:27'!
defaultCostume
	^CWindow! !

!CTextChunkTool methodsFor: 'accessing' stamp: 'tk 1/7/2005 13:27'!
errorString
	"Answer the errorString of the receiver"
	<bewareOf: #errorStringChanged>
	^self propertyValueAt: #errorString! !

!CTextChunkTool methodsFor: 'accessing' stamp: 'tk 1/7/2005 13:27'!
errorString: aValue
	"Modify the receiver's errorString"
	^self propertyValueAt: #errorString put: aValue with: #errorStringChanged! !

!CTextChunkTool methodsFor: 'accessing' stamp: 'ar 5/22/2005 18:54'!
halo
	"Answer the halo of the receiver"
	<bewareOf: #haloChanged>
	^self propertyValueAt: #halo! !

!CTextChunkTool methodsFor: 'accessing' stamp: 'ar 5/22/2005 18:54'!
halo: aValue
	"Modify the receiver's halo"
	^self propertyValueAt: #halo put: aValue with: #haloChanged! !

!CTextChunkTool methodsFor: 'initialize' stamp: 'tk 1/7/2005 22:12'!
initialize
	super initialize.
	self define: #charFrom as: CInputField new.
	self define: #charTo as: CInputField new.
	self define: #wordFrom as: CInputField new.
	self define: #wordTo as: CInputField new.
	self define: #itemFrom as: CInputField new.
	self define: #itemTo as: CInputField new.
	self define: #itemSeparators as: CInputField new.
	self define: #lineFrom as: CInputField new.
	self define: #lineTo as: CInputField new.
	self define: #seeChunk as: CTextEditor new.
	"self define: #errorStringLabel as: CLabel new."
! !

!CTextChunkTool methodsFor: 'accessing' stamp: 'tk 1/7/2005 13:55'!
itemFrom
	"Answer the itemFrom of the receiver"
	<bewareOf: #itemFromChanged>
	^self propertyValueAt: #itemFrom! !

!CTextChunkTool methodsFor: 'accessing' stamp: 'tk 1/7/2005 13:55'!
itemFrom: aValue
	"Modify the receiver's itemFrom"
	^self propertyValueAt: #itemFrom put: aValue with: #itemFromChanged! !

!CTextChunkTool methodsFor: 'accessing' stamp: 'tk 1/7/2005 14:08'!
itemSeparators
	"Answer the itemSeparators of the receiver"
	<bewareOf: #itemSeparatorsChanged>
	^self propertyValueAt: #itemSeparators! !

!CTextChunkTool methodsFor: 'accessing' stamp: 'tk 1/7/2005 14:08'!
itemSeparators: aValue
	"Modify the receiver's itemSeparators"
	^self propertyValueAt: #itemSeparators put: aValue with: #itemSeparatorsChanged! !

!CTextChunkTool methodsFor: 'accessing' stamp: 'tk 1/7/2005 13:55'!
itemTo
	"Answer the itemTo of the receiver"
	<bewareOf: #itemToChanged>
	^self propertyValueAt: #itemTo! !

!CTextChunkTool methodsFor: 'accessing' stamp: 'tk 1/7/2005 13:55'!
itemTo: aValue
	"Modify the receiver's itemTo"
	^self propertyValueAt: #itemTo put: aValue with: #itemToChanged! !

!CTextChunkTool methodsFor: 'private' stamp: 'tk 1/18/2005 16:15'!
itemsIn: str
	"Return the items specified by the input fields.  If blank fields, pass the entire text through.  Keep error message separate."

	"find numbers"
	| ff tt seps |
	itemFrom value ifNil: [^ str].
	itemFrom value withBlanksTrimmed = '' ifTrue: [^ str].	"no lines"
	(ff := itemFrom value withBlanksTrimmed asInteger) ifNil: [
		errorString := 'Item-from index must be a number or empty'.  ^ ''].
	ff > str size ifTrue: [errorString := 'Item-from index is too big'.  ^ ''].
	ff := ff max: 1.

	tt := nil.
	itemTo value ifNil: [tt := ff].	"one item only"
	tt ifNil: [itemTo value withBlanksTrimmed = '' ifTrue: [tt := ff]].
	tt ifNil: [(tt := itemTo value withBlanksTrimmed asInteger) ifNil: [
		errorString := 'Item-to index must be a number'.  ^'']].
	tt < ff ifTrue: [errorString := 'Item-to index is too small'.  ^ ''].

	(seps := itemSeparators value) isString ifFalse: [seps := ','].
	(seps detect: [:cc | cc isSeparator] ifNone: [nil]) ifNotNil: [
		errorString := 'Item separators includes an invisible character, such as a blank'].
	seps size = 0 ifTrue: [seps := ','].
	^ str item: ff to: tt separatedBy: seps! !

!CTextChunkTool methodsFor: 'accessing' stamp: 'tk 1/6/2005 12:26'!
lineFrom
	"Answer the lineFrom of the receiver"
	<bewareOf: #lineFromChanged>
	^self propertyValueAt: #lineFrom! !

!CTextChunkTool methodsFor: 'accessing' stamp: 'tk 1/6/2005 12:26'!
lineFrom: aValue
	"Modify the receiver's lineFrom"
	^self propertyValueAt: #lineFrom put: aValue with: #lineFromChanged! !

!CTextChunkTool methodsFor: 'accessing' stamp: 'tk 1/6/2005 12:26'!
lineTo
	"Answer the lineTo of the receiver"
	<bewareOf: #lineToChanged>
	^self propertyValueAt: #lineTo! !

!CTextChunkTool methodsFor: 'accessing' stamp: 'tk 1/6/2005 12:26'!
lineTo: aValue
	"Modify the receiver's lineTo"
	^self propertyValueAt: #lineTo put: aValue with: #lineToChanged! !

!CTextChunkTool methodsFor: 'private' stamp: 'ar 5/22/2005 18:54'!
lines
	"Return the lines specified by the input fields.  If blank fields, pass the entire text through.  Keep error message separate."

	"find the source text"
	| theTarget str ff tt |
	errorString := ''.
	(theTarget := halo target) ifNil: [
		errorString := 'Please bring up a halo on an object that has text'.  ^ ''].
	(str := theTarget text) ifNil: [errorString := 'The object has no text'.  ^ ''].	"do fetch unaccepted text"
	str size = 0 ifTrue: [errorString := 'This object has no text'.  ^ ''].

	"find numbers"
	lineFrom value ifNil: [^ str].
	lineFrom value withBlanksTrimmed = '' ifTrue: [^ str].	"no lines"
	(ff := lineFrom value withBlanksTrimmed asInteger) ifNil: [
		errorString := 'Line-from index must be a number or empty'.  ^ ''].
	ff > str size ifTrue: [errorString := 'Line-from index is too big'.  ^ ''].
	ff := ff max: 1.

	tt := nil.
	lineTo value ifNil: [tt := ff].	"one line only"
	tt ifNil: [lineTo value withBlanksTrimmed = '' ifTrue: [tt := ff]].
	tt ifNil: [(tt := lineTo value asInteger) ifNil: [
		errorString := 'Line-to index must be a number'.  ^'']].
	tt < ff ifTrue: [errorString := 'Line-to index is too small'.  ^ ''].
	^ str line: ff to: tt! !

!CTextChunkTool methodsFor: 'events' stamp: 'tk 1/5/2005 23:31'!
onCharFromChanged
	"notice and recompute the chunk"
	<on: valueChanged in: charFrom>
	self onSpecChange.! !

!CTextChunkTool methodsFor: 'events' stamp: 'tk 1/5/2005 23:31'!
onCharToChanged
	"notice and recompute the chunk"
	<on: valueChanged in: charTo>
	self onSpecChange.! !

!CTextChunkTool methodsFor: 'events' stamp: 'ar 5/22/2005 18:54'!
onHaloChanged
	<on: targetChanged in: halo>
	costume label: 'Text Chunk Tool on ', halo target name.
	self onSpecChange.
! !

!CTextChunkTool methodsFor: 'events' stamp: 'tk 1/7/2005 15:29'!
onItemFromChanged
	"notice and recompute the chunk"
	<on: valueChanged in: itemFrom>
	self onSpecChange.! !

!CTextChunkTool methodsFor: 'events' stamp: 'tk 1/7/2005 15:31'!
onItemSepChanged
	"notice and recompute the chunk"
	<on: valueChanged in: itemSeparators>
	self onSpecChange.! !

!CTextChunkTool methodsFor: 'events' stamp: 'tk 1/7/2005 15:29'!
onItemToChanged
	"notice and recompute the chunk"
	<on: valueChanged in: itemTo>
	self onSpecChange.! !

!CTextChunkTool methodsFor: 'events' stamp: 'tk 1/6/2005 12:31'!
onLineFromChanged
	"notice and recompute the chunk"
	<on: valueChanged in: lineFrom>
	self onSpecChange.! !

!CTextChunkTool methodsFor: 'events' stamp: 'tk 1/6/2005 12:31'!
onLineToChanged
	"notice and recompute the chunk"
	<on: valueChanged in: lineTo>
	self onSpecChange.! !

!CTextChunkTool methodsFor: 'events' stamp: 'tk 1/10/2005 17:06'!
onSpecChange
	"recompute the chunk specified by the input fields.  Take each spec in order, line, item, word, char.  Keep error message separate, and show what the tiles would really do."

	"find numbers"
	| str |
	str := self lines.	"If no spec, pass all through"
	str size > 0 ifTrue: [str := self itemsIn: str].
	str size > 0 ifTrue: [str := self wordsIn: str].
	str size > 0 ifTrue: [str := self charsIn: str].
	errorString size > 0 ifTrue: [
		(errorString beginsWith: 'Item sep') ifFalse: [
			str := String cr, errorString]].	"later give it its own field"
	seeChunk text: str.! !

!CTextChunkTool methodsFor: 'events' stamp: 'tk 1/7/2005 15:29'!
onWordFromChanged
	"notice and recompute the chunk"
	<on: valueChanged in: wordFrom>
	self onSpecChange.! !

!CTextChunkTool methodsFor: 'events' stamp: 'tk 1/7/2005 15:29'!
onWordToChanged
	"notice and recompute the chunk"
	<on: valueChanged in: wordTo>
	self onSpecChange.! !

!CTextChunkTool methodsFor: 'accessing' stamp: 'tk 1/5/2005 17:54'!
seeChunk
	"Answer the seeChunk of the receiver"
	<bewareOf: #seeChunkChanged>
	^self propertyValueAt: #seeChunk! !

!CTextChunkTool methodsFor: 'accessing' stamp: 'tk 1/5/2005 17:54'!
seeChunk: aValue
	"Modify the receiver's seeChunk"
	^self propertyValueAt: #seeChunk put: aValue with: #seeChunkChanged! !

!CTextChunkTool methodsFor: 'initialize' stamp: 'ar 6/24/2005 21:09'!
setupCharColumn
	"Create the controls for 'char 5 to 7'."

	| label6 label8 label10 label11 |
	label6 := CLabel new.
	label6 height: 16.
	label6 extent: 102@16.
	label6 value: 'Character   of'.
	label6 topLeft: 17@8.
	costume add: label6 at: 2.
	charFrom extent: 50@18.
	charFrom topLeft: 22@29.
	charFrom autoAccept: true.
	costume add: charFrom at: 3.
	label8 := CLabel new.
	label8 height: 16.
	label8 extent: 27@16.
	label8 value: 'to'.
	label8 topLeft: 39@52.
	costume add: label8 at: 4.
	charTo extent: 50@18.
	charTo topLeft: 22@74.
	charTo autoAccept: true.
	costume add: charTo at: 5.
	label10 := CLabel new.
	label10 topLeft: 19@94.
	label10 height: 16.
	label10 extent: 125@16.
	label10 value: 'leave blank to get'.
	costume add: label10 at: 6.
	label11 := CLabel new.
	label11 topLeft: 20@106.
	label11 height: 16.
	label11 extent: 125@16.
	label11 value: 'a single character.'.
	costume add: label11.
! !

!CTextChunkTool methodsFor: 'initialize' stamp: 'ar 6/24/2005 21:09'!
setupCostume

	| windowCostume2 holder3 |
	super setupCostume.

	costume hResizing: #rigid; vResizing: #rigid.
	costume topLeft: 173@40.
	costume extent: 393@299.
	windowCostume2 := costume costume.
	holder3 := windowCostume2 frontPage.
	holder3 color: (Color r: 0.85 g: 0.85 b: 0.85).
	seeChunk extent: 354@96.
	seeChunk topLeft: 17@164.
	costume add: seeChunk at: 1.
	self setupCharColumn.
	self setupWordColumn.
	self setupItemColumn.
	self setupLineColumn.
! !

!CTextChunkTool methodsFor: 'initialize' stamp: 'ar 6/24/2005 21:09'!
setupItemColumn
	"Create the controls for 'line 5 to 7'."

	| label6 label8 colX label9 |
	colX := 180.
	label6 := CLabel new.
	label6 height: 16.
	label6 extent: 102@16.
	label6 value: 'Item     of'.
	label6 bottom: 24.
	label6 topLeft: colX+27@8.
	costume add: label6.
	itemFrom extent: 50@18.
	itemFrom topLeft: colX+22@29.
	itemFrom autoAccept: true.
	costume add: itemFrom.
	label8 := CLabel new.
	label8 height: 16; extent: 27@16; value: 'to'; topLeft: colX+39@52.
	costume add: label8.
	itemTo extent: 50@18.
	itemTo topLeft: colX+22@74.
	itemTo autoAccept: true.
	costume add: itemTo.
	label9 := CLabel new.
	label9 height: 16; extent: 67@16; value: 'separated by'; topLeft: colX+6@99.
	costume add: label9.

	itemSeparators extent: 70@18.
	itemSeparators topLeft: colX+12@124.
	itemSeparators autoAccept: true.
	costume add: itemSeparators.
! !

!CTextChunkTool methodsFor: 'initialize' stamp: 'ar 6/24/2005 21:09'!
setupLineColumn
	"Create the controls for 'line 5 to 7'."

	| label6 label8 colX |
	colX := 270.
	label6 := CLabel new.
	label6 height: 16.
	label6 extent: 102@16.
	label6 value: 'Line'.
	label6 bottom: 24.
	label6 topLeft: colX+27@8.
	costume add: label6.
	lineFrom extent: 50@18.
	lineFrom topLeft: colX+22@29.
	lineFrom autoAccept: true.
	costume add: lineFrom.
	label8 := CLabel new.
	label8 height: 16.
	label8 extent: 27@16.
	label8 bottom: 68.
	label8 value: 'to'.
	label8 topLeft: colX+39@52.
	costume add: label8.
	lineTo extent: 50@18.
	lineTo topLeft: colX+22@74.
	lineTo autoAccept: true.
	costume add: lineTo.
! !

!CTextChunkTool methodsFor: 'initialize' stamp: 'ar 6/24/2005 21:09'!
setupWordColumn
	"Create the controls for 'line 5 to 7'."

	| label6 label8 colX |
	colX := 90.
	label6 := CLabel new.
	label6 height: 16.
	label6 extent: 102@16.
	label6 value: 'Word     of'.
	label6 bottom: 24.
	label6 topLeft: colX+27@8.
	costume add: label6.
	wordFrom extent: 50@18.
	wordFrom topLeft: colX+22@29.
	wordFrom autoAccept: true.
	costume add: wordFrom.
	label8 := CLabel new.
	label8 height: 16.
	label8 extent: 27@16.
	label8 bottom: 68.
	label8 value: 'to'.
	label8 topLeft: colX+39@52.
	costume add: label8.
	wordTo extent: 50@18.
	wordTo topLeft: colX+22@74.
	wordTo autoAccept: true.
	costume add: wordTo.
! !

!CTextChunkTool methodsFor: 'accessing' stamp: 'tk 1/6/2005 12:26'!
wordFrom
	"Answer the wordFrom of the receiver"
	<bewareOf: #wordFromChanged>
	^self propertyValueAt: #wordFrom! !

!CTextChunkTool methodsFor: 'accessing' stamp: 'tk 1/6/2005 12:26'!
wordFrom: aValue
	"Modify the receiver's wordFrom"
	^self propertyValueAt: #wordFrom put: aValue with: #wordFromChanged! !

!CTextChunkTool methodsFor: 'accessing' stamp: 'tk 1/6/2005 12:26'!
wordTo
	"Answer the wordTo of the receiver"
	<bewareOf: #wordToChanged>
	^self propertyValueAt: #wordTo! !

!CTextChunkTool methodsFor: 'accessing' stamp: 'tk 1/6/2005 12:26'!
wordTo: aValue
	"Modify the receiver's wordTo"
	^self propertyValueAt: #wordTo put: aValue with: #wordToChanged! !

!CTextChunkTool methodsFor: 'private' stamp: 'tk 1/7/2005 14:11'!
wordsIn: str
	"Return the words specified by the input fields.  If blank fields, pass the entire text through.  Keep error message separate."

	"find numbers"
	| ff tt |
	wordFrom value ifNil: [^ str].
	wordFrom value withBlanksTrimmed = '' ifTrue: [^ str].	"no lines"
	(ff := wordFrom value withBlanksTrimmed asInteger) ifNil: [
		errorString := 'Word-from index must be a number or empty'.  ^ ''].
	ff > str size ifTrue: [errorString := 'Word-from index is too big'.  ^ ''].
	ff := ff max: 1.

	tt := nil.
	wordTo value ifNil: [tt := ff].	"one word only"
	tt ifNil: [wordTo value withBlanksTrimmed = '' ifTrue: [tt := ff]].
	tt ifNil: [(tt := wordTo value withBlanksTrimmed asInteger) ifNil: [
		errorString := 'Word-to index must be a number'.  ^'']].
	tt < ff ifTrue: [errorString := 'Word-to index is too small'.  ^ ''].

	^ str word: ff to: tt! !

CPlayer subclass: #CTextTool
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Tools-TextTool'!

!CTextTool commentStamp: '<historical>' prior: 0!
The Text Tool allows the user to make text bold, or italic, and change its size and font.  It operates on the last text that the user clicked in.  Get a Text Tool from the Tools menu of the menu bar.[general]


### Allow Users to see the above explanation ###!

CTextTool defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="font" toSet="font:" changeEvent="fontChanged">font</field>
	<field toGet="fontNames" toSet="fontNames:" changeEvent="fontNamesChanged">fontNames</field>
	<field toGet="fontSizes" toSet="fontSizes:" changeEvent="fontSizesChanged">fontSizes</field>
	<field toGet="colorButton" toSet="colorButton:" changeEvent="colorButtonChanged">colorButton</field>
	<field toGet="boldButton" toSet="boldButton:" changeEvent="boldButtonChanged">boldButton</field>
	<field toGet="italicButton" toSet="italicButton:" changeEvent="italicButtonChanged">italicButton</field>
	<field toGet="underlineButton" toSet="underlineButton:" changeEvent="underlineButtonChanged">underlineButton</field>
	<field toGet="struckoutButton" toSet="struckoutButton:" changeEvent="struckoutButtonChanged">struckoutButton</field>
	<field toGet="alignList" toSet="alignList:" changeEvent="alignListChanged">alignList</field>
	<field toGet="editor" toSet="editor:" changeEvent="editorChanged">editor</field>
</fields>'!

!CTextTool class methodsFor: 'class initialization' stamp: 'ar 1/22/2005 22:46'!
initialize
	"self initialize"
	self registerOpenCommand.! !

!CTextTool class methodsFor: 'class initialization' stamp: 'ar 1/22/2005 22:45'!
registerOpenCommand
	"self initialize"
	Smalltalk at: #CProjectBuilder ifPresent:[:pb|
		pb registerOpenCommand: { 'Text Tool' . { self . #open }. 'A Text Tool' }.
	].! !

!CTextTool methodsFor: 'font' stamp: 'tak 2/19/2006 01:31'!
acceptFont
	| attr selection |
	editor
		ifNil: [^ self].
	attr := TextFontReference toFont: font.
	selection := editor selection.
	selection isEmpty
		ifTrue: [^ editor changeFontHere: attr].
	selection := selection addAttribute: attr.
	editor replaceSelectionWith: selection.
	editor selectFrom: editor selectionStop - selection size to: editor selectionStop! !

!CTextTool methodsFor: 'accessing' stamp: 'tak 5/9/2005 23:56'!
alignList
	"Answer the alignList of the receiver"
	<bewareOf: #alignListChanged>
	^self propertyValueAt: #alignList! !

!CTextTool methodsFor: 'accessing' stamp: 'tak 5/9/2005 23:56'!
alignList: aValue
	"Modify the receiver's alignList"
	^self propertyValueAt: #alignList put: aValue with: #alignListChanged! !

!CTextTool methodsFor: 'accessing' stamp: 'ar 4/4/2004 17:36'!
boldButton
	"Answer the boldButton of the receiver"
	<bewareOf: #boldButtonChanged>
	^self propertyValueAt: #boldButton! !

!CTextTool methodsFor: 'accessing' stamp: 'ar 4/4/2004 17:36'!
boldButton: aValue
	"Modify the receiver's boldButton"
	^self propertyValueAt: #boldButton put: aValue with: #boldButtonChanged! !

!CTextTool methodsFor: 'intialize' stamp: 'tak 5/16/2005 13:52'!
buildAlignButtons
	| symbols labels buttons button |
	symbols := #(#leftFlush #centered #justified #rightFlush ).
	labels := #('[' ':' '=' ']' ).
	buttons := OrderedCollection new.
	symbols
		keysAndValuesDo: [:index :symbol | 
			button := CRadioButton new.
			button costume: CToolBarButtonCostume new.
			button value: symbol.
			button
				label: (labels at: index).
			button font: (TextStyle named: #WindowFont) defaultFont.
			button extent: 20 @ 20.
			buttons add: button].
	^ buttons! !

!CTextTool methodsFor: 'intialize' stamp: 'tak 5/10/2005 11:42'!
buildAlignList
	alignList layout: CTableLayout new.
	alignList layout listDirection: #leftToRight.
	alignList hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap.
	alignList layout cellInset: 2.
	alignList addAll: self buildAlignButtons.
	self add: alignList! !

!CTextTool methodsFor: 'emphasis' stamp: 'tk 12/14/2004 15:26'!
changeEmphasis: emph
	"If the emphasis is present in the current selection, then add it. Otherwise remove it."
	| attr selection |
	editor ifNil: [^ self].
	selection := editor selection.
	selection isEmpty 
		ifTrue:[^editor changeEmpasisHere: emph].
	selection removeAttributesSuchThat:[:a| a class == TextEmphasis].
	emph = 0 ifFalse:[
		attr := TextEmphasis new emphasisCode: emph.
		emph = 0 ifFalse:[selection addAttribute: attr].
	].
	editor replaceSelectionWith: selection.
	editor selectFrom: editor selectionStop - selection size to: editor selectionStop.! !

!CTextTool methodsFor: 'accessing' stamp: 'tak 5/9/2005 18:18'!
colorButton
	"Answer the colorButton of the receiver"
	<bewareOf: #colorButtonChanged>
	^self propertyValueAt: #colorButton! !

!CTextTool methodsFor: 'accessing' stamp: 'tak 5/9/2005 18:18'!
colorButton: aValue
	"Modify the receiver's colorButton"
	^self propertyValueAt: #colorButton put: aValue with: #colorButtonChanged! !

!CTextTool methodsFor: 'intialize' stamp: 'ar 2/7/2005 00:59'!
defaultCostume
	^CHolder! !

!CTextTool methodsFor: 'accessing' stamp: 'ar 4/4/2004 19:06'!
editor
	"Answer the editor of the receiver"
	<bewareOf: #editorChanged>
	^self propertyValueAt: #editor! !

!CTextTool methodsFor: 'accessing' stamp: 'ar 4/4/2004 19:06'!
editor: aValue
	"Modify the receiver's editor"
	^self propertyValueAt: #editor put: aValue with: #editorChanged! !

!CTextTool methodsFor: 'accessing' stamp: 'tak 2/19/2006 00:59'!
font
	"Answer the font of the receiver"
	<bewareOf: #fontChanged>
	^self propertyValueAt: #font! !

!CTextTool methodsFor: 'accessing' stamp: 'tak 2/19/2006 00:59'!
font: aValue
	"Modify the receiver's font"
	^self propertyValueAt: #font put: aValue with: #fontChanged! !

!CTextTool methodsFor: 'font' stamp: 'tak 2/19/2006 01:31'!
fontName: aSymbol
	| lastSize style |
	lastSize := font pointSize.
	style := (TextStyle named: aSymbol) ifNil: [TextStyle default].
	font := style fontOfPointSize: lastSize.
	self acceptFont
	
! !

!CTextTool methodsFor: 'accessing' stamp: 'ar 4/4/2004 17:34'!
fontNames
	"Answer the fontNames of the receiver"
	<bewareOf: #fontNamesChanged>
	^self propertyValueAt: #fontNames! !

!CTextTool methodsFor: 'accessing' stamp: 'ar 4/4/2004 17:34'!
fontNames: aValue
	"Modify the receiver's fontNames"
	^self propertyValueAt: #fontNames put: aValue with: #fontNamesChanged! !

!CTextTool methodsFor: 'font' stamp: 'tak 2/19/2006 02:14'!
fontSize: aNumber 
	| textStyle |
	textStyle := font textStyle.
	(font isTTCFont
			and: [(textStyle fontArray
					anySatisfy: [:aFont | aFont pointSize = aNumber]) not])
		ifTrue: ["Add new font size"
			textStyle addNewFontSize: aNumber].
	font := font textStyle fontOfPointSize: aNumber.
	self acceptFont! !

!CTextTool methodsFor: 'accessing' stamp: 'ar 4/4/2004 17:34'!
fontSizes
	"Answer the fontSizes of the receiver"
	<bewareOf: #fontSizesChanged>
	^self propertyValueAt: #fontSizes! !

!CTextTool methodsFor: 'accessing' stamp: 'ar 4/4/2004 17:34'!
fontSizes: aValue
	"Modify the receiver's fontSizes"
	^self propertyValueAt: #fontSizes put: aValue with: #fontSizesChanged! !

!CTextTool methodsFor: 'intialize' stamp: 'tak 2/19/2006 01:00'!
initialize
	super initialize.
	font := TextStyle defaultFont.
	self define: #fontNames as: CDropDownList new.
	self define: #fontSizes as: CDropDownList new.
	self define: #colorButton as: CPlayer new.
	self define: #boldButton as: CToolBarButton new.
	self define: #italicButton as: CToolBarButton new.
	self define: #underlineButton as: CToolBarButton new.
	self define: #struckoutButton as: CToolBarButton new.
	self define: #alignList as: CButtonList new.
! !

!CTextTool methodsFor: 'accessing' stamp: 'ar 4/4/2004 17:36'!
italicButton
	"Answer the italicButton of the receiver"
	<bewareOf: #italicButtonChanged>
	^self propertyValueAt: #italicButton! !

!CTextTool methodsFor: 'accessing' stamp: 'ar 4/4/2004 17:36'!
italicButton: aValue
	"Modify the receiver's italicButton"
	^self propertyValueAt: #italicButton put: aValue with: #italicButtonChanged! !

!CTextTool methodsFor: 'emphasis' stamp: 'ar 4/4/2004 19:46'!
onBoldChanged
	<on: fire in: boldButton>
	boldButton selected: boldButton selected not.
	self onUpdateEmphasis.! !

!CTextTool methodsFor: 'events' stamp: 'tak 2/18/2006 23:51'!
onClosed
	<on: closed>
	self pauseScript: #onKeyboardFocusChanged:
! !

!CTextTool methodsFor: 'events' stamp: 'ar 4/4/2004 21:20'!
onEditorChanged
	<on: editorChanged>
	editor ifNotNil:[^self onTextSelectionChanged].! !

!CTextTool methodsFor: 'events' stamp: 'tak 2/19/2006 01:35'!
onFontNameChanged
	<on: cursorChanged in: fontNames>
	font familyName = fontNames selection
		ifTrue: [^self].
	self fontName: fontNames selection.! !

!CTextTool methodsFor: 'events' stamp: 'tak 2/19/2006 02:18'!
onFontSizeChanged
	| fontSize answer |
	<on: cursorChanged in: fontSizes>
	fontSize := fontSizes selection.
	fontSize = font pointSize
		ifTrue: [^ self].
	fontSize = 'new size'
		ifTrue: [self pauseScript: #onEditorChanged.
			answer := FillInTheBlank request: 'Enter the point size' translated initialAnswer: '12'.
			self resumeScript: #onEditorChanged.
			"Wait to back old editor"
			self waitTick.
			answer
				ifNil: [^ self].
			fontSize := answer asNumber].
	self fontSize: fontSize! !

!CTextTool methodsFor: 'emphasis' stamp: 'ar 4/4/2004 19:47'!
onItalicChanged
	<on: fire in: italicButton>
	italicButton selected: italicButton selected not.
	self onUpdateEmphasis.! !

!CTextTool methodsFor: 'events' stamp: 'tak 6/15/2005 16:52'!
onKeyboardFocusChanged: newKeyFocus
	| newFocus |
	newKeyFocus ifNil:[^self].
	newFocus := newKeyFocus asPlayer.
	newFocus textHolder ifNil:[^self].
	editor := newFocus textHolder getEditor.
! !

!CTextTool methodsFor: 'events' stamp: 'tak 6/15/2005 16:54'!
onOpened
	| newHand |
	<on: opened>
	"For some reason, self hand is not a good hand(???)."
	newHand := self project primaryHand.
	self startScript: #onKeyboardFocusChanged: when: {newHand. #keyboardFocusChanged}.
	self onKeyboardFocusChanged: newHand.! !

!CTextTool methodsFor: 'emphasis' stamp: 'ar 4/4/2004 19:47'!
onStruckoutChanged
	<on: fire in: struckoutButton>
	struckoutButton selected: struckoutButton selected not.
	self onUpdateEmphasis.! !

!CTextTool methodsFor: 'events' stamp: 'tak 2/19/2006 01:12'!
onTextSelectionChanged
	| code |
	"Refresh widget from the font of current editor."
	<on: textSelectionChanged in: editor>
	(editor notNil and: [editor font notNil])
		ifTrue: [font := editor font].
	self setWidgetFont: font.
	code := editor emphasis.
	boldButton selected: (code anyMask: 1).
	italicButton selected: (code anyMask: 2).
	underlineButton selected: (code anyMask: 4).
	struckoutButton selected: (code anyMask: 16).
	colorButton player: (editor fieldNamed: #textColor).
	alignList player: (editor fieldNamed: #align).
! !

!CTextTool methodsFor: 'emphasis' stamp: 'ar 4/4/2004 19:47'!
onUnderlinedChanged
	<on: fire in: underlineButton>
	underlineButton selected: underlineButton selected not.
	self onUpdateEmphasis.! !

!CTextTool methodsFor: 'emphasis' stamp: 'ar 10/19/2004 14:26'!
onUpdateEmphasis
	| code |
	code := 0.
	boldButton selected ifTrue:[code := code bitOr: 1].
	italicButton selected ifTrue:[code := code bitOr: 2].
	underlineButton selected ifTrue:[code := code bitOr: 4].
	struckoutButton selected ifTrue:[code := code bitOr: 16].
	self changeEmphasis: code.! !

!CTextTool methodsFor: 'font' stamp: 'tak 2/19/2006 01:23'!
setWidgetFont: aFont 
	"Refresh widget from the font of current editor."
	| list |
	fontNames selection: aFont familyName asSymbol.
	list := aFont textStyle pointSizes.
	aFont isTTCFont
		ifTrue: [list := list , #('new size' )].
	fontSizes contents: list.
	fontSizes selection: aFont pointSize! !

!CTextTool methodsFor: 'intialize' stamp: 'ar 5/13/2005 14:32'!
setupCostume
	super setupCostume.
	self extent: 209@76.
	self fillStyle: #solid.
	self fillColors: (Array with: (Color r: 1.0 g: 1.0 b: 1.0) with: (Color r: 1.0 g: 0.677 b: 0.032)).
	self borderWidth: 1.
	self roundCorners: true.
	self dropShadowEnabled: true.
	self borderColor: (Color r: 0.987 g: 0.725 b: 0.188).
	self borderStyle: #simple.
	self fillStyle: #solid.

	layout := CTableLayout new.
	layout listDirection: #leftToRight.
	layout wrapDirection: #topToBottom.
	layout hResizing: #shrinkWrap; vResizing: #shrinkWrap.
	layout layoutInset: 4.
	layout cellInset: 2.

	fontNames addAll: StrikeFont actualFamilyNames.
	fontNames width: 108.
	fontNames costume hResizing: #rigid.
	self add: fontNames.

	fontSizes addAll: #(9 10 12 14 18 24 36 48).
	fontSizes width: 64.
	fontSizes costume hResizing: #rigid.
	self add: fontSizes.

	colorButton costume: CColorTileCostume.
	colorButton extent: 20@20.
	colorButton hResizing: #rigid; vResizing: #rigid.
	self add: colorButton.

	boldButton label: ('B' asText allBold addAttribute: TextEmphasis bold).
	boldButton extent: 20@20.
	self add: boldButton.

	italicButton label: (' I ' asText allBold addAttribute: TextEmphasis italic).
	italicButton extent: 20@20.
	self add: italicButton.

	underlineButton label: ('U' asText allBold addAttribute: TextEmphasis underlined).
	underlineButton extent: 20@20.
	self add: underlineButton.

	struckoutButton label: ('S' asText allBold addAttribute: TextEmphasis struckOut).
	struckoutButton extent: 20@20.
	self add: struckoutButton.

	self buildAlignList.
! !

!CTextTool methodsFor: 'accessing' stamp: 'ar 4/4/2004 17:36'!
struckoutButton
	"Answer the struckoutButton of the receiver"
	<bewareOf: #struckoutButtonChanged>
	^self propertyValueAt: #struckoutButton! !

!CTextTool methodsFor: 'accessing' stamp: 'ar 4/4/2004 17:36'!
struckoutButton: aValue
	"Modify the receiver's struckoutButton"
	^self propertyValueAt: #struckoutButton put: aValue with: #struckoutButtonChanged! !

!CTextTool methodsFor: 'accessing' stamp: 'ar 4/4/2004 17:36'!
underlineButton
	"Answer the underlineButton of the receiver"
	<bewareOf: #underlineButtonChanged>
	^self propertyValueAt: #underlineButton! !

!CTextTool methodsFor: 'accessing' stamp: 'ar 4/4/2004 17:36'!
underlineButton: aValue
	"Modify the receiver's underlineButton"
	^self propertyValueAt: #underlineButton put: aValue with: #underlineButtonChanged! !

!CTextTool methodsFor: 'color and fill' stamp: 'ar 4/4/2004 18:34'!
windowColor: aColor
	super windowColor: aColor.
	self elements do:[:each| each windowColor: aColor].
! !

CPlayer subclass: #CTrashCan
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Tools-Trash'!

!CTrashCan commentStamp: 'sw 4/28/2005 04:12' prior: 0!
An icon on the screen representing the Trash.  Double-click on it to view its contents.!

CTrashCan defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="trashManager" toSet="trashManager:" changeEvent="trashManagerChanged">trashManager</field>
</fields>'!

!CTrashCan class methodsFor: 'graphic images' stamp: 'sw 4/30/2005 22:02'!
playDeleteSound
	"Play the standard sound associated with object deletion."

	SoundService default playSampledSound: self samplesForDelete rate: 22050! !

!CTrashCan class methodsFor: 'graphic images' stamp: 'sw 4/30/2005 02:50'!
samplesForDelete
	"Answer a monster array of 4636 integers, representing the sound to make when an object is dropped into the trash"

	^ #(0 11 5 18 42 35 28 54 42 59 52 44 16 18 33 6 -39 -30 -39 -37 -61 -61 -55 -83 -71 -42 -66 -45 -61 -40 -22 1 -3 33 61 69 44 59 59 64 44 81 62 79 91 62 45 55 1 -8 -10 -1 -16 -33 -20 -57 -54 -18 10 5 -1 -6 25 62 47 49 79 52 20 50 76 94 74 91 100 94 69 67 76 76 44 71 62 64 91 93 96 113 93 125 120 108 76 67 79 54 79 69 64 83 37 39 35 6 -13 -57 -62 -52 -79 -94 -100 -78 -105 -101 -59 -69 -64 -25 -55 -33 -57 -33 -39 -33 -16 -16 -16 -30 -25 -1 -27 -32 -39 -44 -1 -18 -23 -61 -55 -45 -67 -74 -47 -23 -22 -55 -50 -18 -47 -39 -22 -32 -28 -45 -28 -50 -69 -83 -83 -66 -93 -84 -74 -74 -84 -76 -94 -52 -69 -62 -35 -3 11 -16 28 5 -10 0 3 25 -1 20 32 25 44 59 18 11 -32 0 -11 -28 -55 -67 -62 -64 -57 -49 -76 -239 -980 -1731 -1565 -478 1153 2646 2919 1799 -1385 -5482 -8325 -8427 -4347 2556 9606 13864 12797 7894 731 -6395 -9218 -6222 1491 9207 12724 10783 3258 -6050 -12631 -14020 -9175 -454 8771 14419 13457 7050 -1679 -8875 -11346 -7670 960 10478 16383 15908 10112 2191 -5150 -8398 -6123 644 8334 12364 11062 5163 -2966 -9760 -12327 -9012 -1947 4977 8880 8495 4412 -1704 -6697 -7935 -5491 -186 5557 9289 9235 4955 -819 -4990 -5843 -3005 2128 7204 9606 7728 2439 -3872 -8469 -9930 -7226 -1385 4532 7567 6452 2154 -3136 -7248 -8045 -4493 1794 7582 10089 8636 3994 -1994 -6473 -7257 -3774 1894 6760 9011 7177 1979 -4364 -8760 -9067 -5465 332 5596 7764 5742 284 -5345 -8517 -7840 -3480 2838 8592 10639 7918 2485 -3435 -7177 -7341 -3630 2542 7333 8449 5514 15 -5645 -9192 -8368 -3540 3111 8083 9218 6558 941 -5119 -8500 -7748 -2905 3329 8259 9891 6975 1192 -4921 -8285 -7411 -3123 3090 7961 9206 5967 -130 -5728 -8793 -7886 -3061 3637 8965 9864 6471 683 -5121 -8324 -7547 -2720 3679 8050 8714 5236 -373 -6032 -9138 -7679 -2653 3679 8166 8982 5906 -111 -5825 -8561 -7094 -2091 3874 8412 9128 5533 -361 -5918 -8320 -6939 -2222 4016 8376 8831 4987 -943 -6130 -8678 -7102 -2117 4149 8322 8296 4768 -744 -5827 -8144 -6444 -1172 4732 8463 8412 4659 -1111 -6519 -8782 -6838 -1876 3818 7423 7601 3966 -1852 -6722 -8505 -6354 -1297 4366 8266 8217 4386 -1206 -5891 -7589 -5647 -595 5092 8402 7645 3372 -2274 -7031 -8958 -6814 -1560 4329 7654 7123 3477 -1869 -6393 -7899 -5367 88 5572 8632 8001 3994 -1711 -6441 -7793 -5287 -393 4497 7216 6430 2176 -3494 -7572 -8412 -5660 -476 4873 7782 6690 2393 -2805 -6588 -7323 -4649 614 5879 8327 6904 2609 -2773 -6848 -7927 -5150 117 5087 7272 5923 1730 -3616 -7575 -8117 -4951 332 5082 7314 6100 1716 -3587 -7162 -7338 -4064 1063 5860 7922 6178 1477 -3845 -7267 -7575 -4571 537 5260 7199 5292 826 -4115 -7486 -7689 -4446 938 5637 7201 5421 1063 -3815 -7109 -7141 -3667 1448 5660 6990 4983 519 -4622 -7833 -7543 -3996 1080 5323 6922 5028 385 -4480 -7416 -7070 -3789 1145 5533 6878 4693 40 -4734 -7506 -7268 -3827 1353 5650 6756 4347 -161 -4821 -7581 -7051 -3301 1993 5847 6707 4347 -198 -4888 -7582 -6814 -2926 2076 5860 6719 4339 -313 -5104 -7557 -6685 -2960 1915 5679 6573 3945 -814 -5333 -7572 -6588 -2787 2269 6052 6597 3789 -877 -5189 -7406 -6525 -2636 2447 5996 6307 3497 -1070 -5450 -7609 -6463 -2340 2658 5945 6230 3482 -1158 -5519 -7458 -5949 -1767 3039 6341 6612 3603 -1267 -5625 -7343 -5857 -1774 3033 6279 6346 3156 -1653 -5721 -7357 -5877 -1742 3158 6256 6039 2848 -1752 -5721 -7285 -5643 -1223 3635 6464 6159 2960 -1731 -5771 -7229 -5280 -936 3662 6266 5823 2488 -2386 -6329 -7457 -5362 -1044 3521 6339 5962 2564 -2183 -5850 -6875 -4841 -536 4120 6763 6062 2488 -2111 -5681 -6838 -4873 -605 3845 6190 5268 1777 -2759 -6413 -7419 -5162 -680 3692 5964 5234 1888 -2556 -5979 -6624 -4157 242 4497 6702 5860 2200 -2597 -6054 -6732 -4381 -111 4183 6330 5153 1346 -3170 -6430 -7031 -4688 -198 4213 6335 5180 1519 -2753 -5777 -6198 -3531 958 5024 6619 5234 1523 -3048 -6295 -6753 -4157 137 3986 5665 4412 788 -3545 -6449 -6469 -3735 539 4539 6246 4921 1172 -3100 -5918 -6010 -3352 905 4800 6313 4702 865 -3363 -6118 -6254 -3609 753 4529 5842 4178 466 -3628 -6305 -6174 -3231 1195 4854 6112 4497 715 -3550 -6183 -5972 -3043 1265 4843 6030 4203 264 -3915 -6352 -5945 -2961 1328 4907 6001 4025 50 -3949 -6240 -5808 -2731 1620 5085 5932 3872 5 -3961 -6174 -5640 -2408 1971 5204 5806 3587 -347 -4320 -6493 -5674 -2252 2103 5245 5818 3709 -300 -4249 -6215 -5309 -2066 2078 5077 5591 3262 -809 -4558 -6335 -5384 -2111 2062 5097 5460 3022 -951 -4570 -6283 -5192 -1733 2491 5348 5475 3024 -912 -4546 -6217 -5077 -1557 2597 5245 5301 2785 -1263 -4934 -6522 -5226 -1716 2385 5104 5206 2680 -1328 -4860 -6276 -4933 -1472 2549 5211 5238 2602 -1389 -4778 -6118 -4834 -1379 2664 5109 4880 2156 -1731 -5007 -6259 -4754 -1121 2883 5297 4973 2318 -1620 -4939 -6086 -4395 -697 3187 5426 5082 2242 -1738 -5026 -6037 -4332 -754 3012 5156 4665 1777 -2237 -5294 -6125 -4310 -676 3177 5313 4707 1704 -2171 -5167 -5962 -4134 -434 3307 5221 4456 1421 -2371 -5287 -5974 -3954 -188 3542 5297 4424 1389 -2456 -5362 -5854 -3667 161 3709 5435 4476 1255 -2671 -5472 -5828 -3589 215 3804 5409 4402 1138 -2724 -5324 -5599 -3384 378 3901 5396 4091 868 -2871 -5385 -5572 -3270 525 3884 5155 3828 575 -3119 -5518 -5503 -2994 826 4095 5277 3886 615 -3100 -5348 -5202 -2603 1202 4405 5579 4064 602 -3109 -5419 -5272 -2790 899 4067 5100 3521 122 -3477 -5592 -5270 -2585 1314 4537 5531 3905 485 -3089 -5226 -4956 -2347 1443 4476 5236 3463 11 -3604 -5711 -5257 -2473 1341 4363 5141 3385 -28 -3584 -5504 -4973 -2164 1586 4456 5218 3413 -64 -3496 -5321 -4707 -1969 1721 4571 5109 3195 -329 -3723 -5474 -4821 -1969 1776 4503 4921 2919 -522 -3845 -5506 -4654 -1676 2057 4687 5036 3068 -415 -3721 -5323 -4408 -1430 2169 4614 4882 2788 -695 -3915 -5313 -4337 -1396 2132 4519 4702 2544 -905 -3866 -5124 -3993 -988 2586 4865 4841 2573 -877 -3859 -5050 -3949 -902 2556 4668 4510 2223 -1141 -4108 -5170 -3808 -703 2720 4719 4553 2271 -1131 -3972 -4907 -3489 -390 2919 4890 4537 2088 -1385 -4154 -4934 -3447 -337 2949 4792 4325 1743 -1562 -4181 -4856 -3273 -33 3316 5041 4439 1923 -1424 -3959 -4570 -2910 317 3423 4907 4088 1355 -2054 -4624 -5056 -3187 140 3307 4809 4030 1323 -2069 -4432 -4695 -2724 597 3694 5114 4179 1360 -1966 -4229 -4478 -2602 675 3715 5019 3932 1027 -2281 -4537 -4753 -2714 656 3687 4919 3859 1085 -2127 -4312 -4403 -2332 965 3786 4910 3750 882 -2391 -4437 -4402 -2254 933 3703 4646 3397 396 -2761 -4724 -4539 -2305 980 3754 4756 3469 590 -2468 -4317 -4120 -1871 1389 4050 4788 3321 318 -2715 -4503 -4201 -1837 1438 4025 4685 3201 220 -2892 -4629 -4167 -1665 1653 4171 4763 3180 93 -2975 -4602 -4015 -1499 1777 4212 4668 2927 -195 -3214 -4712 -4027 -1443 1877 4278 4609 2759 -451 -3440 -4853 -4093 -1385 1983 4334 4570 2726 -405 -3326 -4680 -3794 -1068 2210 4410 4547 2595 -554 -3460 -4715 -3725 -987 2203 4300 4352 2317 -875 -3669 -4760 -3687 -941 2237 4312 4330 2291 -778 -3453 -4486 -3475 -775 2271 4218 4105 1969 -1070 -3682 -4656 -3518 -661 2424 4262 4018 1854 -1197 -3718 -4505 -3141 -252 2809 4564 4264 2067 -1039 -3611 -4369 -3028 -201 2761 4427 4040 1772 -1318 -3740 -4352 -2907 -52 2939 4553 4008 1657 -1414 -3784 -4364 -2858 71 3089 4629 4098 1794 -1219 -3535 -4025 -2500 373 3224 4571 3896 1487 -1553 -3828 -4269 -2661 281 3126 4547 3891 1552 -1413 -3640 -3989 -2363 529 3341 4719 4010 1545 -1452 -3640 -3988 -2305 653 3467 4729 3866 1292 -1740 -3849 -4091 -2325 671 3436 4602 3716 1219 -1733 -3760 -3867 -1994 1031 3708 4758 3730 1100 -1925 -3891 -3898 -1938 1044 3640 4625 3557 921 -2020 -3859 -3776 -1813 1116 3687 4617 3465 815 -2079 -3828 -3713 -1708 1263 3759 4544 3307 641 -2169 -3855 -3674 -1608 1362 3750 4410 3090 425 -2383 -4022 -3725 -1533 1491 3835 4488 3167 390 -2378 -3928 -3509 -1257 1728 4013 4573 3123 286 -2473 -3894 -3404 -1080 1884 4078 4466 2853 -5 -2678 -4035 -3440 -1097 1857 3996 4295 2678 -137 -2821 -4118 -3421 -983 1959 4054 4283 2648 -196 -2873 -4054 -3273 -751 2161 4159 4334 2556 -320 -2965 -4064 -3201 -743 2176 4144 4225 2424 -491 -2999 -4011 -3065 -524 2366 4218 4166 2266 -527 -3007 -3950 -2995 -441 2446 4186 4011 2055 -793 -3221 -4122 -3048 -497 2269 3910 3759 1847 -951 -3318 -4032 -2861 -261 2461 4044 3777 1764 -1048 -3282 -3888 -2595 8 2720 4200 3747 1609 -1195 -3413 -4006 -2727 -94 2586 4001 3501 1396 -1321 -3396 -3835 -2456 164 2756 3984 3385 1253 -1458 -3540 -3889 -2427 161 2654 3835 3194 978 -1743 -3638 -3838 -2295 322 2819 3964 3211 939 -1698 -3550 -3689 -2147 446 2883 3884 3016 726 -1901 -3667 -3765 -2123 530 2870 3745 2848 568 -2028 -3721 -3652 -1884 743 3014 3804 2827 478 -2144 -3779 -3686 -1910 685 2910 3669 2636 249 -2295 -3828 -3676 -1867 787 3011 3681 2564 169 -2269 -3684 -3424 -1508 1109 3282 3789 2575 134 -2334 -3779 -3482 -1543 1073 3099 3608 2339 -127 -2620 -3944 -3519 -1525 1092 3151 3535 2273 -193 -2580 -3787 -3318 -1296 1326 3309 3652 2234 -256 -2634 -3888 -3409 -1348 1282 3204 3491 2125 -346 -2666 -3811 -3204 -1114 1441 3253 3462 2008 -432 -2714 -3692 -3007 -861 1662 3399 3499 1940 -547 -2821 -3765 -2983 -854 1648 3346 3394 1743 -761 -2958 -3849 -3087 -822 1676 3304 3282 1636 -822 -2963 -3772 -2878 -644 1835 3375 3296 1599 -831 -2924 -3667 -2702 -446 1998 3489 3307 1604 -885 -2949 -3667 -2658 -408 1984 3421 3207 1407 -1005 -3028 -3592 -2493 -223 2183 3519 3168 1323 -1124 -3078 -3621 -2468 -157 2191 3465 3090 1216 -1211 -3123 -3584 -2390 -106 2201 3424 2983 1031 -1414 -3236 -3594 -2278 52 2393 3518 2982 1026 -1372 -3185 -3492 -2174 217 2481 3558 2990 999 -1399 -3104 -3323 -1944 391 2603 3528 2824 765 -1645 -3338 -3516 -2118 259 2439 3404 2700 654 -1716 -3375 -3479 -1952 439 2602 3455 2704 617 -1772 -3360 -3404 -1901 493 2585 3413 2571 442 -1901 -3413 -3358 -1742 676 2719 3458 2583 442 -1862 -3275 -3184 -1514 848 2836 3482 2495 313 -1981 -3404 -3224 -1543 771 2719 3268 2198 22 -2217 -3523 -3218 -1457 934 2870 3380 2242 59 -2137 -3336 -3000 -1255 1077 2880 3290 2110 -83 -2249 -3472 -3087 -1267 1111 2885 3257 2040 -176 -2349 -3455 -3004 -1129 1255 3036 3316 2039 -227 -2339 -3367 -2824 -929 1423 3077 3287 1959 -317 -2425 -3404 -2826 -843 1430 3068 3162 1762 -476 -2500 -3382 -2659 -727 1562 3083 3145 1742 -512 -2522 -3314 -2559 -602 1664 3136 3073 1555 -715 -2690 -3413 -2556 -503 1757 3190 3055 1450 -804 -2731 -3387 -2464 -390 1826 3150 2944 1301 -988 -2887 -3487 -2491 -402 1808 3073 2807 1145 -1095 -2921 -3406 -2352 -208 1950 3141 2802 1072 -1204 -2977 -3394 -2252 -139 2044 3163 2751 988 -1284 -2999 -3350 -2217 -88 2015 3102 2629 783 -1424 -3044 -3346 -2157 -30 2050 2988 2449 636 -1582 -3178 -3411 -2135 33 2055 3016 2424 588 -1604 -3153 -3331 -2032 105 2123 3004 2344 451 -1704 -3204 -3309 -1933 240 2208 3055 2334 446 -1723 -3175 -3231 -1818 359 2308 3090 2346 386 -1787 -3260 -3265 -1820 356 2266 2999 2193 254 -1933 -3348 -3302 -1774 369 2222 2917 2042 49 -2030 -3348 -3221 -1676 551 2424 2995 2054 59 -2069 -3306 -3095 -1494 698 2522 3017 1974 -76 -2184 -3380 -3114 -1440 812 2568 3072 2033 -28 -2128 -3285 -2956 -1228 978 2724 3102 2010 -72 -2132 -3243 -2871 -1197 1016 2712 3029 1879 -193 -2206 -3229 -2775 -1056 1151 2797 3009 1818 -259 -2251 -3228 -2729 -924 1199 2758 2960 1718 -366 -2324 -3206 -2607 -812 1346 2836 2951 1687 -417 -2296 -3068 -2403 -625 1489 2924 2973 1616 -495 -2352 -3067 -2391 -554 1545 2861 2807 1397 -666 -2452 -3170 -2430 -598 1455 2785 2736 1312 -666 -2441 -3082 -2300 -371 1625 2866 2787 1319 -715 -2419 -3014 -2215 -357 1630 2768 2593 1134 -895 -2544 -3051 -2178 -300 1721 2892 2634 1145 -873 -2515 -2951 -2057 -198 1786 2807 2505 988 -1041 -2620 -2987 -2040 -173 1787 2775 2424 878 -1146 -2653 -2960 -1923 -22 1884 2870 2447 839 -1131 -2622 -2897 -1799 150 2027 2955 2466 880 -1138 -2624 -2885 -1730 215 2008 2792 2244 532 -1406 -2788 -2907 -1703 271 2074 2865 2293 571 -1377 -2724 -2844 -1597 359 2159 2905 2247 524 -1426 -2756 -2770 -1526 385 2118 2799 2111 366 -1521 -2792 -2805 -1494 476 2227 2856 2176 419 -1497 -2702 -2664 -1365 576 2242 2846 2050 288 -1597 -2805 -2685 -1346 610 2278 2780 1937 101 -1784 -2922 -2737 -1321 656 2274 2778 1906 101 -1762 -2860 -2610 -1156 798 2368 2831 1903 113 -1745 -2832 -2569 -1114 817 2385 2771 1847 64 -1781 -2734 -2446 -980 972 2488 2827 1830 -37 -1804 -2773 -2381 -854 1075 2529 2805 1762 -115 -1871 -2814 -2424 -863 995 2388 2588 1572 -262 -1977 -2756 -2281 -768 1187 2551 2702 1616 -217 -1921 -2693 -2156 -525 1368 2688 2802 1681 -176 -1843 -2583 -2054 -486 1362 2622 2668 1482 -310 -1964 -2658 -2030 -407 1440 2632 2615 1414 -419 -1998 -2603 -1949 -308 1501 2646 2553 1251 -544 -2111 -2641 -1891 -203 1606 2693 2558 1221 -636 -2152 -2639 -1867 -169 1662 2737 2547 1212 -588 -2088 -2498 -1655 66 1843 2843 2575 1178 -659 -2118 -2500 -1614 84 1874 2810 2476 1056 -807 -2218 -2522 -1633 91 1833 2736 2359 912 -917 -2295 -2539 -1521 210 1962 2793 2374 877 -956 -2273 -2486 -1486 273 1960 2763 2318 846 -924 -2200 -2364 -1294 463 2123 2812 2301 746 -1033 -2281 -2395 -1277 478 2088 2770 2203 668 -1089 -2273 -2325 -1138 593 2156 2782 2140 586 -1177 -2335 -2295 -1131 673 2266 2788 2115 527 -1240 -2337 -2291 -1065 714 2232 2751 2049 415 -1301 -2344 -2203 -912 893 2398 2875 2103 441 -1287 -2285 -2145 -860 919 2373 2787 1955 291 -1384 -2390 -2218 -926 895 2315 2670 1786 118 -1521 -2456 -2156 -763 1043 2485 2775 1905 215 -1428 -2301 -1988 -605 1143 2486 2773 1811 106 -1504 -2330 -1949 -517 1224 2539 2766 1765 -1 -1609 -2354 -1901 -485 1265 2576 2702 1630 -103 -1664 -2429 -1998 -532 1202 2383 2439 1382 -313 -1859 -2522 -1972 -449 1268 2454 2522 1407 -266 -1801 -2391 -1793 -269 1458 2597 2563 1399 -335 -1806 -2393 -1781 -264 1457 2571 2525 1296 -424 -1881 -2419 -1738 -169 1570 2620 2485 1246 -483 -1893 -2373 -1645 -76 1594 2564 2400 1128 -595 -2039 -2476 -1670 -79 1582 2556 2366 1092 -661 -2010 -2352 -1514 42 1745 2668 2398 1085 -602 -1954 -2271 -1428 161 1794 2649 2296 1000 -680 -1991 -2286 -1416 208 1781 2580 2232 882 -783 -2025 -2223 -1270 357 1925 2659 2237 856 -861 -2084 -2254 -1331 264 1833 2527 2105 724 -924 -2098 -2169 -1211 463 2013 2658 2137 717 -951 -2037 -2125 -1067 580 2088 2704 2156 712 -922 -1998 -2030 -975 687 2101 2625 2033 553 -1068 -2105 -2113 -992 614 2054 2544 1925 393 -1209 -2193 -2120 -978 659 2095 2553 1852 371 -1175 -2167 -2055 -907 712 2117 2532 1833 351 -1221 -2191 -2064 -904 722 2089 2497 1755 251 -1306 -2191 -1996 -809 793 2079 2441 1687 159 -1350 -2232 -1959 -717 875 2159 2439 1591 74 -1423 -2210 -1928 -710 904 2117 2327 1511 0 -1455 -2184 -1832 -544 1070 2242 2419 1545 6 -1440 -2161 -1769 -468 1124 2271 2393 1463 -93 -1541 -2206 -1748 -459 1145 2278 2366 1367 -193 -1575 -2225 -1774 -398 1206 2305 2327 1348 -193 -1597 -2240 -1767 -379 1195 2225 2232 1192 -351 -1692 -2218 -1655 -300 1255 2262 2245 1173 -381 -1740 -2223 -1589 -193 1358 2339 2254 1162 -359 -1698 -2137 -1513 -130 1419 2361 2208 1099 -480 -1771 -2242 -1558 -110 1399 2259 2096 965 -566 -1838 -2200 -1501 -69 1440 2279 2064 956 -566 -1796 -2127 -1367 47 1509 2339 2071 854 -666 -1862 -2105 -1321 125 1599 2378 2079 834 -676 -1816 -2062 -1279 167 1625 2349 1998 792 -726 -1860 -2055 -1178 296 1692 2369 1979 714 -802 -1893 -2084 -1211 261 1664 2237 1779 464 -1005 -2033 -2147 -1245 259 1594 2166 1720 434 -1065 -2061 -2095 -1133 371 1750 2251 1742 417 -1055 -2010 -2003 -1033 476 1747 2210 1621 274 -1178 -2098 -2074 -1051 405 1660 2091 1502 145 -1277 -2162 -2062 -1043 446 1704 2091 1430 117 -1302 -2130 -2008 -924 534 1752 2081 1391 6 -1401 -2186 -2016 -924 551 1669 1938 1233 -144 -1443 -2208 -1949 -810 656 1764 2040 1273 -74 -1399 -2100 -1818 -690 741 1816 2006 1199 -137 -1418 -2110 -1808 -673 737 1740 1866 1055 -293 -1597 -2213 -1793 -644 736 1752 1869 1050 -301 -1584 -2159 -1776 -568 810 1796 1871 1005 -364 -1608 -2164 -1706 -534 843 1798 1833 919 -422 -1660 -2137 -1655 -454 917 1830 1784 866 -449 -1647 -2147 -1604 -424 965 1801 1743 821 -566 -1743 -2128 -1562 -305 1000 1820 1704 753 -619 -1781 -2127 -1565 -334 1000 1874 1733 710 -631 -1726 -2074 -1487 -225 1072 1849 1676 690 -670 -1771 -2072 -1409 -150 1134 1842 1630 622 -744 -1801 -2088 -1375 -118 1112 1793 1572 517 -861 -1860 -2061 -1360 -125 1153 1801 1499 435 -863 -1843 -2011 -1287 -15 1250 1871 1496 419 -888 -1866 -2020 -1263 25 1240 1801 1457 354 -941 -1864 -1971 -1153 123 1290 1808 1416 300 -992 -1882 -1974 -1136 101 1265 1735 1287 169 -1145 -2027 -2006 -1172 88 1243 1709 1223 74 -1185 -2022 -1994 -1090 201 1290 1665 1151 -5 -1270 -2037 -1964 -1029 254 1341 1723 1148 -30 -1243 -1998 -1893 -990 313 1404 1692 1116 -88 -1318 -2061 -1901 -966 335 1372 1657 1007 -184 -1409 -2127 -1972 -1012 273 1297 1553 922 -283 -1502 -2195 -1944 -924 359 1353 1581 934 -257 -1472 -2069 -1782 -743 544 1508 1721 1005 -239 -1430 -2013 -1728 -726 568 1513 1687 946 -274 -1453 -2000 -1706 -615 656 1560 1662 916 -303 -1462 -2018 -1660 -619 641 1506 1558 765 -459 -1584 -2078 -1667 -602 614 1463 1504 707 -507 -1609 -2050 -1591 -502 732 1547 1574 746 -434 -1467 -1896 -1414 -320 873 1638 1558 717 -546 -1572 -1920 -1423 -303 914 1626 1499 622 -576 -1601 -1947 -1440 -315 878 1564 1413 497 -700 -1630 -1901 -1340 -235 943 1635 1450 505 -673 -1626 -1838 -1268 -117 1063 1699 1487 566 -598 -1531 -1754 -1133 6 1155 1725 1477 520 -692 -1577 -1721 -1087 50 1187 1782 1497 541 -634 -1526 -1698 -1005 122 1201 1737 1426 424 -741 -1599 -1704 -1051 98 1219 1728 1363 347 -795 -1614 -1650 -910 278 1353 1830 1470 405 -761 -1553 -1575 -782 407 1414 1867 1394 356 -827 -1587 -1589 -810 320 1326 1735 1304 232 -916 -1650 -1601 -790 378 1401 1748 1262 196 -924 -1606 -1538 -720 463 1453 1774 1262 215 -880 -1591 -1465 -619 542 1487 1760 1224 169 -924 -1567 -1379 -486 658 1604 1874 1328 256 -834 -1433 -1297 -476 680 1601 1816 1236 149 -922 -1492 -1307 -434 705 1579 1733 1136 59 -1005 -1540 -1331 -395 756 1616 1789 1146 67 -944 -1440 -1162 -234 897 1698 1796 1162 54 -965 -1433 -1126 -196 909 1742 1826 1116 39 -951 -1385 -1117 -179 985 1740 1777 1100 -3 -973 -1397 -1065 -139 965 1709 1708 1009 -83 -1061 -1492 -1114 -176 914 1630 1640 902 -188 -1100 -1497 -1082 -135 948 1676 1636 887 -137 -1063 -1382 -966 10 1061 1728 1681 890 -196 -1095 -1360 -888 52 1082 1706 1594 775 -300 -1194 -1472 -994 -25 1014 1628 1484 690 -420 -1262 -1480 -1007 -10 1063 1653 1467 631 -413 -1268 -1460 -951 27 1033 1557 1336 508 -544 -1350 -1552 -999 1 1027 1506 1307 486 -568 -1367 -1492 -904 123 1082 1574 1307 437 -602 -1372 -1474 -880 135 1083 1518 1204 320 -717 -1489 -1574 -980 22 965 1401 1092 188 -858 -1536 -1564 -893 120 1029 1372 1038 173 -824 -1484 -1470 -809 225 1095 1435 1063 156 -851 -1492 -1482 -804 189 1075 1357 992 79 -941 -1541 -1513 -817 186 1038 1329 909 -1 -951 -1550 -1487 -776 242 1068 1319 907 -37 -970 -1562 -1433 -703 281 1111 1338 877 -22 -994 -1547 -1382 -646 359 1158 1375 877 -39 -917 -1424 -1279 -513 488 1246 1396 895 -42 -944 -1430 -1251 -444 493 1180 1296 748 -193 -1056 -1523 -1294 -507 471 1189 1294 754 -176 -1068 -1426 -1178 -354 617 1314 1423 832 -137 -1029 -1413 -1138 -379 566 1257 1306 693 -251 -1112 -1494 -1204 -366 595 1224 1217 608 -351 -1167 -1513 -1184 -340 595 1201 1206 551 -368 -1260 -1558 -1240 -403 519 1117 1089 435 -536 -1324 -1623 -1250 -366 575 1173 1122 468 -466 -1309 -1516 -1111 -244 680 1257 1162 486 -441 -1211 -1443 -1011 -161 763 1258 1160 463 -481 -1258 -1414 -955 -105 773 1243 1104 435 -491 -1216 -1382 -949 -118 800 1263 1089 332 -585 -1250 -1363 -926 -47 832 1262 1027 296 -598 -1258 -1368 -829 54 919 1299 1085 378 -515 -1153 -1219 -703 189 997 1391 1145 393 -517 -1141 -1201 -678 213 1036 1363 1104 303 -605 -1216 -1279 -683 193 983 1304 1011 249 -641 -1223 -1251 -646 245 1046 1299 1002 205 -671 -1216 -1173 -554 354 1136 1397 1043 225 -659 -1189 -1133 -498 368 1139 1391 1004 178 -646 -1160 -1056 -478 432 1160 1401 978 161 -653 -1138 -1089 -420 459 1139 1341 927 115 -695 -1170 -1038 -381 468 1148 1316 893 61 -744 -1201 -1061 -376 503 1173 1341 899 49 -731 -1155 -1000 -312 536 1168 1335 853 27 -754 -1167 -983 -279 575 1219 1297 797 -8 -790 -1145 -931 -234 617 1223 1245 737 -89 -863 -1195 -949 -218 617 1167 1202 693 -183 -895 -1216 -951 -220 629 1172 1199 664 -128 -836 -1134 -844 -108 731 1265 1229 659 -157 -860 -1119 -809 -91 734 1240 1178 595 -229 -975 -1194 -870 -111 678 1150 1136 537 -283 -943 -1165 -800 -71 766 1226 1106 520 -271 -924 -1129 -800 -49 785 1221 1072 476 -361 -980 -1162 -753 1 768 1204 1063 415 -364 -994 -1122 -678 83 868 1268 1109 498 -329 -938 -1039 -631 137 880 1234 1009 354 -422 -1041 -1109 -663 72 832 1182 994 335 -478 -1029 -1136 -649 152 885 1234 1004 320 -471 -999 -1044 -539 247 926 1272 1070 373 -381 -939 -987 -490 256 966 1294 1007 305 -461 -972 -963 -469 278 966 1228 927 218 -529 -1044 -1041 -517 264 924 1143 853 105 -632 -1104 -1048 -507 313 943 1143 788 98 -670 -1100 -1019 -429 339 968 1141 822 117 -603 -1002 -907 -334 454 1050 1195 795 96 -612 -1014 -934 -369 412 983 1073 680 -47 -759 -1153 -1021 -419 335 919 1053 697 -15 -724 -1067 -916 -332 420 966 1055 659 -67 -734 -1106 -917 -349 385 929 1034 600 -96 -734 -1029 -885 -217 513 1060 1082 676 -40 -698 -1005 -785 -193 580 1063 1097 670 -45 -707 -1005 -787 -178 512 1029 1016 505 -217 -829 -1094 -827 -196 517 949 944 480 -229 -836 -1041 -753 -135 602 1100 1068 615 -83 -695 -948 -644 27 710 1133 1073 549 -179 -793 -1005 -736 -71 617 1044 990 463 -266 -831 -1017 -680 -45 658 1063 978 430 -245 -815 -944 -624 42 707 1034 910 376 -327 -880 -1014 -653 -55 636 966 812 290 -393 -917 -1022 -612 61 698 1034 902 327 -386 -912 -1005 -598 44 673 1002 838 261 -464 -944 -1053 -661 27 676 949 739 130 -537 -1031 -1097 -687 -18 653 922 690 113 -547 -1036 -1033 -597 105 719 983 751 149 -536 -978 -983 -546 125 737 949 681 79 -573 -1005 -1002 -559 108 720 895 648 28 -653 -1050 -1011 -524 137 681 834 536 -93 -754 -1160 -1085 -624 79 603 758 463 -184 -829 -1189 -1080 -563 79 631 788 434 -178 -809 -1129 -965 -454 201 724 861 497 -139 -724 -1082 -980 -405 227 729 804 430 -206 -814 -1158 -992 -439 218 683 751 351 -264 -890 -1177 -988 -449 159 661 726 356 -295 -904 -1131 -936 -415 242 697 707 301 -307 -870 -1106 -926 -337 296 739 739 356 -300 -829 -1053 -814 -212 407 821 839 378 -268 -829 -1026 -814 -232 361 749 744 274 -366 -910 -1090 -814 -254 347 751 676 184 -402 -924 -1077 -785 -189 419 763 683 240 -354 -885 -1017 -707 -117 481 812 722 290 -296 -793 -919 -590 -15 576 897 805 322 -312 -809 -890 -598 -64 544 839 715 242 -385 -836 -895 -592 10 602 878 765 291 -315 -731 -815 -454 123 707 955 826 300 -291 -717 -775 -434 139 710 973 788 254 -347 -732 -765 -391 189 714 961 776 249 -330 -707 -709 -332 230 736 941 736 196 -398 -783 -805 -408 195 663 838 632 94 -490 -849 -815 -435 162 648 822 607 83 -481 -826 -768 -320 259 731 873 649 135 -429 -734 -664 -247 335 802 921 629 89 -463 -753 -681 -300 247 693 792 513 -27 -566 -838 -714 -315 271 697 798 493 -22 -564 -860 -707 -245 281 722 819 541 -13 -505 -734 -617 -195 390 814 858 539 11 -520 -739 -607 -149 449 815 848 497 -45 -510 -790 -605 -171 369 775 780 461 -103 -603 -809 -639 -189 329 693 687 354 -183 -671 -843 -654 -193 368 739 770 376 -149 -575 -761 -578 -93 452 839 804 403 -134 -568 -726 -508 -45 498 778 773 371 -161 -625 -766 -530 -57 485 824 731 378 -179 -598 -727 -532 -25 502 773 698 291 -212 -670 -790 -546 -83 420 712 608 218 -293 -703 -787 -524 -49 471 739 649 274 -249 -661 -739 -452 57 532 810 710 274 -234 -619 -698 -413 61 558 758 602 169 -351 -732 -798 -517 -28 435 653 493 52 -408 -810 -817 -490 20 525 719 532 89 -407 -780 -804 -474 1 463 656 466 40 -463 -785 -809 -459 22 452 642 493 13 -435 -754 -717 -366 113 541 714 471 33 -456 -773 -748 -429 61 495 625 420 -15 -502 -838 -751 -402 106 500 610 395 -37 -510 -787 -739 -342 157 549 646 427 -20 -463 -734 -670 -290 208 608 709 452 -20 -469 -724 -666 -273 218 622 648 390 -44 -495).
! !

!CTrashCan class methodsFor: 'graphic images' stamp: 'sw 4/30/2005 02:53'!
trashCanImage
	"Answer a form comprising the image to use for the trashcan"

	^  Form extent: 42@54 depth: 16 fromArray: #( 0 0 0 0 0 0 32735 2073983966 2073982844 1933274907 1792633561 1794797306 1933276060 2073983966 2145320960 0 0 0 0 0 0 0 0 0 0 2145352606 2000450331 1790534199 1507153300 1368609139 1368609170 1299269969 1230063985 1232162194 1374903926 1725460314 2006743966 0 0 0 0 0 0 0 0 2073982812 1855613496 1574326643 1299334447 1024342285 957167885 1024343342 1093616943 1232096593 1299336562 1297171792 1162824145 1377001142 1866102684 2078178270 0 0 0 0 0 2143254332 1855613432 1572162929 889990346 617097416 753547532 1026441519 1162888528 1160792432 1230065010 1366513011 1502894485 1433618769 1093614894 1238456981 1798993820 2008906718 0 0 0 31646 1855614457 1708675442 753538181 411380937 1026445683 1639342551 1639341494 1502960020 1572167126 1504988530 1230065009 1366515125 1708681688 1435780432 957168974 1305566934 1801090972 2078146560 0 0 2002611770 1775855063 1093604452 136389800 1299344889 1912303098 1775789495 1572231572 1502896630 1922724538 1504985327 1160725840 1160725840 1435790841 1912299991 1160722701 959269329 1588946712 1870362557 0 31581 1845063161 1777876270 138544160 890007033 2117957147 1775788502 1572231573 1500797365 1782085307 1922719221 1158690989 1158695281 1093614893 1022185875 1845065243 1505049870 889993517 1244748469 1729655675 2078146560 2143252090 1777955322 1366430820 2110732 1981513277 1842962903 1639341494 1570069909 1643606682 1994089015 1368605968 1160792401 1162889584 1230061903 957103406 1572238875 1845053808 887895276 1099846259 1521837848 2006712320 2000513528 1845062104 753532960 480666038 2048682457 1708615095 1641505239 1641507384 1922724538 1643531570 1227967794 1368542578 1297171760 1162888528 1022179597 1435790842 1914326322 889992460 959269425 1450401526 1870363614 1994090968 1845126615 617153568 617113048 2048681432 1708680664 1637246455 1994095388 1784173972 1297173810 1368609170 1299336561 1230063984 1232093487 959266094 1572173339 1775846736 889993485 892027342 1381129909 1868199869 1994156504 1845062105 1026426913 342117745 2048684538 1775789527 1572234711 2073984991 1580614928 1433621908 1368609138 1299336529 1232094512 1093614829 959271283 1912239643 1433614605 957168910 686374317 1311857333 1798929374 1931241976 1842966009 1572151463 136388775 1502900731 1845062104 1637244342 1853453083 1576358227 1502893427 1366445426 1299335505 1232094511 1093550383 1502899706 1912297909 1093548301 1026437354 549928365 1244681876 1798928317 2002545176 1845063161 1845055891 617090147 547834224 1641507288 1708614103 1637245399 1574328692 1435784563 1366510962 1297172848 1160792401 1366516183 1914334713 1433615662 957234478 889985157 480656813 1242585748 1798929310 2004705815 1641507288 1842966010 1502951693 547822726 887899472 1366514036 1502894452 1502960020 1435783571 1368543602 1299337587 1435786677 1775790553 1572161873 1026440494 1024339178 411374692 549862829 1244747412 1798929374 2073977399 1435786678 1706519000 1912236536 1368602893 820719851 889993486 1162822992 1232096562 1299272050 1366511987 1435785621 1572168118 1502891377 1160723758 1026438412 617092196 274928772 549929421 1244682933 1801092062 2143185593 1433620851 1433623989 1641507289 1845062104 1572163954 1230062928 1160791376 1232096593 1299337586 1366513044 1502893427 1433619826 1162886446 1022177515 617093253 274928740 411375749 688406990 1311857333 1868200926 30589 1578520947 1299336562 1366446451 1502895542 1639343575 1639341494 1505057173 1502893460 1435784596 1433620851 1299335537 1093613836 820718793 549918853 274928740 342168708 344202406 896221646 1314021110 1870363614 0 1933269461 1299336529 1232094544 1162888495 1162889553 1299337586 1366446450 1230063953 1162888495 1093549357 955003115 617094310 344265828 274928740 342103172 344200292 480653641 1034700271 1450404665 2008875008 0 29499 1442072944 1232094512 1160724783 1026439438 957167885 957166860 887894251 753544393 617161896 547822726 411374692 342103140 344200325 344199267 411378888 757741932 1034766896 1591112603 2078146560 0 0 1994086805 1297171792 1162821934 1026440462 957166860 887894251 753544426 684270792 617095335 547822758 411375749 342103140 274927715 411377831 820719883 896220588 1104040530 1798928317 0 0 0 2004709914 1502954800 1162888495 957167917 957166860 820718827 751446217 684270760 547822758 478551174 411374692 274928772 478552231 751384846 957101291 963396045 1173313172 1868201951 0 0 0 2073981530 1708608849 1366515158 1505052977 1024342317 957165803 684271817 684205256 547822758 547823783 547824841 822819085 887892169 753548622 892089644 1034764782 1242586838 1870331904 0 0 0 2143253146 1708674385 1299341782 1708611988 1091519792 1366446483 1299334479 957167885 1162822992 1093613837 820721965 1164984655 957163689 753548622 957101355 1104037359 1311858390 1939636158 0 0 0 30460 1775848754 1230069206 1708613046 1230062928 1366448564 1502956914 1091518766 1301369235 1230060781 820721965 1232160079 955066569 753614125 957166892 1104102895 1314021110 1939603456 0 0 0 30557 1845055859 1160797621 1708613045 1230062896 1368544660 1502892402 1024343310 1301435827 1297168653 751450413 1301366096 887892137 753548622 889993548 1173309967 1383229144 1939603456 0 0 0 31581 1849317780 1160796597 1708679606 1227965744 1368544660 1435783539 1024343277 1301435796 1232157933 818624813 1301366096 887892137 822820142 889993581 1173309968 1383294744 2008875008 0 0 0 31581 1849318837 1160796564 1710711254 1232093455 1299339700 1435784563 1093614829 1301370291 1299266830 820720908 1164985680 887826601 822820142 889994605 1175472688 1452567353 2078146560 0 0 0 31646 1853514166 1230067059 1643602391 1227963662 1299339700 1502893427 1162886414 1164988819 1299266830 887895308 1162822992 887892137 887831886 889994605 1242581552 1519676217 2078146560 0 0 0 32735 1922720182 1230066034 1641505239 1364345103 1299273108 1435784563 1232092430 1162891698 1299333423 820720908 1162821967 887892137 892092718 889994638 1242516017 1519676250 2078146560 0 0 0 0 1996252631 1227966801 1641506263 1433616687 1230067092 1504990612 1160789229 1164988819 1299266830 887896333 1164985680 885794985 892092718 889994638 1242582577 1521839962 2078146560 0 0 0 0 1998415320 1297172817 1641440727 1435780399 1230067059 1504990579 1162886446 1162891698 1299333423 887895308 1164985712 887892169 892092718 889995694 1244678705 1588948859 2078146560 0 0 0 0 2002610712 1433618800 1505060312 1502889264 1162891667 1504990612 1160789229 1164988850 1299333391 887896332 1164985680 887892137 959267151 959267246 1242582577 1591112571 2145320960 0 0 0 0 2073980474 1502955825 1504995832 1502888239 1162892659 1504990612 1232091373 1162827187 1368604974 887895308 1164985680 887893193 961365360 959267278 1244679729 1591112604 2078146560 0 0 0 0 2143187610 1502955825 1435788760 1572159759 1093620114 1435784596 1227962605 1095718323 1433616686 818623756 1232095600 887892137 1028539760 959267279 1242517074 1593209756 0 0 0 0 0 2145351388 1572160816 1299342839 1639336241 1091522963 1504991636 1295139118 1093619090 1368604975 818623756 1232162194 818620617 1028539759 961365455 1242583634 1660385180 2145320960 0 0 0 0 30525 1641497904 1230070231 1641500018 1160727922 1507154324 1299333423 1026444690 1437810991 818623756 1232162193 887892137 1026377071 961365487 1242582610 1660385180 0 0 0 0 0 31581 1779977522 1230069206 1708609906 1160793457 1435785653 1366442286 1024347537 1437812016 885798156 1095715185 955001033 959267151 961365487 1244680786 1729655708 0 0 0 0 0 31646 1849315699 1230069173 1710707059 1093618001 1435785620 1299333391 1024347537 1368607088 957100267 1095715184 887893194 959267118 1028539887 1242583667 1729656765 0 0 0 0 0 32702 1991988628 1227970996 1708676500 1158629713 1437817268 1366507823 1024347537 1368607088 955069676 1095715185 887893194 959267118 1030571503 1244680819 1729656765 0 0 0 0 0 32735 1994086805 1230067092 1710709140 1093552496 1433622964 1366507823 1024346481 1368607057 955069708 1164921201 887893194 959266126 1030638095 1244681843 1798929374 0 0 0 0 0 0 1998347701 1160794483 1710710165 1091519792 1433622965 1433616655 957172080 1433618800 957167885 1164986737 887893194 959267118 1030637072 1244681876 1798928317 0 0 0 0 0 0 2000510390 1160727858 1641504182 1160791344 1368611252 1435780400 1022183793 1442072945 954999945 887900529 887894250 1093549390 1099844111 1311858357 1870363614 0 0 0 0 0 0 2069719576 1160793457 1643602390 1227965743 1368611252 1435781488 1024346480 1504989586 885786626 478562672 957167885 1234190671 1104103984 1450402552 2006712320 0 0 0 0 0 0 2145349242 1502960052 1710711255 1297171760 1299338611 1502890289 1024345424 1442074995 816513025 411388273 1162820910 1095712078 1242583634 1591111547 2078146560 0 0 0 0 0 0 29468 1708615159 1641505206 1295139118 1299338644 1502890321 1093550383 1368543635 950864898 337986895 1162885390 957171151 1383292630 1868199869 0 0 0 0 0 0 0 31646 1922720215 1639341494 1366443312 1442078198 1502890321 955073839 1374900626 1093613805 1024344366 957233453 1171213906 1589013305 1937536957 2008906718 0 0 0 0 0 0 0 2073980570 1641504182 1502893460 1643535797 1433619762 1093552497 1504987504 1160798775 1855608243 1234193937 1381127795 1591109400 1798925113 1798992763 2078146560 0 0 0 0 0 0 32735 1931176536 1576426966 1505056148 1433620883 1295142257 1366443312 1093557845 2136897244 1719164597 1383288337 1381127795 1452562035 1452565239 1870363614 0 0 0 0 0 0 0 31646 2000448185 1647794645 1504990612 1437815187 1301434802 1374903991 1861909341 1855610453 1305560432 1301366128 1104103952 1311857300 1798929374 0 0 0 0 0 0 0 0 32735 2006808444 1864068858 1794796282 1866101596 2006809566 1864066680 1504990579 1366510929 1366512019 961301040 1383292630 1870363614 0 0 0 0 0 0 0 0 0 0 0 0 0 2073979577 1368612277 1639340469 1368608081 1093612812 963467957 1729654651 2008875008 0 0 0 0 0 0 0 0 0 0 0 0 0 1998345620 1299273108 1502892402 1230060878 1099845170 1660449691 2008906718 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2073980537 1505055090 1368543731 1446273751 1801090972 2078179262 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 32638 1931243258 1864071069 2008906718 2145320960 0 0 0 0) offset: 0@0! !

!CTrashCan class methodsFor: 'graphic images' stamp: 'sw 4/30/2005 03:03'!
trashCanOpenImage
	"Answer a form comprising the image of an open trashcan"

	^  ((ColorForm extent: 70@77 depth: 8 fromArray: #( 4076008178 4076008178 4076008178 4076008178 4076008178 4075942386 4076008178 4076008178 4076008178 4076008178 4076008178 4076008178 4076008178 4076008178 4076008178 4076008178 4076008178 4075945984 4076008178 4076008178 4076008178 4076008178 4075875300 3638024410 3840339181 4008833778 4076008178 4076008178 4076008178 4076008178 4076008178 4076008178 4076008178 4076008178 4076008178 4075945984 4076008178 4076008178 4076008178 4076007917 3855333317 3318266043 3164969126 3218728680 3907972850 4076008178 4076008178 4076008178 4076008178 4076008178 4076008178 4076008178 4076008178 4075945984 4076008178 4076008178 4076008178 4075674039 2679421130 2960540474 723786518 439047577 3201290464 3992122098 4076008178 4076008178 4076008178 4076008178 4076008178 4076008178 4076008178 4075945984 4076008178 4076008178 4076008178 3954748573 3033837660 840570912 741619238 420678672 730644137 3269455346 4076008178 4076008178 4076008178 4076008178 4076008178 4076008178 4076008178 4075945984 4076008178 4076008178 4076008153 2928906677 3414962708 388380221 1044271184 1615867664 85087153 2375860967 4076008178 4076008178 4076008178 4076008178 4076008178 4076008178 4076008178 4075945984 4076008178 4076008178 4076001697 2475800012 1746539297 809387582 1195787853 1349481040 503777082 2977989299 3774018290 4076008178 4076008178 4076008178 4076008178 4076008178 4076008178 4075945984 4076008178 4076008178 4074479749 2242825063 370354494 1349548946 2458221401 1330471556 1512574472 1236364416 2850091506 4076008178 4076008178 4076008178 4076008178 4076008178 4076008178 4075945984 4076008178 4076008178 3987047812 2479519253 321933423 2459803037 2645406900 2237223023 2237211664 275290712 2159274226 4076008178 4076008178 4076008178 4076008178 4076008178 4076008178 4075945984 4076008178 4076008178 3179644036 2945194515 810580612 1884309319 1197112221 3030216537 2055554587 253863517 1586414824 4076008178 4076008178 4076008178 4076008178 4076008178 4076008178 4075945984 4076008178 4076008168 2507832211 2956988450 1215259208 774121776 909985625 2259984226 1653043246 420764776 1281334493 4076008178 4076008178 4076008178 4076008178 4076008178 4076008178 4075945984 4076008178 4076008142 2054191791 2132416061 1347434017 455684150 1011305807 1501867410 1870369352 504903540 1263957939 3908236018 4076008178 4076008178 4076008178 4076008178 4076008178 4075945984 4076008178 4076007845 1869577125 1242833470 1194663451 690959670 1044861017 1617072812 2071630690 689513576 1581997980 3723424498 4076008178 4076008178 4076008178 4076008178 4076008178 4075945984 4076008178 4076005510 1650627709 605433661 908139042 691025468 1179603040 1685027731 2457503610 907943259 1951159936 3270439666 4076008178 4076008178 4076008178 4076008178 4076008178 4075945984 4076008178 4075998578 1633850470 437856816 689839657 775239230 1196317280 1652194194 2239468164 1042555220 1985301613 2884170482 4076008178 4076008178 4076008178 4076008178 4076008178 4075945984 4076008178 4075994720 1499567700 421144873 572138537 808859198 1297111394 1920697477 2223281042 1193878097 1985367146 2816537330 4076008178 4076008178 4076008178 4076008178 4076008178 4075945984 4076008178 4075991386 1348507210 370811426 505488425 792083782 1330667618 1887078277 2071696019 1345201736 1984645994 2631856114 4076008178 4076008178 4076008178 4076008178 4076008178 4075945984 4076008178 4075994976 1331333706 421076510 505685033 808860743 1347444847 1921290884 2054919058 1345332818 1749764959 2631987954 4076008178 4076008178 4076008178 4076008178 4076008178 4075945984 4076008178 4076002395 1297120585 421140762 505555248 909526599 1348493424 2055508859 1887739281 1345726811 1951091562 2816471794 4076008178 4076008178 4076008178 4076008178 4076008178 4075945984 4076008178 4076005467 1196263764 437851414 438905135 893273679 1348493938 2056491631 1871027835 1194734709 1951091820 2850616050 4076008178 4076008178 4076008178 4076008178 4076008178 4075945984 4076008178 4076007029 1044151679 672994833 371470384 909919822 1348497264 2275242585 1922211682 1211385750 1733056121 3253269234 4076008178 4076008178 4076008178 4076008178 4076008178 4075945984 4076008178 4076008113 1043752100 823991825 286863163 1044793168 1616933499 2642102112 2224263513 1328833431 1447777935 3505320690 4076008178 4076008178 4076008178 4076008178 4076008178 4075945984 4076008178 4076008158 1412843404 1243425046 168892982 1195855698 1618115461 1865827963 2459794265 1295813246 1263299752 3773756146 4076008178 4076008178 4076008178 4076008178 4076008178 4075945984 4076008178 4076008178 2369138549 2334271530 336137498 691949664 1651466823 691957893 2475843664 1164223573 1264419522 4008899314 4076008178 4076008178 4076008178 4076008178 4076008178 4075945984 4076008178 4076008178 3696503112 2959416374 806751497 286860335 774382625 1047561618 2457559120 1319337538 1450750695 4076008178 4076008178 4076008178 4076008178 4076008178 4076008178 4075945984 4076008178 4076008178 4071241766 1757036064 1044259862 286331156 371077200 2072348307 2692503888 2291553611 1586545896 4008702706 4076008178 4076008178 4076008178 4076008178 4076008178 4075945984 4076008178 4076008178 4075723311 697809726 540953928 993013813 1046051460 2071624818 1379682144 1666339156 1702271144 3269322984 4076008178 4076008178 4076008178 4076008178 4076008178 4075945984 4076008178 4076008178 4076007041 691578315 1344747080 1348034674 2458346046 774120481 489567806 1297113199 1920627315 1954719682 3723030514 4076008178 4076008178 4076008178 4076008178 4075945984 4076008178 4076008178 4076008174 2603759525 3599123771 1179607698 1680479764 337255202 808861255 1330667631 2055639967 2474400889 2629034222 4076008178 4076008178 4076008178 4076008178 4075945984 4076008178 4076008178 4076008178 4072889401 2313341330 1652187678 134812182 505554992 910048839 1348035186 1921290911 3032912721 1770036432 3908236018 4076008178 4076008178 4076008178 4075945984 4076008178 4076008178 4076008178 4076007083 1465689559 3363509251 152312350 505686318 909919823 1348497264 2072348061 2915426707 1096710044 3505255154 4076008178 4076008178 4076008178 4075945984 4076008178 4076008178 4076008178 4076008178 4007510715 2249261837 354031898 506014000 943605582 1348493946 2072351645 2914308561 1649106808 2850026226 4076008178 4076008178 4076008178 4075945984 4076008178 4076008178 4076008178 4076008178 4076006858 570625300 370547230 606349622 910053200 1617064058 2224201119 3031741650 2268944490 2193944306 4076008178 4076008178 4076008178 4075945984 4076008178 4076008178 4076008178 4076008178 4076005730 168366356 353966626 606679094 1044860240 1500476027 2240257453 3031742161 2252363359 2159274226 4076008178 4076008178 4076008178 4075945984 4076008178 4076008178 4076008178 4076008178 4075807568 101258260 370810399 690565174 1044861017 1617918596 2274533300 2947859921 1866094175 2042751218 4076008178 4076008178 4076008178 4075945984 4076008178 4076008178 4076008178 4076008178 4076004484 285611030 370810403 690959926 1196249184 1651538820 2459806893 3031884189 1027233898 2160257266 4076008178 4076008178 4076008178 4075945984 4076008178 4076008178 4076008178 4076008178 4076006087 704778522 438181412 691025214 1196445792 1869773703 2476580788 3335630151 691690847 2193813234 4076008178 4076008178 4076008178 4075945984 4076008178 4076008178 4076008178 4076008178 4076006613 2636187154 421405737 691025470 1196382816 1870300295 2459940038 3516090153 675438186 2194730738 4076008178 4076008178 4076008178 4075945984 4076008178 4076008178 4076008178 4076008178 4076006857 3517789718 337255972 792017990 1330666082 1887143313 2679420589 1631072560 708991071 2429611762 4076008178 4076008178 4076008178 4075945984 4076008178 4076008178 4076008178 4076008178 4076007382 3064766320 1025711650 691025982 1313890415 2054918814 2643556935 505298232 692281194 2429611762 4076008178 4076008178 4076008178 4075945984 4076008178 4076008178 4076008178 4076008178 4076008164 3312474541 3027982672 1330005837 1348493935 1887140463 1497905968 421412661 709582442 2430463730 4076008178 4076008178 4076008178 4075945984 4076008178 4076008178 4076008178 4076008178 4076008171 3514516859 2947387770 2071687281 1868722018 1650476848 910706486 488848950 776691308 2631790322 4076008178 4076008178 4076008178 4075945984 4076008178 4076008178 4076008178 4076008178 4076008171 3549649264 2913824327 1619432069 1883719524 1901082146 944916532 505364017 827022956 2631856882 4076008178 4076008178 4076008178 4075945984 4076008178 4076008178 4076008178 4076008178 4076008173 3383517296 2662690875 1350272635 1614560867 1901673257 944916278 505690421 827678317 2833249010 4076008178 4076008178 4076008178 4075945984 4076008178 4076008178 4076008178 4076008178 4076008176 3602145378 2477753165 1316128388 1648117348 1901673513 944918324 488914742 827744119 2850090994 4076008178 4076008178 4076008178 4075945984 4076008178 4076008178 4076008178 4076008178 4076008178 3837092185 2477626201 1315928965 1866810979 1917860649 945440819 505952304 928407160 2850616050 4076008178 4076008178 4076008178 4075945984 4076008178 4076008178 4076008178 4076008178 4076008178 3955584590 2460848729 1349617275 1866218596 2086680098 946032687 489242416 978739065 2884104946 4076008178 4076008178 4076008178 4075945984 4076008178 4076008178 4076008178 4076008178 4076008178 3955786830 2226101593 1315928964 1882995556 2103458598 946098733 455753008 1079402368 3018388210 4076008178 4076008178 4076008178 4075945984 4076008178 4076008178 4076008178 4076008178 4076008178 3955790425 2226036046 1164082043 1917270883 1918909993 810700846 489307696 1079533186 3270439666 4076008178 4076008178 4076008178 4075945984 4076008178 4076008178 4076008178 4076008178 4076008178 3989541721 2057412441 1147307654 2052078674 1918909999 810504239 489570096 1079926670 3270439666 4076008178 4076008178 4076008178 4075945984 4076008178 4076008178 4076008178 4076008178 4076008178 4057374041 1872735585 1197508219 2052080720 1935820073 810502191 489768496 1096182415 3303994098 4076008178 4076008178 4076008178 4075945984 4076008178 4076008178 4076008178 4076008178 4076008178 4075072601 1503636858 1197046660 2068855634 1918909999 911364135 489768496 1264544400 3505320690 4076008178 4076008178 4076008178 4075945984 4076008178 4076008178 4076008178 4076008178 4076008178 4075138913 1319021947 1297707654 2051948112 1935820591 810701358 506545712 1264478864 3723424498 4076008178 4076008178 4076008178 4075945984 4076008178 4076008178 4076008178 4076008178 4076008178 4075468154 1502785411 1313897094 2068724562 1935820079 894586927 490227766 1264085660 3723621106 4076008178 4076008178 4076008178 4075945984 4076008178 4076008178 4076008178 4076008178 4076008178 4075669891 1502000516 1196454534 2068723279 2087863343 810700847 557404726 1264479388 3773756146 4076008178 4076008178 4076008178 4075945984 4076008178 4076008178 4076008178 4076008178 4076008178 4075672709 1501278098 1162310022 2069443656 2088388137 810703407 490689080 1432186279 3774018290 4076008178 4076008178 4076008178 4075945984 4076008178 4076008178 4076008178 4076008178 4076008178 4076004499 1298312605 1497723526 2220967495 1685210918 811819814 507466295 1448638377 3774018290 4076008178 4076008178 4076008178 4075945984 4076008178 4076008178 4076008178 4076008178 4076008178 4076005023 1314496415 1632461447 2221033278 1685866278 794518319 490557753 1449029033 3891458802 4076008178 4076008178 4076008178 4075945984 4076008178 4076008178 4076008178 4076008178 4076008178 4076006325 1633260461 1867407483 2238661692 1668959791 810048051 507004985 1449097131 3891458802 4076008178 4076008178 4076008178 4075945984 4076008178 4076008178 4076008178 4076008178 4076008178 4076006601 1884918446 1883724411 2254587198 1669091379 692605487 574113345 1449032115 3908236018 4076008178 4076008178 4076008178 4075945984 4076008178 4076008178 4076008178 4076008178 4076008178 4076007383 2069465007 2068666746 2255505212 1618104374 793270831 574113344 1449099443 3908236018 4076008178 4076008178 4076008178 4075945984 4076008178 4076008178 4076008178 4076008178 4076008178 4076007896 2237233837 2219069564 2221950780 1534875956 810637871 574111553 1566539970 3992122098 4076008178 4076008178 4076008178 4075945984 4076008178 4076008178 4076008178 4076008178 4076008178 4076008164 2454614701 2454016122 2272937270 1383747638 911366703 574113345 1482654402 4008899314 4076008178 4076008178 4076008178 4075945984 4076008178 4076008178 4076008178 4076008178 4076008178 4076008170 2639094175 2471382652 2256227899 1518166067 456088111 675692873 1567264989 4008899314 4076008178 4076008178 4076008178 4075945984 4076008178 4076008178 4076008178 4076008178 4076008178 4076008171 2941149345 2656652658 2256228420 1384542503 68375099 945047637 1601811424 4008899314 4076008178 4076008178 4076008178 4075945984 4076008178 4076008178 4076008178 4076008178 4076008178 4076008177 3414525614 2673888866 2055493948 1350398501 17848911 1044857176 2006769134 4076008178 4076008178 4076008178 4076008178 4075945984 4076008178 4076008178 4076008178 4076008178 4076008178 4076008178 3685592735 2640397410 2072271164 1299280436 67850064 1010324857 2630150386 4076008178 4076008178 4076008178 4076008178 4075945984 4076008178 4076008178 4076008178 4076008178 4076008178 4076008178 4006911901 2473545341 2508478779 1299542341 876365372 944991643 3269388520 4008899314 4076008178 4076008178 4076008178 4075945984 4076008178 4076008178 4076008178 4076008178 4076008178 4076008178 4075670687 2474933152 2457494084 1518751822 2748021844 1769437596 3267543747 3723424498 4076008178 4076008178 4076008178 4075945984 4076008178 4076008178 4076008178 4076008178 4076008178 4076008178 4076007897 3113587591 2071621730 1617907268 2364335292 2424334967 2038595714 2849894130 4076008178 4076008178 4076008178 4075945984 4076008178 4076008178 4076008178 4076008178 4076008178 4076008178 4076008178 3991322018 2324069234 1920168821 2798512844 2556187232 1414880874 2193813234 4076008178 4076008178 4076008178 4075945984 4076008178 4076008178 4076008178 4076008178 4076008178 4076008178 4076008178 4076007405 3889089984 3234847976 4006523014 2054185074 1899454329 2631790322 4076008178 4076008178 4076008178 4075945984 4076008178 4076008178 4076008178 4076008178 4076008178 4076008178 4076008178 4076008178 4076008178 4076008173 3178402461 2272944199 809144499 3723031282 4076008178 4076008178 4076008178 4075945984 4076008178 4076008178 4076008178 4076008178 4076008178 4076008178 4076008178 4076008178 4076008178 4076008165 2069920644 1868119883 1806425576 4008899314 4076008178 4076008178 4076008178 4075945984 4076008178 4076008178 4076008178 4076008178 4076008178 4076008178 4076008178 4076008178 4076008178 4076008172 3397873521 1971300547 3891195634 4076008178 4076008178 4076008178 4076008178 4075945984 4076008178 4076008178 4076008178 4076008178 4076008178 4076008178 4076008178 4076008178 4076008178 4076008178 3990605006 3907579633 4076008178 4076008178 4076008178 4076008178 4076008178 4075945984 4076008178 4076008178 4076008178 4076008178 4076008178 4076008178 4076008178 4076008178 4076008178 4076008178 4076008178 4076008178 4076008178 4076008178 4076008178 4076008178 4076008178 4075945984)
	offset: 0@0)
	colorsFromArray: #(#( ) #(0.0 0.0 0.031) #(0.031 0.063 0.031) #(0.063 0.063 0.031) #(0.094 0.0 0.063) #(0.094 0.031 0.063) #(0.094 0.063 0.063) #(0.129 0.031 0.094) #(0.129 0.063 0.094) #(0.129 0.094 0.094) #(0.129 0.094 0.129) #(0.16 0.031 0.16) #(0.16 0.063 0.129) #(0.16 0.094 0.129) #(0.16 0.129 0.16) #(0.192 0.063 0.16) #(0.192 0.094 0.16) #(0.192 0.129 0.16) #(0.192 0.129 0.192) #(0.223 0.094 0.192) #(0.223 0.129 0.192) #(0.223 0.16 0.223) #(0.258 0.16 0.223) #(0.289 0.094 0.258) #(0.289 0.129 0.258) #(0.289 0.16 0.258) #(0.289 0.192 0.258) #(0.289 0.192 0.289) #(0.321 0.129 0.289) #(0.321 0.16 0.289) #(0.321 0.192 0.289) #(0.321 0.192 0.321) #(0.353 0.16 0.321) #(0.353 0.192 0.289) #(0.353 0.192 0.321) #(0.353 0.223 0.289) #(0.353 0.223 0.321) #(0.388 0.16 0.353) #(0.388 0.192 0.353) #(0.388 0.192 0.388) #(0.388 0.223 0.321) #(0.388 0.223 0.353) #(0.388 0.258 0.353) #(0.388 0.289 0.353) #(0.419 0.192 0.353) #(0.419 0.192 0.388) #(0.419 0.223 0.353) #(0.419 0.223 0.388) #(0.419 0.258 0.388) #(0.419 0.289 0.388) #(0.419 0.321 0.388) #(0.451 0.223 0.388) #(0.451 0.223 0.419) #(0.451 0.258 0.388) #(0.451 0.258 0.419) #(0.451 0.289 0.388) #(0.451 0.289 0.419) #(0.451 0.321 0.419) #(0.451 0.353 0.419) #(0.482 0.223 0.419) #(0.482 0.258 0.451) #(0.482 0.289 0.419) #(0.482 0.289 0.451) #(0.482 0.321 0.451) #(0.482 0.353 0.419) #(0.482 0.353 0.451) #(0.482 0.388 0.419) #(0.482 0.419 0.451) #(0.517 0.258 0.451) #(0.517 0.258 0.482) #(0.517 0.289 0.451) #(0.517 0.289 0.482) #(0.517 0.321 0.482) #(0.517 0.353 0.451) #(0.517 0.388 0.482) #(0.517 0.451 0.451) #(0.517 0.482 0.451) #(0.548 0.289 0.482) #(0.548 0.289 0.517) #(0.548 0.321 0.482) #(0.548 0.321 0.517) #(0.548 0.353 0.482) #(0.548 0.353 0.517) #(0.548 0.388 0.482) #(0.548 0.388 0.517) #(0.548 0.451 0.482) #(0.548 0.482 0.482) #(0.548 0.482 0.548) #(0.548 0.517 0.517) #(0.58 0.321 0.548) #(0.58 0.353 0.548) #(0.58 0.388 0.548) #(0.58 0.451 0.548) #(0.58 0.517 0.482) #(0.58 0.517 0.517) #(0.58 0.548 0.517) #(0.611 0.321 0.548) #(0.611 0.321 0.58) #(0.611 0.353 0.58) #(0.611 0.388 0.548) #(0.611 0.388 0.58) #(0.611 0.419 0.548) #(0.611 0.451 0.548) #(0.611 0.482 0.548) #(0.611 0.482 0.58) #(0.611 0.517 0.548) #(0.611 0.548 0.548) #(0.611 0.548 0.58) #(0.611 0.58 0.548) #(0.611 0.58 0.58) #(0.646 0.321 0.611) #(0.646 0.353 0.58) #(0.646 0.353 0.611) #(0.646 0.388 0.58) #(0.646 0.388 0.611) #(0.646 0.419 0.58) #(0.646 0.482 0.58) #(0.646 0.482 0.611) #(0.646 0.517 0.611) #(0.646 0.58 0.58) #(0.646 0.611 0.58) #(0.646 0.611 0.611) #(0.678 0.353 0.611) #(0.678 0.388 0.646) #(0.678 0.419 0.611) #(0.678 0.482 0.646) #(0.678 0.517 0.611) #(0.678 0.548 0.646) #(0.678 0.611 0.611) #(0.678 0.611 0.678) #(0.678 0.646 0.646) #(0.71 0.353 0.646) #(0.71 0.388 0.646) #(0.71 0.388 0.678) #(0.71 0.419 0.646) #(0.71 0.419 0.678) #(0.71 0.451 0.678) #(0.71 0.482 0.646) #(0.71 0.482 0.678) #(0.71 0.517 0.678) #(0.71 0.548 0.678) #(0.71 0.611 0.678) #(0.71 0.646 0.646) #(0.71 0.678 0.646) #(0.71 0.678 0.678) #(0.741 0.388 0.678) #(0.741 0.419 0.678) #(0.741 0.419 0.71) #(0.741 0.482 0.678) #(0.741 0.482 0.71) #(0.741 0.517 0.678) #(0.741 0.548 0.71) #(0.741 0.58 0.678) #(0.741 0.611 0.71) #(0.741 0.646 0.71) #(0.741 0.678 0.71) #(0.741 0.71 0.71) #(0.776 0.419 0.71) #(0.776 0.451 0.71) #(0.776 0.451 0.741) #(0.776 0.482 0.71) #(0.776 0.482 0.741) #(0.776 0.517 0.741) #(0.776 0.548 0.741) #(0.776 0.58 0.71) #(0.776 0.58 0.741) #(0.776 0.646 0.741) #(0.776 0.71 0.71) #(0.776 0.71 0.741) #(0.776 0.741 0.741) #(0.776 0.741 0.776) #(0.776 0.776 0.776) #(0.807 0.419 0.741) #(0.807 0.451 0.741) #(0.807 0.482 0.741) #(0.807 0.517 0.776) #(0.807 0.611 0.776) #(0.807 0.678 0.776) #(0.807 0.741 0.776) #(0.807 0.776 0.776) #(0.839 0.451 0.776) #(0.839 0.482 0.776) #(0.839 0.482 0.807) #(0.839 0.517 0.807) #(0.839 0.548 0.807) #(0.839 0.58 0.776) #(0.839 0.611 0.776) #(0.839 0.611 0.807) #(0.839 0.646 0.776) #(0.839 0.678 0.807) #(0.839 0.71 0.807) #(0.839 0.741 0.807) #(0.839 0.741 0.839) #(0.839 0.776 0.807) #(0.839 0.807 0.807) #(0.839 0.807 0.839) #(0.839 0.839 0.839) #(0.87 0.482 0.807) #(0.87 0.482 0.839) #(0.87 0.517 0.839) #(0.87 0.548 0.839) #(0.87 0.58 0.839) #(0.87 0.611 0.807) #(0.87 0.611 0.839) #(0.87 0.678 0.839) #(0.87 0.741 0.839) #(0.87 0.776 0.87) #(0.87 0.807 0.839) #(0.87 0.839 0.839) #(0.905 0.482 0.839) #(0.905 0.482 0.87) #(0.905 0.58 0.839) #(0.905 0.611 0.839) #(0.905 0.611 0.87) #(0.905 0.646 0.87) #(0.905 0.678 0.87) #(0.905 0.71 0.87) #(0.905 0.741 0.87) #(0.905 0.741 0.905) #(0.905 0.776 0.905) #(0.905 0.839 0.905) #(0.905 0.87 0.87) #(0.905 0.87 0.905) #(0.905 0.905 0.87) #(0.905 0.905 0.905) #(0.936 0.517 0.87) #(0.936 0.678 0.87) #(0.936 0.678 0.905) #(0.936 0.71 0.905) #(0.936 0.776 0.905) #(0.936 0.807 0.905) #(0.936 0.905 0.905) #(0.936 0.936 0.936) #(0.968 0.71 0.936) #(0.968 0.807 0.936) #(0.968 0.839 0.936) #(0.968 0.87 0.968) #(0.968 0.905 0.968) #(0.968 0.968 0.968) #(1.0 0.936 0.968) #(1.0 0.936 1.0) #(1.0 0.968 1.0) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( ) #( )  ))! !

!CTrashCan methodsFor: 'initialization' stamp: 'ar 6/19/2005 12:12'!
initialize
	"Initialize the receiver"
	super initialize.
	trashManager := self project trashManager.! !

!CTrashCan methodsFor: 'events' stamp: 'sw 4/30/2005 22:00'!
onDragEnter: aDraggee
	"An object just got dragged over a trash can.  Temporarily gobble up (visually) what the hand is carrying"

	<on: dragEnter>
	self hand dragContents ifNotNilDo:
		[:p |
			p visible: false.
			self showOpenTrashCanImage]! !

!CTrashCan methodsFor: 'events' stamp: 'sw 4/30/2005 22:00'!
onDragLeave: event
	"When the mouse leaves, make the hand's contents once agin visible, and change my graphic back to the closed one."

	<on: dragLeave>
	event hand dragContents ifNotNilDo:
		[:p | p visible: true.
			self showClosedTrashCanImage]! !

!CTrashCan methodsFor: 'events' stamp: 'ar 5/28/2005 19:36'!
onDrop: aPlayer
	"Upon drop over me, snatch the quarry."

	<on: dragDrop>
	trashManager addToTrash: aPlayer.
	aPlayer close.
	aPlayer signal: #dropAccept with: self.
	self showClosedTrashCanImage.

	Preferences soundsEnabled ifTrue: [self class playDeleteSound]! !

!CTrashCan methodsFor: 'events' stamp: 'ar 6/19/2005 12:11'!
onMouseDoubleClick
	"When the user double-clicks on a trashcan, open up a window on the trash's contents.  If such a window already exists in the world, then bring attention to it."

	| aTool |
	<on: mouseDoubleClick>
	aTool := world elements detect: [:m | m isKindOf: CTrashTool] ifNone: [nil].
	aTool ifNotNil:  "Existing open tool -- bring it to prominence"
		[aTool comeToFront.
		aTool restore.
		aTool flash.
		^ self].

	aTool := CTrashTool new.
	aTool trashManager: trashManager.	
	aTool openCenteredAt: self world center.! !

!CTrashCan methodsFor: 'events' stamp: 'sw 4/29/2005 04:35'!
onMouseDrag
	"When the user tries to drag the trash can, well, let it happen."

	<on: mouseDrag>
	hand grab: self
! !

!CTrashCan methodsFor: 'initialization' stamp: 'ar 5/28/2005 19:34'!
playersForTrash
	"Answer the player(s) that should  be dropped in the trash."
	^ OrderedCollection new! !

!CTrashCan methodsFor: 'initialization' stamp: 'sw 4/27/2005 03:10'!
setupCostume
	"Set up the receiver's costume when it is lazily instantiated."

	super setupCostume.
	graphic := self class trashCanImage.
	self extent: (myCostume  propertyValueAt: #graphic) extent! !

!CTrashCan methodsFor: 'graphic' stamp: 'sw 4/30/2005 02:51'!
showClosedTrashCanImage
	"Show the closed trash-can icon image.  Assumes that the open image was showing"

	graphic := self class trashCanImage.
	extent := graphic extent.
	position := position + (15@22)! !

!CTrashCan methodsFor: 'graphic' stamp: 'sw 4/30/2005 22:01'!
showOpenTrashCanImage
	"Show the open image; adjust my position to make it look convincing"

	| openImage |
	openImage := self class trashCanOpenImage.
	graphic = openImage ifFalse: 
		[graphic := openImage.
		extent := graphic extent.
		position := position - (15@22)]! !

!CTrashCan methodsFor: 'accessing' stamp: 'ar 5/28/2005 22:30'!
trashManager
	"Answer the trashManager of the receiver"
	<bewareOf: #trashManagerChanged>
	^self propertyValueAt: #trashManager! !

!CTrashCan methodsFor: 'accessing' stamp: 'ar 5/28/2005 22:30'!
trashManager: aValue
	"Modify the receiver's trashManager"
	^self propertyValueAt: #trashManager put: aValue with: #trashManagerChanged! !

CPlayer subclass: #CTrashOccupant
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tweak-Tools-Trash'!

!CTrashOccupant commentStamp: 'sw 4/27/2005 11:56' prior: 0!
Represents an object in the trash.!

CTrashOccupant defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="trashManager" toSet="trashManager:" changeEvent="trashManagerChanged">trashManager</field>
	<field toGet="playerRepresented" toSet="playerRepresented:" changeEvent="playerRepresentedChanged">playerRepresented</field>
	<field toGet="timeStamp" toSet="timeStamp:" changeEvent="timeStampChanged">timeStamp</field>
</fields>'!

!CTrashOccupant class methodsFor: 'instance creation' stamp: 'sw 5/1/2005 04:51'!
for: aPlayer
	"Answer a new instance of the receiver to represent the given player"

	^ self new playerRepresented: aPlayer; name: aPlayer name; yourself! !

!CTrashOccupant methodsFor: 'context menu' stamp: 'ar 6/25/2005 15:11'!
getInfoAboutPlayer
	"Offer the user some limited information about the player I represent"
	self inform: self trashInfo.! !

!CTrashOccupant methodsFor: 'initialization' stamp: 'sw 5/15/2005 08:21'!
initialize
	"Initialize the receiver"

	super initialize.
	self startScript: #revivePlayer when: {self. #mouseDrag}! !

!CTrashOccupant methodsFor: 'context menu' stamp: 'sw 4/29/2005 03:25'!
onContextMenu
	"Upon yellow-button click, put up a little menu"

	| aMenu item |
	<on: yellowButtonDown>

	aMenu := CMenu new.
	aMenu label: self name.

	item := aMenu add: 'revive' target: self action: #revivePlayer.
	item balloonHelp: 'Bring the item represented back to life.'.

	item := aMenu add: 'remove from trash (destructive!!)' target: self action: #removePlayerFromTrash.
	item balloonHelp: 'Remove the item from the trash.  If you choose this, the object will be irretrievably lost'.

	item := aMenu add: 'get info' target: self action: #getInfoAboutPlayer.
	item balloonHelp: 'Tell me what you know about this object'.

	aMenu openAt: hand position
! !

!CTrashOccupant methodsFor: 'events' stamp: 'ar 6/25/2005 15:15'!
onPlayerRepresentedChanged
	"When the player I represent has changed, make my appearance reflect that"

	| aLabel unlabeledThumbnail labeledIconForm |
	<on: playerRepresentedChanged>
	playerRepresented ifNil: [^ self].  "too early"
	timeStamp := (playerRepresented userDataAt: #discardedAt) ifNil:['unknown'].
	aLabel := playerRepresented name truncateWithElipsisTo: 15.
	unlabeledThumbnail := CPartIcon thumbnailFormFrom: playerRepresented asForm.
	labeledIconForm := CPartIcon labeledFormFromThumbnail: unlabeledThumbnail withLabel: aLabel.

	graphic := labeledIconForm.
	self extent: graphic extent.
	self balloonHelp: self trashInfo.! !

!CTrashOccupant methodsFor: 'accessing' stamp: 'sw 4/27/2005 03:34'!
playerRepresented
	"Answer the playerRepresented of the receiver"
	<bewareOf: #playerRepresentedChanged>
	^self propertyValueAt: #playerRepresented! !

!CTrashOccupant methodsFor: 'accessing' stamp: 'sw 4/27/2005 03:34'!
playerRepresented: aValue
	"Modify the receiver's playerRepresented"
	^self propertyValueAt: #playerRepresented put: aValue with: #playerRepresentedChanged! !

!CTrashOccupant methodsFor: 'events' stamp: 'sw 5/15/2005 08:26'!
playersForTrash
	"Answer the player(s) that should  be dropped in the trash."

	^ OrderedCollection new! !

!CTrashOccupant methodsFor: 'printing' stamp: 'sw 4/30/2005 02:46'!
printOn: aStream
	"Print the receiver on a stream"

	aStream nextPutAll: 'TrashOccupant for ', playerRepresented name! !

!CTrashOccupant methodsFor: 'context menu' stamp: 'sw 11/4/2005 01:42'!
removePlayerFromTrash
	"Remove the player I represent from the trash.  The ultimate list is held on to by the ProjectBuilder."

	trashManager removeFromTrash: playerRepresented! !

!CTrashOccupant methodsFor: 'context menu' stamp: 'ar 5/28/2005 19:32'!
revivePlayer
	"Bring the player I represent back to life, handing her to the user"

	trashManager removeFromTrash: playerRepresented.
	playerRepresented visible: true; openInHand.  "slight flaw here if the drop gets rejected..."! !

!CTrashOccupant methodsFor: 'accessing' stamp: 'sw 5/1/2005 05:43'!
timeStamp
	"Answer the timeStamp of the receiver"
	<bewareOf: #timeStampChanged>
	^self propertyValueAt: #timeStamp! !

!CTrashOccupant methodsFor: 'accessing' stamp: 'sw 5/1/2005 05:43'!
timeStamp: aValue
	"Modify the receiver's timeStamp"
	^self propertyValueAt: #timeStamp put: aValue with: #timeStampChanged! !

!CTrashOccupant methodsFor: 'context menu' stamp: 'ar 6/25/2005 15:14'!
trashInfo
	"Answer information about the player"
	^String streamContents:
		[:aStream | aStream nextPutAll: 'Object name: ', playerRepresented name.
			aStream cr; nextPutAll: 'Class: ', playerRepresented class name.
			aStream cr; nextPutAll: 'Dimensions: ', playerRepresented extent printString.
			aStream cr; nextPutAll: 'Discarded at: ', timeStamp asString].
! !

!CTrashOccupant methodsFor: 'accessing' stamp: 'ar 5/28/2005 22:08'!
trashManager
	"Answer the trashManager of the receiver"
	<bewareOf: #trashManagerChanged>
	^self propertyValueAt: #trashManager! !

!CTrashOccupant methodsFor: 'accessing' stamp: 'ar 5/28/2005 22:08'!
trashManager: aValue
	"Modify the receiver's trashManager"
	^self propertyValueAt: #trashManager put: aValue with: #trashManagerChanged! !

!String methodsFor: '*Tweak-Tools-TextChunk' stamp: 'tk 1/6/2005 14:36'!
char: index
	"Return the a string with the single character at that location.  Return the empty string if anything is out of range"

	^ self char: index to: index! !

!String methodsFor: '*Tweak-Tools-TextChunk' stamp: 'tk 1/7/2005 00:48'!
char: start to: end
	"Return the characters in the interval.  Return the empty string if anything is out of range"

	| int |
	int := self charInterval: start to: end.
	int last = 0 ifTrue: [^ self class new: 0].	"empty string"
	^ self copyFrom: int first to: int last

"
'abcd' char: 1 to: 2   'ab'
'abcd' char: -34 to: 200  'abcd'
'abcd' char: 2 to: 1   ''
'abcd' char: 45 to: 46  ''
'abcd' char: -11 to: -2   ''
'abcd' char: 2 to: 2   'b'
'abcd' char: -2 to: -2   ''
'' char: 1 to: 1   ''
"! !

!String methodsFor: '*Tweak-Tools-TextChunk' stamp: 'tk 1/7/2005 00:46'!
charInterval: start to: end
	"Return a legal index interval.  Return (0 to: 0) if anything is out of range"

	| si ei |
	(si := start max: 1) <= self size ifFalse: [^ 0 to: 0].
	(ei := end min: self size) >= si ifFalse: [^ 0 to: 0].
	^ si to: ei

"
'abcd' charInterval: 1 to: 2  (1 to: 2)
'abcd' charInterval: -34 to: 200   (1 to: 4)
'abcd' charInterval: 2 to: 1   (0 to: 0)
'abcd' charInterval: 45 to: 46   (0 to: 0)
'abcd' charInterval: -11 to: -2   (0 to: 0)
'abcd' charInterval: 2 to: 2   (2 to: 2)
'abcd' charInterval: -2 to: -2   (0 to: 0)
'' charInterval: 1 to: 1   (0 to: 0)
"! !

!String methodsFor: '*Tweak-Tools-TextChunk' stamp: 'tk 1/7/2005 13:02'!
chunk: start to: end separatedBy: sepChars ignoreMultiSeps: ignore
	"Return the characters in the groups delimited by any of the sepChars.  Return the empty string if anything is out of range.  ignoreMultiSeps means that multiple separators in a row count as one separator.  If false, multiple separators have chunks of size zero between them.  
('1,,,4' chunk: 4 to: 4 separatedBy: ', ' ignoreMultiSeps: false)  gives '4'
('1         2' chunk: 2 to: 2 separatedBy: ', ' ignoreMultiSeps: true)  gives '2'
Set to false to find tab-delimited fields.
"

	| int |
	int := self chunkInterval: start to: end separatedBy: sepChars ignoreMultiSeps: ignore.
	int last = 0 ifTrue: [^ self class new: 0].	"empty string"
	^ self copyFrom: int first to: int last


"
'abcd' chunk: 1 to: 2 separatedBy: ', ' ignoreMultiSeps: true  'abcd'
'abcd' chunk: -34 to: 200 separatedBy: ', ' ignoreMultiSeps: true  'abcd'
'abcd' chunk: 2 to: 1 separatedBy: ', ' ignoreMultiSeps: true   ''
'abcd' chunk: 45 to: 46 separatedBy: ', ' ignoreMultiSeps: true    ''
'abcd 234 sad' chunk: -11 to: -2 separatedBy: ', ' ignoreMultiSeps: true   ''
'abcd,234 sad wer' chunk: 2 to: 2 separatedBy: ', ' ignoreMultiSeps: true   '234'
'abcd' chunk: -2 to: -2 separatedBy: ', ' ignoreMultiSeps: true    ''
'' chunk: 1 to: 1 separatedBy: ', ' ignoreMultiSeps: true   ''
'part1,part2 part3 part4' chunk: 1 to: 1 separatedBy: ', ' ignoreMultiSeps: true   'part1'
'part1,part2 part3 part4' chunk: 2 to: 3 separatedBy: ', ' ignoreMultiSeps: true   'part2 part3'
'part1,    part2  part3  part4 ' chunk: 4 to: 4 separatedBy: ', ' ignoreMultiSeps: true  'part4'
'part1,,,part4 ' chunk: 4 to: 4 separatedBy: ', ' ignoreMultiSeps: false   'part4'
"! !

!String methodsFor: '*Tweak-Tools-TextChunk' stamp: 'tk 1/7/2005 12:59'!
chunkInterval: start to: end separatedBy: sepChars ignoreMultiSeps: ignore
	"Return the indexes of the groups delimited by any of the sepChars.  Return the (0 to: 0) if anything is out of range.  ignoreMultiSeps means that multiple separators in a row count as one separator.  If false, multiple separators have chunks of size zero between them.  
('1,,,4' chunk: 4 to: 4 separatedBy: ', ' ignoreMultiSeps: false)  gives '4'
('1         2' chunk: 2 to: 2 separatedBy: ', ' ignoreMultiSeps: true)  gives '2'
Set to false to find tab-delimited fields.
"

	| si ei lsi lei cSet old |
	lsi := start max: 1.
	(lei := end) >= lsi ifFalse: [^ 0 to: 0].
	cSet := CharacterSet newFrom: sepChars.
	si := 1.
	1 to: lsi-1 do: [:ii | 
		old := si.
		si := self indexOfAnyOf: cSet startingAt: si.
		si = 0 ifTrue: [^ 0 to: 0].
		(old = si and: [ignore]) ifTrue: [ii := ii-1].	
		si := si + 1].
	ei := si.
	lsi to: lei do: [:ii | 
		old := ei.
		ei := self indexOfAnyOf: cSet startingAt: ei.
		ei = 0 ifTrue: [^ si to: self size].
		(old = ei and: [ignore]) ifTrue: [
			ii := ii-1.
			si = ei ifTrue: [si := si + 1]].	"skip extras at start of chunk"
		ei := ei + 1].
	^ si to: ei-2	"when no final cr, already covered"

"
'abcd' chunkInterval: 1 to: 2 separatedBy: ', ' ignoreMultiSeps: true (1 to: 4) 'abcd'
'abcd' chunkInterval: -34 to: 200 separatedBy: ', ' ignoreMultiSeps: true  (1 to: 4) 'abcd'
'abcd' chunkInterval: 2 to: 1 separatedBy: ', ' ignoreMultiSeps: true  (0 to: 0)
'abcd' chunkInterval: 45 to: 46 separatedBy: ', ' ignoreMultiSeps: true    (0 to: 0)
'abcd 234 sad' chunkInterval: -11 to: -2 separatedBy: ', ' ignoreMultiSeps: true   (0 to: 0)
'abcd,234 sad wer' chunkInterval: 2 to: 2 separatedBy: ', ' ignoreMultiSeps: true (6 to: 8)   '234'
'abcd' chunkInterval: -2 to: -2 separatedBy: ', ' ignoreMultiSeps: true   (0 to: 0)
'' chunkInterval: 1 to: 1 separatedBy: ', ' ignoreMultiSeps: true   (1 to: 0)
'part1,part2 part3 part4' chunkInterval: 1 to: 1 separatedBy: ', ' ignoreMultiSeps: true   (1 to: 5) 'part1'
'part1,part2 part3 part4' chunkInterval: 2 to: 3 separatedBy: ', ' ignoreMultiSeps: true  (7 to: 17)  'part2 part3'
'part1,    part2  part3  part4 ' chunkInterval: 4 to: 4 separatedBy: ', ' ignoreMultiSeps: true   (25 to: 29) 'part4'
'part1,,,part4 ' chunkInterval: 4 to: 4 separatedBy: ', ' ignoreMultiSeps: false (9 to: 13) 'part4'
"! !

!String methodsFor: '*Tweak-Tools-TextChunk' stamp: 'tk 1/7/2005 00:39'!
item: start
	"Return the Nth group separated by commas.  Multiples commas are treated as having empty items between them.  Empty items do count."

	^ self chunk: start to: start 
			separatedBy: ',' 
			ignoreMultiSeps: false! !

!String methodsFor: '*Tweak-Tools-TextChunk' stamp: 'tk 1/7/2005 00:38'!
item: start separatedBy: sepChars
	"Return the Nth group separated by the chars specified.  Multiples are treated as having empty items between them.  Empty items do count."

	^ self chunk: start to: start 
			separatedBy: sepChars 
			ignoreMultiSeps: false! !

!String methodsFor: '*Tweak-Tools-TextChunk' stamp: 'tk 1/7/2005 00:40'!
item: start to: end
	"Return the range of groups separated by commas.  Multiples commas are treated as having empty items between them.  Empty items do count.  Note that a single item can cross a line boundary and can contain a carriage return."

	^ self chunk: start to: end 
			separatedBy: ',' 
			ignoreMultiSeps: false! !

!String methodsFor: '*Tweak-Tools-TextChunk' stamp: 'tk 1/7/2005 00:37'!
item: start to: end separatedBy: sepChars
	"Return the range of groups separated by the chars specified.  Multiples are treated as having empty items between them.  Empty items do count."

	^ self chunk: start to: end 
			separatedBy: sepChars 
			ignoreMultiSeps: false! !

!String methodsFor: '*Tweak-Tools-TextChunk' stamp: 'tk 1/6/2005 15:18'!
line: index
	"Return the a string with the single text line at location index.  Return the empty string if anything is out of range"

	^ self line: index to: index! !

!String methodsFor: '*Tweak-Tools-TextChunk' stamp: 'tk 1/7/2005 12:52'!
line: start to: end
	"Return the characters on the text lines mentioned.  Return the empty string if anything is out of range"

	| int |
	int := self lineInterval: start to: end.
	int last = 0 ifTrue: [^ self class new: 0].	"empty string"
	^ self copyFrom: int first to: int last

"
'abcd' line: 1 to: 2 'abcd'
'abcd' line: -34 to: 200  'abcd'
'abcd' line: 2 to: 1  ''
'abcd' line: 45 to: 46  ''
'abcd
234 sad' line: -11 to: -2  ''
'abcd
234 sad
wer' line: 2 to: 2  '234 sad'
'abcd' line: -2 to: -2  ''
'' line: 1 to: 1  ''
'line1
line2
line3
line4' line: 1 to: 1  'line1'
'line1
line2
line3
line4' line: 2 to: 3 'line2
line3'
'line1
line2
line3
line4' line: 4 to: 4 'line4'
"! !

!String methodsFor: '*Tweak-Tools-TextChunk' stamp: 'tk 1/7/2005 12:51'!
lineInterval: start to: end
	"Return the indexes of the start and end of the text lines mentioned.  Return (0 to: 0) if anything is out of range."

	| si ei cr lsi lei |
	cr := Character cr.	"carriage return separates lines"
	lsi := start max: 1.
	(lei := end) >= lsi ifFalse: [^ (0 to: 0)].
	si := 1.
	1 to: lsi-1 do: [:ii | 
		si := self indexOf: cr startingAt: si.
		si = 0 ifTrue: [^ (0 to: 0)].
		si := si + 1].
	ei := si.
	lsi to: lei do: [:ii | 
		ei := self indexOf: cr startingAt: ei.
		ei = 0 ifTrue: [^ (si min: self size) to: self size].
		ei := ei + 1].
	^ si to: ei-2	"when no final cr, already covered"

"
'abcd' lineInterval: 1 to: 2     (1 to: 4)
'abcd' lineInterval: -34 to: 200   (1 to: 4)
'abcd' lineInterval: 2 to: 1    (0 to: 0)
'abcd' lineInterval: 45 to: 46   (0 to: 0)
'abcd
234 sad' lineInterval: -11 to: -2    (0 to: 0)
'abcd
234 sad
wer' lineInterval: 2 to: 2   (6 to: 12)
'abcd' lineInterval: -2 to: -2   (0 to: 0)
'' lineInterval: 1 to: 1    (0 to: 0)
'line1
line2
line3
line4' lineInterval: 1 to: 1   (1 to: 5)
'line1
line2
line3
line4' lineInterval: 2 to: 3  (7 to: 17)
'line1
line2
line3
line4' lineInterval: 4 to: 4  (19 to: 23)
"! !

!String methodsFor: '*Tweak-Tools-TextChunk' stamp: 'tk 1/7/2005 00:32'!
word: index
	"Return the Nth word.  Space, tab, and return separate words.  Multiples are treated as one divider."

	^ self word: index to: index! !

!String methodsFor: '*Tweak-Tools-TextChunk' stamp: 'tk 1/7/2005 00:37'!
word: start to: end
	"Return the range of words.  Space, tab, and return separate words.  Multiples are treated as one divider."

	^ self chunk: start to: end 
			separatedBy: (Character separators) 
			ignoreMultiSeps: true! !

CButton subclass: #CPartIcon
	instanceVariableNames: ''
	classVariableNames: 'MaximumWidth MinimumHeight'
	poolDictionaries: ''
	category: 'Tweak-Tools-PartsBin'!

!CPartIcon commentStamp: 'sw 2/1/2005 02:17' prior: 0!
A labeled icon standing in a parts-bin.!

CPartIcon defineFields: '<?xml  version="1.0" ?>
<fields>
	<field toGet="partDescription" toSet="partDescription:" changeEvent="partDescriptionChanged">partDescription</field>
</fields>'!

!CPartIcon class methodsFor: 'class initialization' stamp: 'sw 1/26/2005 05:22'!
initialize
	"Initialize the receiver -- set the standard icon metrics for parts bins"

	MaximumWidth := 90.
	MinimumHeight := 24

"CPartIcon initialize"! !

!CPartIcon class methodsFor: 'services' stamp: 'ar 6/25/2005 20:21'!
labeledCompositeFromThumbnail: thumbnailForm withLabel: aString
	"Given a thumnbnail form, answer another form which consists of the original form together with a label beneath it, against a mild background"

	| labeledItem  thumb aLabel aFont strW |
	labeledItem := CPlayer new.
	labeledItem layout: CTableLayout new.
	labeledItem layout listDirection: #topToBottom; hResizing: #shrinkWrap; vResizing: #shrinkWrap.
	labeledItem borderWidth: 2.
	thumb := CPlayer new.
	thumb graphic: thumbnailForm copy.
	thumb extent: thumbnailForm extent.
	labeledItem add: thumb.
	aLabel := CLabel new.
	aLabel font: (aFont := StrikeFont familyName: 'Atlanta' size: 11).
	aLabel value: aString.
	aLabel color: Color white.
	aLabel hResizing: #shrinkWrap.
	strW := aFont widthOfString: aString.
	labeledItem add: aLabel.
	labeledItem width: (thumbnailForm extent x max: strW) + 6.
	labeledItem fullBounds.
	^ labeledItem


"
(CPartIcon labeledCompositeFromThumbnail: Form fromUser withLabel: 'short') openInHand
"! !

!CPartIcon class methodsFor: 'services' stamp: 'sw 6/12/2005 18:57'!
labeledFormFromThumbnail: thumbnailForm withLabel: aString
	"Given a thumnbnail form, answer another form which consists of the original form together with a label beneath it,  against a mild background"

	^ (self labeledCompositeFromThumbnail: thumbnailForm withLabel: aString) asForm


"
(CPartIcon labeledFormFromThumbnail: Form fromUser withLabel: 'Testing 1 2 3') extent
"! !

!CPartIcon class methodsFor: 'services' stamp: 'sw 2/8/2005 04:36'!
thumbnailFormFrom: aForm
	"Answer a thumbnail form derived from the input form, making it obey the class's standard MinimumHeight & MaximumWidth guidelines"

	|  scaleX scaleY margin opaque aMinimum |
	aMinimum := aForm height min: MinimumHeight.  "Don't ever magnify -- it's ugly"
	scaleY := aMinimum / aForm height.  "keep height invariant"
	scaleX := ((aForm width * scaleY) <= MaximumWidth)
		ifTrue: [scaleY]  "the usual case; same scale factor, to preserve aspect ratio"
		ifFalse: [scaleY := MaximumWidth / aForm width].

	margin := 1.0 / (scaleX@scaleY) // 2 max: 0@0.  "Extra margin around border"
	opaque := (Form extent: aForm extent + margin depth: aForm depth) "fillWhite".
	aForm displayOn: opaque at: aForm offset negated rule: Form paint.  "Opaque form shrinks better"
	^ (opaque magnify: opaque boundingBox by: (scaleX @ scaleY) smoothing: 2)! !

!CPartIcon methodsFor: 'miscellaneous' stamp: 'ar 6/25/2005 20:21'!
accommodatePartDescription 
	"Fit properly around the graphic obtained from my partDescription"

	| aForm |
	aForm := partDescription labeledIconForm copy.
	self image: aForm.
	self extent: aForm extent.
	self borderWidth: 0.
	self color: Color gray muchLighter! !

!CPartIcon methodsFor: 'menu' stamp: 'sw 6/20/2005 03:26'!
changePartCategory
	"Allow the user to change the part category"

	| anIndex names newName |
	self partsSource ifNotNilDo: [:s | ^ self changePartSourceCategory].

	"What follows is the old CPartsBin code eventually to be removed..."
	anIndex := UIManager default chooseFrom: (names := CPartsBin allPopulatableCategoryNames) title: (partDescription label, ' (current category: ', partDescription categories first, ')').
	anIndex = 0 ifTrue: [^ self].
	partDescription categories: (Array with: (newName := names at: anIndex)).
	CPartsBin registerPartDescription: partDescription.
	CPartsBin signal: #needToShowCategory with: newName! !

!CPartIcon methodsFor: 'menu' stamp: 'sw 6/16/2005 15:36'!
changePartSourceCategory
	"Allow the user to change the category"

	| anIndex names newName aBin |
	(aBin := self containerThatIsA:  CPartsSource) ifNil: [^ self].
	anIndex := UIManager default chooseFrom: (names := aBin allPopulatableCategoryNames) title: (partDescription label, ' (current category: ', partDescription categories first, ')').
	anIndex = 0 ifTrue: [^ self].
	partDescription categories: (Array with: (newName := names at: anIndex)).
	aBin registerPartDescription: partDescription.
	aBin showCategory: newName! !

!CPartIcon methodsFor: 'accessing' stamp: 'sw 6/16/2005 15:02'!
containerThatIsA: aClass
	"Answer an object above me in the containment hierarchy that is a member of, or inherits from, the given class; answer nil if none found.  This could reasonably be a method of CPlayer, but it's stashed off here in CPartIcon for the moment on a need-to-know basis..."

	| anObject |
	anObject := container.
	[anObject notNil] whileTrue:
		[(anObject isKindOf: aClass) ifTrue: [^ anObject].
		anObject := anObject container].

	^ nil! !

!CPartIcon methodsFor: 'menu' stamp: 'sw 2/8/2005 05:26'!
editBalloonHelp
	"Allow the user to see and edit the balloon help.  This should really use multiLineRequest: but that's not implemented yet. For now, since cr forces an accept, the poor-man's version is that the user can use a \ to show where he wants crs. "

	| reply help |
	reply := self request: 'Edit the help message here: ' initialAnswer: partDescription balloonHelp.
	reply isEmptyOrNil ifFalse:
		[help := reply withCRs.
		partDescription balloonHelp: help.
		balloonHelp := help]
	! !

!CPartIcon methodsFor: 'launch' stamp: 'sw 2/6/2005 03:37'!
launchPart
	"Launch a precorsor of the part I represent, placing it in the user's hand"

	partDescription newPartPrecursor openInHand
! !

!CPartIcon methodsFor: 'menu' stamp: 'sw 2/8/2005 05:23'!
onContextMenu
	"Put up a menu of options when the user yellow-clicks on the receiver"

	| aMenu item |
	<on: yellowButtonDown>

	aMenu := CMenu new.
	aMenu label: partDescription label.
	item := aMenu add: 'destroy' target: self action: #removeFromPartCategory.
	item balloonHelp: 'Deletes this item -- WARNING -- DESTRUCTIVE!!'.

	item := aMenu add: 'rename...' target: self action: #renamePart.
	item balloonHelp: 'change the name by which this item is known in the parts bin'.

	item := aMenu add: 'move to category...' target: self action: #changePartCategory.
	item balloonHelp: 'Allows you to move this item to a different category'.

	item := aMenu add: 'edit balloon help' target: self action: #editBalloonHelp.
	item balloonHelp: 'Change the balloon-help-message for this item'.

	aMenu openAt: hand position.! !

!CPartIcon methodsFor: 'events' stamp: 'ar 2/8/2005 19:25'!
onPartDescriptionChanged
	<on: partDescriptionChanged>
	self balloonHelp := partDescription balloonHelp.
! !

!CPartIcon methodsFor: 'accessing' stamp: 'sw 1/19/2005 02:58'!
partDescription
	"Answer the partDescription of the receiver"
	<bewareOf: #partDescriptionChanged>
	^self propertyValueAt: #partDescription! !

!CPartIcon methodsFor: 'accessing' stamp: 'ar 2/8/2005 19:24'!
partDescription: aPartDescription
	"Modify the receiver's partDescription"
	^ self propertyValueAt: #partDescription put: aPartDescription with: #partDescriptionChanged! !

!CPartIcon methodsFor: 'menu' stamp: 'sw 6/12/2005 21:53'!
partsSource
	"Answer the containing CPartsSource, or nil if none"

	^ self containerThatIsA: CPartsSource! !

!CPartIcon methodsFor: 'menu' stamp: 'sw 6/20/2005 03:26'!
removeFromPartCategory
	"Remove the part that the receiver represents from its category"

	self partsSource ifNotNilDo: [:s | ^ s removePart: partDescription label].

	"The following needs to be excised when CPartsBin is excised"
	CPartsBin removePart: partDescription label! !

!CPartIcon methodsFor: 'menu' stamp: 'sw 6/20/2005 03:26'!
renamePart
	"Allow the user to rename the part"

	| newName |
	self partsSource ifNotNilDo: [:s | ^ self renamePartInPartsSource].

	"The remainder here is legacy code that will be removed when CPartsBin is removed"
	newName := self request: 'New name for ', partDescription label initialAnswer: partDescription label.
	newName isEmptyOrNil ifTrue: [^ self].
	(CPartsBin partDescriptionNamed: newName) ifNotNil:
		[^ self inform: 'Sorry, that name is already taken'].
	CPartsBin removePart: partDescription label.
	partDescription label: newName.
	partDescription rebuildGraphicFrom: nil.
	CPartsBin registerPartDescription: partDescription! !

!CPartIcon methodsFor: 'menu' stamp: 'sw 6/16/2005 15:35'!
renamePartInPartsSource
	"Allow the user to rename the part"

	| newName aSource |
	newName := self request: 'New name for ', partDescription label initialAnswer: partDescription label.
	newName isEmptyOrNil ifTrue: [^ self].
	((aSource := self partsSource) partDescriptionNamed: newName) ifNotNil:
		[^ self inform: 'Sorry, that name is already taken'].
	aSource removePart: partDescription label.
	partDescription label: newName.
	partDescription rebuildGraphicFrom: nil.
	aSource registerPartDescription: partDescription! !

!Text methodsFor: '*Tweak-Tools-TextChunk' stamp: 'tk 1/7/2005 13:26'!
char: index
	"Return the a string with the single character at that location.  Return the empty string if anything is out of range"

	^ self char: index to: index! !

!Text methodsFor: '*Tweak-Tools-TextChunk' stamp: 'tk 1/7/2005 13:26'!
char: start to: end
	"Return the characters in the interval.  Return the empty string if anything is out of range"

	| int |
	int := string charInterval: start to: end.
	int last = 0 ifTrue: [^ self class new: 0].	"empty string"
	^ self copyFrom: int first to: int last
! !

!Text methodsFor: '*Tweak-Tools-TextChunk' stamp: 'tk 1/7/2005 13:21'!
chunk: start to: end separatedBy: sepChars ignoreMultiSeps: ignore
	"Return the characters in the groups delimited by any of the sepChars.  Return the empty string if anything is out of range.  ignoreMultiSeps means that multiple separators in a row count as one separator.  If false, multiple separators have chunks of size zero between them.  
('1,,,4' chunk: 4 to: 4 separatedBy: ', ' ignoreMultiSeps: false)  gives '4'
('1         2' chunk: 2 to: 2 separatedBy: ', ' ignoreMultiSeps: true)  gives '2'
Set to false to find tab-delimited fields.
"

	| int |
	int := string chunkInterval: start to: end separatedBy: sepChars ignoreMultiSeps: ignore.
	int last = 0 ifTrue: [^ self class new: 0].	"empty"
	^ self copyFrom: int first to: int last
! !

!Text methodsFor: '*Tweak-Tools-TextChunk' stamp: 'tk 1/7/2005 13:22'!
item: start
	"Return the Nth group separated by commas.  Multiples commas are treated as having empty items between them.  Empty items do count."

	^ self chunk: start to: start 
			separatedBy: ',' 
			ignoreMultiSeps: false! !

!Text methodsFor: '*Tweak-Tools-TextChunk' stamp: 'tk 1/7/2005 13:22'!
item: start separatedBy: sepChars
	"Return the Nth group separated by the chars specified.  Multiples are treated as having empty items between them.  Empty items do count."

	^ self chunk: start to: start 
			separatedBy: sepChars 
			ignoreMultiSeps: false! !

!Text methodsFor: '*Tweak-Tools-TextChunk' stamp: 'tk 1/7/2005 13:22'!
item: start to: end
	"Return the range of groups separated by commas.  Multiples commas are treated as having empty items between them.  Empty items do count.  Note that a single item can cross a line boundary and can contain a carriage return."

	^ self chunk: start to: end 
			separatedBy: ',' 
			ignoreMultiSeps: false! !

!Text methodsFor: '*Tweak-Tools-TextChunk' stamp: 'tk 1/7/2005 13:22'!
item: start to: end separatedBy: sepChars
	"Return the range of groups separated by the chars specified.  Multiples are treated as having empty items between them.  Empty items do count."

	^ self chunk: start to: end 
			separatedBy: sepChars 
			ignoreMultiSeps: false! !

!Text methodsFor: '*Tweak-Tools-TextChunk' stamp: 'tk 1/7/2005 13:19'!
line: index
	"Return the a string with the single text line at location index.  Return the empty string if anything is out of range"

	^ self line: index to: index! !

!Text methodsFor: '*Tweak-Tools-TextChunk' stamp: 'tk 1/7/2005 13:18'!
line: start to: end
	"Return the characters on the text lines mentioned.  Return the empty text if anything is out of range"

	| int |
	int := string lineInterval: start to: end.	"compute the interval using the raw string"
	int last = 0 ifTrue: [^ self class new: 0].	"empty"
	^ self copyFrom: int first to: int last
! !

!Text methodsFor: '*Tweak-Tools-TextChunk' stamp: 'tk 1/7/2005 13:25'!
word: index
	"Return the Nth word.  Space, tab, and return separate words.  Multiples are treated as one divider."

	^ self word: index to: index! !

!Text methodsFor: '*Tweak-Tools-TextChunk' stamp: 'tk 1/7/2005 13:25'!
word: start to: end
	"Return the range of words.  Space, tab, and return separate words.  Multiples are treated as one divider."

	^ self chunk: start to: end 
			separatedBy: (Character separators) 
			ignoreMultiSeps: true! !
CColorTool initialize!
CPartsBin initialize!
CPreferencesTool initialize!
CSimpleTextEditor initialize!
CTrashTool initialize!
CTextTool initialize!
CPartIcon initialize!
